/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "common/stringmanip.h"
#include "common/nrsimp.h"

const double Pi = 3.14159265;
void pfunc(double *pvals, double *outvals);
void vfunc(double *rpar, double *y);
void tvfunc(double *_x, double *_tempvs, double *_v, double *rpar);

int main(int argc, char *argv[])
{
  int l;
  if(argc<3){
    fprintf(stderr, "ERROR in src/augmentdatfile.c. You need to supply a data file name followed by the new file name.\n");
    return -1;
  }

  l=augmentdatfile(argv[1], argv[2], "sysfiles/settable.dat", "sysfiles/vararray.dat", "sysfiles/params.dat", pfunc, tvfunc);

  return l;
}

