#include "common/stringmanip.h"


int checkinput(char infile[], char settable[])
{

  int len, i, j, flag, nump;
  FILE *fd, *fd1;
  char line[1000];
  int block_pos;
  char block[10000];
  char *oneline=NULL;
  int lim_line = 1000;
  int maxv = 20;
  char *vars[20];
  char varname[100];
  int warnflag=0;

  fd = fopen(infile, "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in routine \"checkinput\". File: %s could not be opened...\n", infile);
    return -2;
  }

  len = getblock(fd, block, "******", 10000);
  block_pos=0;
  nump = 0; // default
  while(block_pos<len){
    getlinefromblock(&block_pos, block, line, lim_line);
    j=0;
    if(!iscomsep(line) && strstr(line, "chosen_param:")){
      oneline = getrst("chosen_param:", line);
      if(strcmp(oneline, "") == 0){
	fprintf(stderr, "WARNING in routine \"checkinput\". chosen_params not given.\n");
	nump = 0;
	break;
      }
      else{
	nump = chemgets(oneline, vars, maxv);
	break;
      }
      free(oneline);
    }
  }

  for(i=0;i<nump;i++){
    fd1 = fopen(settable, "r");
    if(fd1 == NULL){
      fprintf(stderr, "ERROR in routine \"checkinput\". File: %s could not be opened...\n", settable);
      return -4;
    }

    j=0;
    flag=0;
    while(flag==0 && (len = getline(fd1, line, 1000)) > 0){
      if(!(iscomsep(line))){
	getnthword(line, varname, 100, 1);
	if(strcmp(varname, vars[i])==0){
	  flag=1;
	}
      }
    }
    if(flag==0){
      fprintf(stderr, "WARNING in checkinput.c: %s in %s is not a settable parameter.\n", vars[i], infile);
      if(strcmp(vars[i], "SaO2sup")==0 || strcmp(vars[i], "PaO2")==0)
	fprintf(stderr, "\tChange the function defining O2_a in otherparams.dt\n");
      warnflag=1;

    }
    fclose(fd1);
  }

  fclose(fd);

  if(warnflag==1)
    return 1;
  else
    return 0;
}

int main(int argc, char *argv[])
{
  if(argc<2){
    fprintf(stderr, "ERROR in checkinput.c: need to enter a file name.\n");
    return -2;
  }
  return checkinput(argv[1], "sysfiles/settable.dat");
}
