/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//
// a program to find out which processes a particular variable occurs in...
//

#include "syssize.h"
#include "common/stringmanip.h"

int checkvar(struct algrel allalgrels[], int numalgrels, char *var);

int main()
{
  int i;
  struct algrel allalgrels[MAXALG];
  int numalgrels;
  struct DEterm allDEterms[MAXDETERM];
  int numDEterms;
  char **vararray;
  int numvars=0;

  vararray = genarraydat("sysfiles/vararray.dat", &numvars);

  // generate the array of algrels
  numalgrels = readalgfile(allalgrels, MAXALG, "sysfiles/allalgrels1.dat", "sysfiles/vararray.dat", "sysfiles/allparams.dat", "userfiles/remsfile.dat");

  // read in the DEterms

  numDEterms = readDEtermfile(allDEterms, MAXDETERM, "sysfiles/allDEterms.dat");
  for (i=0;i<numvars;i++)
    checkvar(allalgrels, numalgrels, allDEterms, numDEterms, vararray[i]);

  free_DEtermarray(allDEterms, numDEterms);
  freearraydat(vararray, numvars);
  free_algarray(allalgrels, numalgrels);

  return 0;
}


int checkvar(struct algrel allalgrels[], int numalgrels, struct DEterm DEtermarray[], int numDEterms, char *var)
{
  int i;
  printf("%s:\n", var);
  for(i=0;i<numDEterms;i++){
    if(isinstring(allDEterms[i].rterm, var) == 1)
      printf("\t%s\n", allDEterms[i].name);
  }
  for(i=0;i<numalgrels;i++){
    if(isinstring(allalgrels[i].rterm, var) == 1)
      printf("\t%s\n", allalgrels[i].name);
  }
  return 0;
}
