/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

char **charar(long nl, long nh); /* my one! */

struct paramstr{
  char *pname;
  double pvalue;
};

struct paramfcn{
  char *pname;
  double (*pfunction)();
};

/* the structure which holds a reaction */

struct react{
  char *reactname;
  char *reacttype;
  int comps; // compartments
  int stoics; // stoichiometries same as values?
  int numleft;
  char **varsleft;
  char **valsleft;
  char **compsleft;
  char **stoicsleft;
  int numright;
  char **varsright;
  char **valsright;
  char **compsright;
  char **stoicsright;
  int twoway;
  char **rates;
  char *rateterm;
};

/* the structure to hold a whole DE (with possibly non-trivial LHS) */

struct DE{
  char *name;
  int numleft;
  char **varsleft;
  char *keyvar;
  char **valsleft;
  int numright;
  char **varsright;
  int numparams;
  char **params;
  char *rterm;
};

/* the structure of a single term in a DE */

struct DEterm{
  char *name;
  char *keyvar;
  char *rterm;
};

/* an algebraic relation - same as DEterm, but used differently */

struct algrel{
  char *name;
  char *keyvar;
  int numvars;
  int numparams;
  char **vars;
  char **params;
  char *rterm;
};

