/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{
  char dirname[50] = "models/modeldescs/";
  char datafile[60];
  char modulefilename[100];
  char editcall[10] = "emacs ";

  char systemcom[200];


  if(argc < 2){
    fprintf(stderr, "ERROR in editsys.c: you must enter the name of the system you wish to edit.\n");
    return -1;
  }
  if(strlen(argv[1]) > 30){
    fprintf(stderr, "ERROR in editsys.c: system name %s too long.\n", argv[1]);
    return -1;
  }

  // the modeldescs file

  strcat(dirname, argv[1]); strcat(dirname, "/"); // safe
  strcpy(datafile, dirname);  strcat(datafile, "alldata.dat &"); // safe

  sprintf(systemcom, "%s%s &", editcall, datafile); // safe

  fprintf(stderr, "%s\n", systemcom);
  system(systemcom);

// the info file
  sprintf(modulefilename, "%s%sinfo", dirname, argv[1]); // safe
  sprintf(systemcom, "%s%s &", editcall, modulefilename); // safe

  fprintf(stderr, "%s\n", systemcom);
  system(systemcom);

  // the module file

  sprintf(modulefilename, "models/modules/%s/%s.dt", argv[1], argv[1]); // safe
  sprintf(systemcom, "%s%s &", editcall, modulefilename); // safe

  fprintf(stderr, "%s\n", systemcom);
  system(systemcom);

  // the default input file
  sprintf(modulefilename, "models/inputs/%s/%s_default.dat", argv[1], argv[1]); // safe
  sprintf(systemcom, "%s%s &", editcall, modulefilename); // safe

  fprintf(stderr, "%s\n", systemcom);
  system(systemcom);


// the parameter value file

  sprintf(modulefilename, "models/pvals/%s/%s_pvals.dat", argv[1], argv[1]); // safe
  sprintf(systemcom, "%s%s &", editcall, modulefilename); // safe

  fprintf(stderr, "%s\n", systemcom);
  system(systemcom);


  return 0;
}
