/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "common/stringmanip.h"

#define MAXrterm 2500

int main()
{
  int j, k, len;
  FILE *fd, *fd1;
  int lim=500;
  char oneline[500];
  char varname[40];

  char **vararray;
  int numvars=0;
  char **paramarray;
  int numparams=0;

  char **chemnames;
  int numchems=0;


  fd = fopen("sysfiles/temp/constraints.dat", "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in \"genconstraints.c\": \"sysfiles/temp/constraints.dat\" could not be opened.\n");
    return -1;
  }
  fd1 = fopen("sysfiles/constraints.dat", "w");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in \"genconstraints.c\": \"sysfiles/constraints.dat\" could not be opened.\n");
    return -1;
  }

  fprintf(fd1, "// This file contains the constraints relevant to the particular system in question.\n//It is generated automatically by the file \"genconstraints.c\"\n\n");

  chemnames = genarraydat("sysfiles/chemnames.dat", &numchems);
  vararray = genarraydat("sysfiles/vararray.dat", &numvars);
  paramarray = genarraydat("sysfiles/paramarray.dat", &numparams);


  // the universal conditions for chemical quantities

  for(j=0;j<numchems;j++)
    fprintf(fd1, "%s: %s < 0.0: %s = 0.0\n", chemnames[j], chemnames[j], chemnames[j]);

  while((len = getline(fd, oneline, lim)) > 0){
    j=0;
    while((isspace((int) oneline[j])) || (oneline[j] == 13)){j++;}
    if ((oneline[j] == '/') || (oneline[j] == '*') || (oneline[j] == '\0')){} // comment/empty lines
    else{
      k=0;
      while((k < 40) && (oneline[j] != ':') && (oneline[j] != '\n') && (oneline[j] != 13))
	varname[k++] = oneline[j++];
      varname[k] = '\0'; 
      if(isinarray(vararray, numvars, varname) >=0)
	fprintf(fd1, "%s", oneline);
    }
  }

  freearraydat(chemnames, numchems);
  freearraydat(vararray, numvars);
  freearraydat(paramarray, numparams);

  fclose(fd);
  fclose(fd1);
  return 0;
}
