/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// collects together the existing DEterms + those generated from reactions + those generated from transport processes

#include "common/stringmanip.h"

int getblock(FILE *fp, char s[], char end[], int lim); // in common/stringmanip.c

int main()
{
  int i, len1;
  char *nameline;
  int lim_block = 10000;
  char block[10000];
  FILE *fd1, *fd2;
  char *transfile = "sysfiles/transportterms.dat";
  char *chemfile = "sysfiles/chemterms.dat";
  char *filename2 = "sysfiles/allDEterms.dat";
  char determfile[100];
  char *pstr;
  char **DEtermnames;
  int numDEterms;
  int DEtermcounter;
  int flag=0;

  strcpy(determfile, "sysfiles/sysstate/DEterms.dat"); // safe

  DEtermnames = genarraydat(determfile, &numDEterms);

  i=0; // number of DEterms
  fd2 = fopen(filename2, "w");
  if(fd2 == NULL){
    fprintf(stderr, "ERROR in gendatDEterms.c: %s could not be opened...\n", filename2);
    return -1;
  }

  DEtermcounter=0;

  for(i=0;i<numDEterms;i++){ 
    pstr=getproc("sysfiles/DEterms/allterms.dat", DEtermnames[i]);
    if(pstr[0]==0){
      fprintf(stderr, "ERROR in \"gendatDEterms.c\": DEterm %s could not be found.\n", DEtermnames[i]);
      flag =1;
    }
    else{
      DEtermcounter++;
      fprintf(fd2, "%s", pstr);
    }
    free(pstr);
  }
  freearraydat(DEtermnames, numDEterms);

  if(flag==1){
    fprintf(stderr, "ERROR in gendatDEterms.c: some DEterms could not be found...\n");
    fclose(fd2);
    return -1;
  }

  //
  // now the other two files - chemterms and transport terms
  // These are imported wholesale
  //

  fd1 = fopen(chemfile, "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in gendatDEterms.c: %s could not be opened...\n", chemfile);
    return -1;
  }

  while((len1 = getcleanblock(fd1, block, "******", lim_block)) > 0){
    nameline=getname("name:", block);
    if(strcmp(nameline, "") != 0){
      fprintf(fd2, "%s", block);
      i++;
    }
    free(nameline);
  }
  fclose(fd1);

  fd1 = fopen(transfile, "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in gendatDEterms.c: %s could not be opened...\n", transfile);
    return -1;
  }

  while((len1 = getcleanblock(fd1, block, "******", lim_block)) > 0){
    nameline=getname("name:", block);
    if(strcmp(nameline, "") != 0){
      fprintf(fd2, "%s", block);
      i++;
    }
    free(nameline);
  }
  fclose(fd1);

  //  fprintf(stderr, "Total number of DE terms = %d\n", i);

  fclose(fd2);
  return 0;
}
