/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// This file generates a data-file containing all the model algebraic relations

#include "common/stringmanip.h"

int main()
{
  int i;
  char nameline[100];
  char keyvarline[100];
  char *keyvar;
  FILE *fd;
  char *filename2 = "sysfiles/allalgrels.dat";
  char algrelfile[100];
  int numalgrels=0;
  char **algnames;
  int algrelcounter;
  char *pstr;

  int numfixedvars=0;
  char **fixedvars;

  strcpy(algrelfile, "sysfiles/sysstate/algrels.dat"); //safe

  algnames = genarraydat(algrelfile, &numalgrels);
  fixedvars = genarraydat("sysfiles/fixedvars.dat", &numfixedvars);

  fd = fopen(filename2, "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in \"gendatalgs.c\": %s could not be opened.\n", filename2);
    return -1;
  }

  algrelcounter=0;
  for(i=0;i<numalgrels;i++){ // for each algrel
    pstr=getproc("sysfiles/algrels/allalgrels.dat", algnames[i]);
    if(pstr[0]==0){
      fprintf(stderr, "ERROR in \"gendatalgs.c\": algebraic relation %s could not be found.\n", algnames[i]);
    }
    else{
      algrelcounter++;
      if(isinarray(fixedvars, numfixedvars, keyvarline)>=0){
	keyvar=getname("keyvar:", pstr);
	fprintf(fd, "name: %s\nkeyvar: %s\neqn: %sn - %s\n******\n", nameline, keyvar, keyvar, keyvar);
	free(keyvar);
      }
      else
	fprintf(fd, "%s", pstr);
    }
    free(pstr);
  }
  fclose(fd); 


  freearraydat(fixedvars, numfixedvars);
  freearraydat(algnames, numalgrels);

  if (algrelcounter < numalgrels)
    return -1;

  return 0;
}
