/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "common/stringmanip.h"

int main()
{
  FILE *fd, *fd1, *fd2, *fd3, *fd4, *fd5, *fd6, *fd7, *fd71, *fd8, *fd9, *fd10, *fd11, *fd12, *fd13;
  int len;
  int lim_line = 5000;
  char line[5000];
  int lim_block = 100000;
  char block[100000];
  int errcode;


  system("cp userfiles/othero2funcsr.cc sysfiles/temp/o2funcsr1.cc"); // still necessary
  system("cp userfiles/otherinitfuncsr.cc sysfiles/temp/initfuncsr1.cc"); // still necessary


  fd = fopen("sysfiles/allmodules.dat", "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/allmodules.dat could not be opened...\n");
    return -1;
  }

  fd1 = fopen("tempfiles/allreacs.dat", "w");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allreacs.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd1, "// Generated by gendatfiles.c. Do not edit directly.\n\n******\n");

  fd2 = fopen("tempfiles/allalgrels.dat", "w");
  if(fd2 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allalgrels.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd2, "// Generated by gendatfiles.c. Do not edit directly.\n\n******\n");

  fd3 = fopen("tempfiles/allparams.dat", "w");
  if(fd3 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allparams.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd3, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd4 = fopen("sysfiles/temp/o2funcsr1.cc", "a");
  if(fd4 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/o2funcsr1.cc could not be opened...\n");
    return -1;
  }
  fprintf(fd4, "//////////\n\n");

  fd5 = fopen("tempfiles/allDEs.dat", "w");
  if(fd5 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allDEs.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd5, "// Generated by gendatfiles.c. Do not edit directly.\n\n******\n");

  fd6 = fopen("tempfiles/allterms.dat", "w");
  if(fd6 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allterms.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd6, "// Generated by gendatfiles.c. Do not edit directly.\n\n******\n");

  fd7 = fopen("tempfiles/allvarbles.dat", "w");
  if(fd7 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: tempfiles/allvarbles.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd7, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd71 = fopen("sysfiles/tempvars.dat", "w");
  if(fd71 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/tempvars.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd71, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd8 = fopen("sysfiles/temp/initfuncsr1.cc", "a");
  if(fd8 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/initfuncsr1.cc could not be opened...\n");
    return -1;
  }
  fprintf(fd8, "//////////\n\n");

  fd9 = fopen("sysfiles/temp/params.desc", "w");
  if(fd9 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/params.desc could not be opened...\n");
    return -1;
  }
  fprintf(fd9, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd10 = fopen("sysfiles/temp/vars.desc", "w");
  if(fd10 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/vars.desc could not be opened...\n");
    return -1;
  }
  fprintf(fd10, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd11 = fopen("sysfiles/temp/constraints.dat", "w");
  if(fd11 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/constraints.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd11, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd12 = fopen("sysfiles/temp/allprocs.desc", "w");
  if(fd12 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/temp/allprocs.desc could not be opened for writing...\n");
    return -1;
  }
  fprintf(fd12, "// Generated by gendatfiles.c. Do not edit directly.\n\n");

  fd13 = fopen("sysfiles/alltemplates.dat", "w");
  if(fd13 == NULL){
    fprintf(stderr, "ERROR in gendatfiles.c: sysfiles/alltemplates.dat could not be opened...\n");
    return -1;
  }
  fprintf(fd13, "// Generated by gendatfiles.c. Do not edit directly.\n\n******\n");



  while((len = getline(fd, line, lim_line)) > 0){
    if(iscom(line))
      continue;
    if(strstr(line, "REACTIONS") != NULL){
      errcode = getblockmin(fd, block, "endREACTIONS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd1, "%s", block);
    }
    else if(strstr(line, "ALGRELS") != NULL){
      errcode = getblockmin(fd, block, "endALGRELS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd2, "%s", block);
    }
    else if(strstr(line, "TEMPLATES") != NULL){
      errcode = getblockmin(fd, block, "endTEMPLATES", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd13, "%s", block);
    }
    else if(strstr(line, "PARAMS") != NULL){
      errcode = getblockmin(fd, block, "endPARAMS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd3, "%s", block);
    }
    else if(strstr(line, "PARAMFUNCS") != NULL){
      errcode = getblockmin(fd, block, "endPARAMFUNCS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd4, "%s", block);
    }
    else if(strstr(line, "DIFFEQS") != NULL){
      errcode = getblockmin(fd, block, "endDIFFEQS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd5, "%s", block);
    }
    else if(strstr(line, "DETERMS") != NULL){
      errcode = getblockmin(fd, block, "endDETERMS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd6, "%s", block);
    }
    else if(strstr(line, "VARS") != NULL){
      errcode = getblockmin(fd, block, "endVARS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd7, "%s", block);
    }
    else if(strstr(line, "TEMPVS") != NULL){
      errcode = getblockmin(fd, block, "endTEMPVS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd71, "%s", block);
    }
    else if(strstr(line, "INITFUNCS") != NULL){
      errcode = getblockmin(fd, block, "endINITFUNCS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd8, "%s", block);
    }
    else if(strstr(line, "PDESC") != NULL){
      errcode = getblockmin(fd, block, "endPDESC", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd9, "%s", block);
    }
    else if(strstr(line, "VDESC") != NULL){
      errcode = getblockmin(fd, block, "endVDESC", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd10, "%s", block);
    }
    else if(strstr(line, "CONSTRAINTS") != NULL){
      errcode = getblockmin(fd, block, "endCONSTRAINTS", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd11, "%s", block);
    }
    else if(strstr(line, "PROCDESC") != NULL){
      errcode = getblockmin(fd, block, "endPROCDESC", "endMODULE", lim_block);
      if(errcode == -1){
	fprintf(stderr, "ERROR in gendatfiles.c: there is an error in \"sysfiles/allmodules.dat\".\n");
	return -1;
      }
      else
	fprintf(fd12, "%s", block);
    }
  }

  fclose(fd);
  fclose(fd1);
  fclose(fd2);
  fclose(fd3);
  fclose(fd4);
  fclose(fd5);
  fclose(fd6);
  fclose(fd7);
  fclose(fd71);
  fclose(fd8);
  fclose(fd9);
  fclose(fd10);
  fclose(fd11);
  fclose(fd12);
  fclose(fd13);


  // Now clean and check for repetition within each file. 
  if((errcode=simplinefile("tempfiles/allparams.dat", "sysfiles/allparams.dat"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 parameter was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d parameters were multiply identically defined\n", errcode);
  }
  if((errcode=simplinefile("tempfiles/allvarbles.dat", "sysfiles/allvarbles.dat"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 variable was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d variables were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("sysfiles/temp/initfuncsr1.cc", "sysfiles/temp/initfuncsr.cc", "//////"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 initialisation function was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d initialisation functions were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("sysfiles/temp/o2funcsr1.cc", "sysfiles/temp/o2funcsr.cc", "//////"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 parameter function was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d parameter functions were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("tempfiles/allreacs.dat", "sysfiles/reactions/allreacs.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 reaction was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d reactions were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("tempfiles/allalgrels.dat", "sysfiles/algrels/allalgrels.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 algebraic relation was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d algebraic relations were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("tempfiles/allterms.dat", "sysfiles/DEterms/allterms.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 DEterm was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d DEterms were multiply identically defined\n", errcode);

  }

  if((errcode=simpblockfile("tempfiles/allDEs.dat", "sysfiles/DEs/allDEs.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "WARNING: 1 differential equation was multiply identically defined\n");
    else
      fprintf(stderr, "WARNING: %d differential equations were multiply identically defined\n", errcode);

  }

  if((errcode=checkprocsfile("sysfiles/DEs/allDEs.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 differential equation was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d differential equations were multiply *differently* defined\n", errcode);

  }

  if((errcode=checkfuncsfile("sysfiles/temp/initfuncsr.cc", "//////"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 initialisation function was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d initialisation functions were multiply *differently* defined\n", errcode);

  }

  if((errcode=checkfuncsfile("sysfiles/temp/o2funcsr.cc", "//////"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 parameter function was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d parameter functions were multiply *differently* defined\n", errcode);

  }

  if((errcode=checkprocsfile("sysfiles/reactions/allreacs.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 reaction was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d reactions were multiply *differently* defined\n", errcode);

  }

  if((errcode=checkprocsfile("sysfiles/algrels/allalgrels.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 algebraic relation was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d algebraic relations were multiply *differently* defined\n", errcode);

  }

  if((errcode=checkprocsfile("sysfiles/DEterms/allterms.dat", "******"))!=0){
    if(errcode==1)
      fprintf(stderr, "FATAL WARNING: 1 DEterm was multiply *differently* defined\n");
    else
      fprintf(stderr, "FATAL WARNING: %d DEterms were multiply *differently* defined\n", errcode);

  }

  return 0;

}
