/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// This file generates the relations to be held in a C structure

#include "common/stringmanip.h"

int main()
{
  int i, len, reaccounter;
  int numreacs=0;
  char **reacnames;
  FILE *fd, *fd1;
  char *pstr;
  char line[1000];

  char reacfile[100];
  strcpy(reacfile, "sysfiles/sysstate/reacs.dat"); // safe

  reacnames = genarraydat(reacfile, &numreacs);

  //
  // print the cleaned data file
  //

  fd = fopen("sysfiles/allreacs.dat", "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in gendatreacs.c: \"sysfiles/allreacs.dat\" could not be opened for writing...\n");
    return -1;
  }

  reaccounter = 0;

  for(i=0;i<numreacs;i++){ // for each reaction

    pstr=getproc("sysfiles/reactions/allreacs.dat", reacnames[i]);
    if(pstr[0]==0){
      fprintf(stderr, "ERROR in \"gendatreacs.c\": reaction %s could not be found.\n", reacnames[i]);
    }
    else{
      reaccounter++;
      fprintf(fd, "%s", pstr);
    }
    free(pstr);

  }

  if (reaccounter < numreacs)
    fprintf(stderr, "WARNING in \"gendatreacs.c\": some reactions could not be found...\n");

  freearraydat(reacnames, numreacs);

  // now the reactions generated from templates.
 
  fd1 = fopen("sysfiles/templatereacs.dat", "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in gentransportterms.c: File \"sysfiles/templatereacs.dat\" could not be opened...\n");
    return -1;
  }

  while((len = getline(fd1, line, 1000)) > 0)
    fprintf(fd, "%s", line);

  fclose(fd1);
  fclose(fd);

  return 0;
}
