/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// generates a continuous input file from a discrete function

#include "common/stringmanip.h"
const double Pi = 3.14159265;
void funcprint(char fname[], char plist[], double tint, double tsamp, double (*func)(double));
void funcprint2(char fname[], char plist[], double tint, double tsamp, double (*func)(double), double (*func2)(double));
double trialfunc(double t);
double trialfunc1(double t);
double trialfunc2(double t);
int main()
{
  //  funcprint("models/inputs/trialfunc.dat", "P_a", 200, 0.1, trialfunc1);
  funcprint2("models/inputs/trialfunc.dat", "P_a, P_cv", 200, 0.1, trialfunc1, trialfunc2);
  return 0;
}

void funcprint(char fname[], char plist[], double tint, double tsamp, double (*func)(double)){
  FILE *fd;
  int i,k;
  k=(int)(tint/tsamp);
  fd = fopen(fname, "w");
  fprintf(fd, "// generated by getinputfile.c\n\n");
  fprintf(fd, "chosen_param: %s\n", plist);
  fprintf(fd, "time_step: %.4f\n******\n", tsamp);
  for(i=0;i<k;i++){
    fprintf(fd, "%.4e\n", (*func)(i*tsamp));
  }
  fprintf(fd, "\n");

}
void funcprint2(char fname[], char plist[], double tint, double tsamp, double (*func)(double), double (*func2)(double)){
  FILE *fd;
  int i,k;
  k=(int)(tint/tsamp);
  fd = fopen(fname, "w");
  fprintf(fd, "// generated by getinputfile.c\n\n");
  fprintf(fd, "chosen_param: %s\n", plist);
  fprintf(fd, "time_step: %.4f\n******\n", tsamp);
  for(i=0;i<k;i++){
    fprintf(fd, "%.4e, %.4e\n", (*func)(i*tsamp), (*func2)(i*tsamp));
  }
  fprintf(fd, "\n");

}

double trialfunc(double t){
  return 100.0 + 40.0*sin(2.0*Pi*t/1.0);
}

double trialfunc1(double t){
  return 100.0 + 9.5*sin(2.0*Pi*t/6.0) + 20.0*sin(2.0*Pi*t/1.0);
}

double trialfunc2(double t){
  return 6.0 + 2.0*sin(2.0*Pi*(t-0.25)/6.0);
  //  return 6.0;

}


