/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

/* A program to help generate the web of relations */

#include "common/stringmanip.h"
const double Pi = 3.14159265; 


int main()
{
  int i, j;
  FILE *fd;
  char *file;
  char **paramarray;
  int numparams = 0;
  char *pdeplist[1000];
  int numdeps=0;



  file = "paramweb.gdl"; /* the default output file */

  fd = fopen(file, "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in genparamweb.cc: File %s could not be opened for writing...\n", file);
    return -1;
  }

  paramarray = genarraydat("sysfiles/params.dat", &numparams);

  /* get all the information. */
  fprintf(stderr, "going through the parameters... \n\n");
  fprintf(fd, "// the parameter web - generated by genparamweb.cc //\n\n");
  fprintf(fd, "graph: { title: \"paramgraph\"\nscaling: maxspect\ncolor: 15\nedge.color: 8\nedge.thickness: 2\n\n");

  for(i=0;i<numparams;i++){
    fprintf(fd, "\nnode: { color: 7 textcolor: 0 title:\"%s\" label:\"%s\" }\n", paramarray[i], paramarray[i]);
    numdeps = getalldepson(paramarray[i], paramarray, numparams, "sysfiles/alldeps.dat", pdeplist, 1000);
    for(j=0;j<numdeps;j++){
      fprintf(fd, "edge: { sourcename: \"%s\" targetname: \"%s\" color: 1 }\n", pdeplist[j], paramarray[i]);
    }
    free_datarray(pdeplist, numdeps);
  }

  fprintf(fd, "}\n\n");
  fclose(fd);
  freearraydat(paramarray, numparams);
  return 0;

}



