/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// Reads the parameter and variable datafiles. Gets the number of variables and parameters, and writes the files "sysfiles/allvarbles.c" and "sysfiles/allparams.c" which contain the number of variables/parameters, and character arrays with these variables

#include "common/stringmanip.h"
char **charar(long nl, long nh); /* my one! */

int main()
{
  int i, j, k, numparams, len;
  int lim=1000;
  FILE *fd, *fd1;
  char *filename1 = "sysfiles/params.dat";
  char *filename2 = "sysfiles/allsysparams.c";
  char **paramnames;
  char pname[100];
  char oneline[1000]; // for comments too


  //
  // parse 1: read params.dat. Get number of parameters
  //

  i=0;
  fd = fopen(filename1, "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in getallsysparams.c: File %s could not be opened...\n", filename1);
    return -1;
  }
  while((len = getline(fd, oneline, lim)) > 0){
    if(!(iscomsep(oneline))){
      i++;
  }
  fclose(fd);

  paramnames = charar(0, i);

  //
  // parse two - get into an array of paramnames
  //

  i=0;
  fd = fopen(filename1, "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in getallsysparams.c: File %s could not be opened...\n", filename1);
    return -1;
  }
  while((len = getline(fd, oneline, lim)) > 0){
    if(!(iscomsep(oneline))){
      getnthword(oneline, pname, 40, 1);
      paramnames[i] = strdup(pname);
      i++;
    }
  }
  fclose(fd);
  numparams = i;
  printf("numsysparams = %d\n", numparams);

  // now write
  fd1 = fopen(filename2, "w");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in getallsysparams.c: File %s could not be opened...\n", filename2);
    return -1;
  }
  fprintf(fd1, "/* This file is generated by getallsysparams.c. It reads the parameter data file and outputs a list of all parameters in a character array.*/\n\n");
  fprintf(fd1, "int numsysparams = %d;\n\n", numparams);
  if(numparams==0)
    fprintf(fd1, "char *allsysparamarray[0];\n");
  else{
    fprintf(fd1, "char *allsysparamarray[%d] = {", numparams);
    for(i=0;i<numparams - 1;i++){
      if (i%3 == 0)
        fprintf(fd1, "\"%s\",\n", paramnames[i]);
      else
        fprintf(fd1, "\"%s\", ", paramnames[i]);
    }
    fprintf(fd1, "\"%s\"};\n\n", paramnames[i]);
  }
  fclose(fd1);

  while (--numparams >= 0)
    free (paramnames[numparams]); /* free elements of array */

  return 0;
}
