/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// get the module files needed by the model (if any)

#include "common/stringmanip.h"

int main(int argc, char *argv[])
{
  FILE *fd;
  int len;
  int l;
  char line[500];
  char *oneword;
  char *fullname;
  char filename[100];
  char systemcom[200];

  if(argc < 2){
    fprintf(stderr, "ERROR in getmodfiles.c: you need to provide the name of the directory.\n");
    return -1;
  }


  sprintf(filename, "sysfiles/sysstate/modfiles.dat"); // safe

  fd = fopen(filename, "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in getmodfiles.c: \"%s\" could not be opened...\n", filename);
    return -1;
  }

  while((len=getline(fd, line, 500)) > 0){
    if(!(iscom(line))){
      oneword = getnthblk(line, 1);
      if(strcmp(oneword, "ALL") == 0){ // must be the first word
	// don't yet know how to handle this situation...
      }
      else{
	fullname = (char*) malloc(sizeof(char) * strlen(oneword) + 20);
	sprintf(fullname, "models/modules/%s", oneword); // safe
        if (!fileexists(fullname)){
  	  fprintf(stderr, "WARNING in getmodfiles: could not find file %s\n", fullname);
        }
        else{
          snprintf(systemcom, 200, "ln -s -f ../%s --target-directory=models/modules/%s", oneword, argv[1]);
          if((l = system(systemcom)) != 0){
	    fprintf(stderr, "WARNING: failed to create link to file %s in directory %s.\n", oneword, argv[1]);
          }
        }
	free(fullname);
      }
      free(oneword);
    }
  }
  fclose(fd);

  return 0;
}
