/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//
// BasicComponent.h: A class to define a protocol for all components
//

#ifndef BASICCOMPONENT_H
#define BASICCOMPONENT_H

#include <Xm/Xm.h>

class BasicComponent {

 protected:

  char *_name;
  Widget _w;

  //Protected constructor to prevent instantiation

  BasicComponent (const char * );

 public:
  virtual ~BasicComponent();
  virtual void manage(); //Manage and unmanage the widget tree
  virtual void unmanage();
  const Widget baseWidget() { return (_w);}
};

#endif
