/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */


//
//
// viewmfileControl
//
//

class viewmfileControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;

  void viewmfile();

  static void viewmfileCallback(Widget, XtPointer client_data, XtPointer);

  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  viewmfileControl(Widget parent, Widget *infile, char *name, char display[], messagelabel **label1, XtAppContext *app);

};


//
//
// parsemfileControl
//
//

class parsemfileControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;

  void parsemfile();

  static void parsemfileCallback(Widget, XtPointer client_data, XtPointer);


  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  parsemfileControl(Widget parent, Widget *infile, char *name, char display[], messagelabel **label1, XtAppContext *app);

};



//
//
// scanmfileControl
//
//

class scanmfileControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;

  void scanmfile();

  static void scanmfileCallback(Widget, XtPointer client_data, XtPointer);

  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  scanmfileControl(Widget parent, Widget *infile, char *name, char display[], messagelabel **label1, XtAppContext *app);

};


//
//
// selectmfileControl
//
//

class selectmfileControl: public BasicComponent{

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;
  Widget *fsdialog;
  char *inputfstr;
  char *inputfilereal;
  char systemcom[100];

  void selectmfile();

  static void selectmfileCallback(Widget, XtPointer client_data, XtPointer);

  void help();
  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  selectmfileControl(Widget parent, Widget *infile, Widget *fsdlg, char *name, char display[], messagelabel **label1);

};




//
//
// viewdatfileControl
//
//

class viewdatfileControl: public BasicComponent{

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;

  void viewdatfile();

  static void viewdatfileCallback(Widget, XtPointer client_data, XtPointer);

  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  viewdatfileControl(Widget parent, Widget *infile, char *name, char display[], messagelabel **label1);

};


//
//
// selectdatfileControl
//
//

class selectdatfileControl: public BasicComponent{

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;
  Widget *fsdialog;
  char *inputfstr;
  char *inputfilereal;
  char systemcom[100];

  void selectdatfile();

  static void selectdatfileCallback(Widget, XtPointer client_data, XtPointer);

  void help();
  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  selectdatfileControl(Widget parent, Widget *infile, Widget *fsdlg, char *name, char display[], messagelabel **label1);

};

//
//
// scanmodelControl
//
//

class scanmodelControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;
  Widget *toplevel;

  void scanmodel();

  static void scanmodelCallback(Widget, XtPointer client_data, XtPointer);


  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  scanmodelControl(Widget parent, Widget *toplevel1, Widget *infile, char *name, char display[], messagelabel **label1, XtAppContext *app);

};

//
//
// cpdescfileControl
//
//

class cpdescfileControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;

  void cpdescfile();

  static void cpdescfileCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  cpdescfileControl(Widget parent, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};




//
//
// changevarControl
//
//

class changevarControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *inputfile;

  void changevar();

  static void changevarCallback(Widget, XtPointer client_data, XtPointer);

  static void changedlg_Callback(Widget widget, XtPointer client_data, XtPointer call_data);

  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  changevarControl(Widget parent, Widget *infile, char *name, char display[], messagelabel **label1, XtAppContext *app);

};


//
//
// editinfofileControl
//
//

class editinfofileControl: public BasicComponent{

  XtAppContext *app1;

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_mod;

  void editinfofile();

  static void editinfofileCallback(Widget, XtPointer client_data, XtPointer);

  void help();

  static void helpCallback(Widget, XtPointer client_data, XtPointer);

  //constructor

  editinfofileControl(Widget parent, Widget *text_modname, char *name, char display[], messagelabel **label1, XtAppContext *app);

};



//
//
// setmoddefControl
//
//

class setmoddefControl: public BasicComponent{

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_mod;
  Widget *toplevel;
  char defobj[20];

  void setmoddef();

  static void setmoddefCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog1_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg1(Widget widget, XtPointer client_data, XtPointer call_data);
  void help();

  //constructor

  setmoddefControl(Widget parent, Widget *toplevel1, Widget *text_modname, char *name, char display[], messagelabel **label1);

};



//
//
// gennewsysControl
//
//

class gennewsysControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void gennewsys();

  static void gennewsysCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void descdialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);
  void descdlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  gennewsysControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};



//
//
// cpsysControl
//
//

class cpsysControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char oldmodname[100];
  char moddesc[100];

  void cpsys();

  static void cpsysCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void descdialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dlg0_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg0(Widget widget, XtPointer client_data, XtPointer call_data);
  void descdlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  cpsysControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};



//
//
// rmsysControl
//
//

class rmsysControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void rmsys();

  static void rmsysCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  rmsysControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};



//
//
// subtomodelControl
//
//

class subtomodelControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void subtomodel();

  static void subtomodelCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  subtomodelControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};




//
//
// archivesysControl
//
//

class archivesysControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void archivesys();

  static void archivesysCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  archivesysControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};





//
//
// backupControl
//
//

class backupControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void backup();

  static void backupCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  backupControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};





//
//
// restoresysControl
//
//

class restoresysControl: public BasicComponent{


 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *text_filename;
  char *inputfstr;
  char *inputfilereal;
  Widget *toplevel;
  char modname[100];
  char moddesc[100];

  void restoresys();

  static void restoresysCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  restoresysControl(Widget parent, Widget *toplevel1, Widget *text_filename1, char *name, char display[], messagelabel **label1);

};




//
//
// The main one: editsysControl
//
//


class editsysControl: public BasicComponent{

  XtAppContext *app1;
  viewmfileControl *button_viewmfile;
  editinfofileControl *button_editinfofile;
  parsemfileControl *button_parsemfile;
  scanmfileControl *button_scanmfile;
  cpdescfileControl *button_cpdescfile;
  viewdatfileControl *button_viewdatfile;
  selectmfileControl *button_selectmfile;
  scanmodelControl *button_scanmodel;
  selectdatfileControl *button_selectdatfile;
  changevarControl *button_changevar;
  setmoddefControl *button_setmoddef;
  gennewsysControl *button_gennewsys;
  cpsysControl *button_cpsys;
  rmsysControl *button_rmsys;
  subtomodelControl *button_subtomodel;
  archivesysControl *button_archivesys;
  backupControl *button_backup;
  restoresysControl *button_restoresys;

 public:

  Widget rc1, rc1a, rc2, rc21, rc22, separator1;
  Widget rc3, rc31, rc32, rc4;
  Widget rc5, rc51, rc52, rc53;
  Widget label_module, text_module, frame_module;
  Widget label_datfile, text_datfile, frame_datfile;
  Widget label_batch, frame_batch;

  int paramsmanaged;
  Widget message_frame;
  messagelabel *messages;
  Widget *toplevel;
  Widget *text_mod;
  Widget *mfsdlg;
  Widget *datfsdlg;

  static void genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void genhelp(Widget widget, XtPointer client_data, XtPointer call_data);

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  // constructor

  editsysControl(Widget parent, Widget *toplevel1, Widget *text_modname, Widget *mfsdlg1, Widget *datfsdlg1, char *name, char display[], char *funcfile, char *descfile, int *paramschanged, XtAppContext *app);

};

