/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 
 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//
// The main program for the user interface
//

#include <sys/types.h>
#include <unistd.h>
#include <time.h> // for sleep
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
//#include <curses.h> //for refresh
#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/DrawingA.h>
#include <Xm/Text.h>
#include <Xm/Frame.h>
#include <Xm/Command.h>
#include <Xm/Separator.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/DrawnB.h>
#include <sys/stat.h>
#include <X11/cursorfont.h>
#include "BasicComponent.h"

#include "../common/stringmanip.h"

// These are the files containing my classes

#include "messagelabel.h"
#include "controls.h"


const double Pi = 3.14159265; 
#include "editsys.h"

struct paramvar{
  paramControl *p;
  varControl *v;
  editsysControl *e;
  Widget *main;
};
int viewstate=0;
int paramschanged=0;

#define YES 1 
#define NO 2

// useful to have this global in case another routine needs to access it

XtAppContext app;
Widget toplevel;

paramvar pv;


int getvarindex(char fname[], char varname[]); // not used? in stringmanip.c
Widget PostErrorDialog(Widget parent, messagelabel **label, char *msg); // in controls.cc
void DestWidget(Widget widget, XtPointer client_data, XtPointer call_data); // in controls.cc
Widget PostEDialog(Widget parent, char *msg);
// Ugly global declarations!!

Display *drawingdisplay;
Screen *screen_ptr;

void appmenu_cb(Widget widget, XtPointer client_data, XtPointer call_data);
void viewmenu_cb(Widget widget, XtPointer client_data, XtPointer call_data);
void help_menu_cb(Widget widget, XtPointer client_data, XtPointer call_data);
void query_for_help (Widget widget, XtPointer client_data, XtPointer call_data);
void quitCallback (Widget, XtPointer, XtPointer);
void paramtogCallback(Widget, XtPointer clientdata1, XtPointer);
void draw_cbk(Widget w, XtPointer data,
	       XtPointer cbk);
void exec_cmd (Widget cmd_widget, XtPointer client_data, XtPointer call_data);
void echo_file(Widget widget, XtPointer client_data, XtPointer call_data);
void echo_pfile(Widget widget, XtPointer client_data, XtPointer call_data);
void echo_mfile(Widget widget, XtPointer client_data, XtPointer call_data);
void echo_datfile(Widget widget, XtPointer client_data, XtPointer call_data);
static void CloseFileSB(Widget widget, XtPointer client_data, XtPointer call_data);
static void FileSBhelp(Widget widget, XtPointer client_data, XtPointer call_data);
static void FileSBhelp1(Widget widget, XtPointer client_data, XtPointer call_data);
static void FileSBhelp2(Widget widget, XtPointer client_data, XtPointer call_data);
static void FileSBhelp3(Widget widget, XtPointer client_data, XtPointer call_data);
void response(Widget widget, XtPointer client_data, XtPointer call_data);
int AskUser(Widget parent, char *question);
void genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data);
Widget PostHelpDialog(Widget parent, char *title, char *msg); // in controls.cc
void FullSysHelp(Widget widget, XtPointer client_data, XtPointer call_data);

static Widget fsdialog;
static Widget pfsdialog;
static Widget mfsdialog;
static Widget datfsdialog;

//
//
//
// now entering main...
//
//
//

int main(int argc, char **argv)
{
  Widget main_w, menubar, menu, menu1, main_form, form, tempwidget,
    rc1, rc2, rc3, rc31, rc61, rc62, rc6, rc7, rc71, rc72,
    rc8, rc81, rc82, rc9, rc91, rc92,
    rc4, rc41, rc42, rc421, rcend, rcend1,
    frame_message, frame_selmodel, frame_inputfile, frame_outputfile, frame_plot, frame_makerun, frame_params,
    label_input, label_inputfile, label_outputfile, label_vartoplot, label_pfilename,
    button_paramtog,
    button_quit,
    text_modeltype, text_inputfile, text_outputfile, text_pfilename,
    text_comout, command_w;

  Widget plot_text;
  Widget Helpbutton;
  Widget ibutton;

  selectoutvarControl *button_selectvar;
  selectmodelControl *button_selectmodel;
  reducefileControl *button_reducefile;
  makeControl *button_make;
  //runControl *button_run;
  makerunControl *button_makerun;
  editfileControl *button_editfile;
  cpinputfileControl *button_cpinputfile;
  cpparamfileControl *button_cpparamfile;
  editfilesimpControl *button_editfilesimp;
  editheadfileControl *button_editheadfile;
  viewpfileControl *button_viewpfile;
  searchvarControl *button_searchvar;
  selectfileControl *button_selectfile;
  selectpfileControl *button_selectpfile;
  plotToggle *autoreg_tog;
  smoothToggle *smooth_tog;
  contplotToggle *contplot_tog;
  plotControl *button_plot;
  messagelabel *label_info;
  paramControl *params;
  varControl *vars;
  editsysControl *esys;
  Arg args[20];
  int nn=0;
  XmString comstr;
  char line[100];
  char wdir[100];
  int firstuse=0; // is this the first time the GUI is being used?

  FILE *fd;

  XmString xmstr, xmstr1, xmstr2, xmstr3, xmstr4, xmstr5, xmstr6, 
    xmstr_input, xmstr_inputfile, xmstr_outputfile,
    xmstr_name, xmstr_val, xmstr_vartoplot, 
    xmstr_nofunc, xmstr_fname,
    xmstr_application,
    xmstr_view,
    xmstr_main,
    xmstr_params,
    xmstr_vars,
    xmstr_editsys,
    xmstr_help,
    xmstr_conthelp,
    xmstr_issues,
    xmstr_manage,
    xmstr_paramtog,
    xmstr_about,
    xmstr_start,
    xmstr_aboutmodel,
    filesb_titlestring;

  Pixel fg, bg;
  Dimension ht, st;
  Pixmap Helppix;
  char DATAFILE[100];
  char DEF_MODEL[100];
  char DEF_PLOT_VAR[100];
  char DEF_INPUT_FILE[100];
  char DEF_PARAM_FILE[100];
  char PARAM_CHANGES_FILE[100];

  time_t tstmp;
  char *tmp;


  // All for trial at the moment

  //  XGCValues gcv;
  //  GC gc;

  // Are we in the correct working directory

  if(getoption("userfiles/gui_options", "WORKDIR", wdir, 100)!=0){
    fprintf(stderr, "The user interface could not be started. It needs to be run from the directory specified in \"userfiles/gui_options\".\n");
    return -1;
  }

  if(wrongdir(wdir)){
    fprintf(stderr, "The user interface could not be started. It needs to be run from the directory specified in \"userfiles/gui_options\".\n");
    return -1;
  }
  // Has the GUI been used before?

  fd = fopen("src/gui/_gui_used", "r");
  if(fd==NULL)
    fprintf(stderr, "File \"src/gui/_gui_used\" could not be opened.\n");
  else{
    getline(fd, line, 100);
    fclose(fd);
  }
  if(strstr(line, "no")!=NULL){
    firstuse=1;
    fd = fopen("src/gui/_gui_used", "w");
    if(fd==NULL)
      fprintf(stderr, "File \"src/gui/_gui_used\" could not be opened for writing.\n");
    else{
      fprintf(fd, "yes\n");
      fclose(fd);
    }
  }

  // Initialise the intrinsics


  toplevel = XtAppInitialize (&app, "uclsface", NULL, 0, 
			      &argc, argv, NULL, NULL, 0 );

  XtVaSetValues(toplevel, 
		XmNallowShellResize, False,
		XmNtitle, "BRAINCIRC INTERFACE - VERSION 2.3",
		NULL);


  // create compound strings

  xmstr = XmStringCreateSimple ("Make");
  xmstr1 = XmStringCreateSimple ("Run");
  xmstr2 = XmStringCreateSimple ("Make and Run");
  xmstr3 = XmStringCreateSimple ("Quit");
  xmstr4 = XmStringCreateSimple ("");
  xmstr5 = XmStringCreateSimple ("Parameter name and value...");
  xmstr6 = XmStringCreateSimple ("Variable name and value...");
  xmstr_name = XmStringCreateSimple ("(name)");
  xmstr_val = XmStringCreateSimple ("(val)");
  xmstr_nofunc = XmStringCreateSimple ("basic plot");
  xmstr_paramtog = XmStringCreateSimple ("toggle view");
  xmstr_input = XmStringCreateSimple("model:");
  xmstr_inputfile = XmStringCreateSimple("input file:");
  xmstr_outputfile = XmStringCreateSimple("output file:");
  xmstr_vartoplot = XmStringCreateSimple("plot:");
  xmstr_fname = XmStringCreateSimple("param file:");


  // set the application title


  main_w = XtVaCreateManagedWidget ("main_w", xmMainWindowWidgetClass, toplevel, 
// 				    XmNwidth, 850,
// 				    XmNheight, 500,
// 				    XmNvisualPolicy, XmCONSTANT,
// 				    XmNscrollBarDisplayPolicy, XmAS_NEEDED,
// 				    XmNscrollingPolicy, XmAUTOMATIC,
// 				    XmNfractionBase, 100,
				    NULL);

  main_form = XtCreateManagedWidget ("main_form", xmFormWidgetClass, main_w, NULL, 0);
  XtVaSetValues (main_form,
		 XmNwidth, 850,
		 XmNheight, 500,
		 XmNfractionBase, 100,
		 NULL);


  // the menubar itself

  xmstr_application = XmStringCreateSimple("Application");
  xmstr_view = XmStringCreateSimple("View");
  xmstr_help = XmStringCreateSimple("Help");

  menubar = XmVaCreateSimpleMenuBar (main_w, "menubar", 
				     XmVaCASCADEBUTTON, xmstr_application, 'p',
				     XmVaCASCADEBUTTON, xmstr_view, 'V',
				     XmVaCASCADEBUTTON, xmstr_help, 'H',
				     NULL);

  XmStringFree(xmstr_application);
  XmStringFree(xmstr_view);
  XmStringFree(xmstr_help);

  if ((tempwidget = XtNameToWidget (menubar, "button_2")))
    XtVaSetValues (menubar, XmNmenuHelpWidget, tempwidget, NULL);

  // the main application pulldown menu (currently only a quit button)

  menu = 
    XmVaCreateSimplePulldownMenu (menubar, "app_menu", 0, appmenu_cb,
				  XmVaPUSHBUTTON, xmstr3, 'Q', NULL, NULL, 
				  NULL);

  // the view pulldown menu

  xmstr_main = XmStringCreateSimple("Main interface");
  xmstr_params = XmStringCreateSimple("Parameters");
  xmstr_vars = XmStringCreateSimple("Variables");
  xmstr_editsys = XmStringCreateSimple("Manage models");

  menu1 = 
    XmVaCreateSimplePulldownMenu (menubar, "view_menu", 1, viewmenu_cb,
				  XmVaPUSHBUTTON, xmstr_main, 'M', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_params, 'P', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_vars, 'V', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_editsys, 'E', NULL, NULL,
				  NULL);

  XmStringFree(xmstr_main);
  XmStringFree(xmstr_params);
  XmStringFree(xmstr_vars);
  XmStringFree(xmstr_editsys);


  // The help pulldown menu

  xmstr_about = XmStringCreateSimple("About the user interface");
  xmstr_aboutmodel = XmStringCreateSimple("About the model");
  xmstr_start = XmStringCreateSimple("Getting started");
  xmstr_conthelp = XmStringCreateSimple("Context sensitive help");
  xmstr_manage = XmStringCreateSimple("Model management");
  xmstr_issues = XmStringCreateSimple("Known issues");

  XmVaCreateSimplePulldownMenu (menubar, "help_menu", 2, help_menu_cb,
				  XmVaPUSHBUTTON, xmstr_aboutmodel, 'A', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_about, 'U', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_start, 'S', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_conthelp, 'C', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_manage, 'M', NULL, NULL,
				  XmVaPUSHBUTTON, xmstr_issues, 'K', NULL, NULL,
				  NULL);

  XmStringFree(xmstr_about);
  XmStringFree(xmstr_aboutmodel);
  XmStringFree(xmstr_start);
  XmStringFree(xmstr_conthelp);
  XmStringFree(xmstr_manage);
  XmStringFree(xmstr_issues);



  XtManageChild(menubar);



  /////////////////////
  //                 //
  //  The main form  //
  //                 //
  /////////////////////


  form = XtCreateWidget ("form", xmFormWidgetClass, main_form, NULL, 0);
  XtVaSetValues (form,
		 XmNwidth, 850,
		 XmNheight, 360,
		 XmNfractionBase, 100,
		 XmNleftAttachment, XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,
		 XmNtopPosition, 20,
		 XmNtopAttachment, XmATTACH_POSITION,
		 XmNbottomPosition, 90,
		 XmNbottomAttachment, XmATTACH_POSITION,
		 NULL);
  XtManageChild (form);




  ////////////////////////
  //                    //
  //  The message label //
  //                    //
  ////////////////////////




  //////////////////////////////////////////////
  //                                          //
  //  The parameter/variable management form  // (needs to be at the start)
  //                                          //
  //////////////////////////////////////////////


//   separator0 = XtVaCreateManagedWidget 
//     ("separator0",
//      xmSeparatorWidgetClass, form,
//      XmNleftAttachment, XmATTACH_FORM,
//      XmNrightAttachment, XmATTACH_FORM,
//      XmNtopPosition, 30,
//      XmNtopAttachment, XmATTACH_POSITION,
//      XmNbottomAttachment, XmATTACH_NONE,
//      NULL);
  nn=0;
  XtSetArg(args[nn], XmNscrollVertical, True); nn++;
  XtSetArg(args[nn], XmNscrollHorizontal, False); nn++;
  XtSetArg(args[nn], XmNeditMode, XmMULTI_LINE_EDIT); nn++;
  XtSetArg(args[nn], XmNeditable, False); nn++;
  //  XtSetArg(args[nn], XmNcursorPositionVisible, False); nn++;
  XtSetArg(args[nn], XmNwordWrap, True); nn++;
  //  XtSetArg(args[nn], XmNrows, 10); nn++;
  //  XtSetArg(args[nn], XmNcolumns, 100); nn++;
  XtSetArg(args[nn], XmNleftPosition, 50); nn++;
  XtSetArg(args[nn], XmNleftAttachment, XmATTACH_POSITION); nn++;
  XtSetArg(args[nn], XmNrightAttachment, XmATTACH_FORM); nn++;
  XtSetArg(args[nn], XmNtopPosition, 27); nn++;
  XtSetArg(args[nn], XmNtopAttachment, XmATTACH_POSITION); nn++;
  XtSetArg(args[nn], XmNbottomPosition, 98); nn++;
  XtSetArg(args[nn], XmNbottomAttachment, XmATTACH_POSITION); nn++;

  text_comout=XmCreateScrolledText(form, "text_comout", args, nn);

  XtManageChild(text_comout);
//   text_comout = XtVaCreateManagedWidget 
//     ("text_comout",
//      xmTextWidgetClass, form,
//      XmNscrollVertical, True,
//      XmNleftPosition, 50,
//      XmNleftAttachment, XmATTACH_POSITION,
//      XmNrightAttachment, XmATTACH_FORM,
//      XmNtopPosition, 45,
//      XmNtopAttachment, XmATTACH_POSITION,
//      XmNbottomPosition, 98,
//      XmNbottomAttachment, XmATTACH_POSITION,
//      XmNeditable, False,
//      XmNeditMode, XmMULTI_LINE_EDIT,
//      NULL);

  XtAddCallback (text_comout, XmNhelpCallback, genhelpCallback, text_comout);

  comstr = XmStringCreateLocalized ("command:");
  command_w = XtVaCreateWidget 
    ("command_w", xmCommandWidgetClass, form,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 50,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 27,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 98,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNpromptString, comstr, 
     NULL);

  XtAddCallback (command_w, XmNhelpCallback, genhelpCallback, command_w);

  XmStringFree(comstr);

  rcend1 = XtVaCreateManagedWidget 
    ("rcend1",
     xmRowColumnWidgetClass, main_form,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 40,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 91,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomAttachment, XmATTACH_FORM,
     XmNorientation,  XmHORIZONTAL,
     XmNspacing, 20,
     NULL);


  button_searchvar = new searchvarControl(rcend1, &toplevel, "button_searchvar", "search", &label_info);

  XtVaSetValues (button_searchvar->baseWidget(),
		 XmNmarginWidth, 20,
		 XmNmarginHeight, 8,
		 NULL);
  button_searchvar->manage();


  Helpbutton = XtVaCreateManagedWidget("Helpbutton",
				       xmPushButtonWidgetClass, rcend1,
				       NULL);

  xmstr_help = XmStringCreateSimple("help");

  XtVaSetValues (Helpbutton,
		 XmNmarginWidth, 20,
		 XmNmarginHeight, 5,
		 XmNlabelString, xmstr_help,
		 NULL);

  XmStringFree(xmstr_help);
  XtAddCallback (Helpbutton, XmNactivateCallback, FullSysHelp, NULL);
  XtAddCallback (Helpbutton, XmNhelpCallback, genhelpCallback, Helpbutton);

  XtVaGetValues(rcend1,
		XmNforeground, &fg,
		XmNbackground, &bg,
		NULL);

  Helppix = XmGetPixmapByDepth(XtScreen (rcend1), "src/gui/xm_information", fg, bg, DefaultDepthOfScreen (XtScreen (rcend1)));

  ibutton = XtVaCreateManagedWidget("ibutton",
				       xmPushButtonWidgetClass, rcend1,
				       NULL);

  XtVaGetValues(ibutton,
		XmNhighlightThickness, &ht,
		XmNshadowThickness, &st,
		NULL);

  XtVaSetValues (ibutton,
		 XmNmarginWidth, 20,
		 XmNmarginHeight, 2,
		 XmNlabelType, XmPIXMAP,
		 XmNlabelPixmap, Helppix,
		 NULL);

  XtAddCallback (ibutton, XmNactivateCallback, query_for_help, NULL);
  XtAddCallback (ibutton, XmNhelpCallback, genhelpCallback, ibutton);

  //  XCopyArea(XtDisplay(Helpbutton), Helppix, XtWindow (Helpbutton), XDefaultGCOfScreen (XtScreen (Helpbutton)), 0, 0, 50, 50, ht + st, ht + st);


  rcend = XtVaCreateManagedWidget 
    ("rcend",
     xmRowColumnWidgetClass, main_form,
     XmNleftPosition, 70,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 91,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomAttachment, XmATTACH_FORM,
     XmNorientation,  XmHORIZONTAL,
     XmNspacing, 20,
     NULL);

  button_paramtog = XtVaCreateManagedWidget
    ("button_paramtog", 
     xmPushButtonWidgetClass, rcend,
     XmNlabelString, xmstr_paramtog,
     XmNmarginWidth, 20,
     XmNmarginHeight, 8,
     NULL);

  button_quit = XtVaCreateManagedWidget 
    ("button_quit", 
     xmPushButtonWidgetClass, rcend,
     XmNlabelString, xmstr3,
     XmNmarginWidth, 20,
     XmNmarginHeight, 8,
     NULL);



  XtAddCallback (command_w, XmNcommandEnteredCallback, exec_cmd, text_comout);
  XtManageChild (command_w);

  params = new paramControl(main_form, &toplevel, &text_pfilename, "params", "irrelevant", "sysfiles/o2funcsr.cc", "sysfiles/temp/params.desc", &paramschanged, &app);
  XtVaSetValues (params->baseWidget(),
		 XmNwidth, 850,
		 XmNheight, 450,
		 XmNfractionBase, 100,
		 XmNleftAttachment, XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,
		 XmNtopPosition, 20,
		 XmNtopAttachment, XmATTACH_POSITION,
		 XmNbottomPosition, 93,
		 XmNbottomAttachment, XmATTACH_POSITION,
		 NULL);
//   XtVaSetValues (params->baseWidget(),
// 		 XmNleftAttachment, XmATTACH_FORM,
// 		 XmNrightAttachment, XmATTACH_FORM,
// 		 XmNtopPosition, 52,
// 		 XmNtopAttachment, XmATTACH_POSITION,
// 		 XmNbottomAttachment, XmATTACH_FORM,
// 		 NULL);
//params->manage();
//  params->paramsmanaged = 1;

  vars = new varControl(main_form, &toplevel, &text_modeltype, "vars", "irrelevant", "sysfiles/temp/vars.desc", "sysfiles/readable", &app);
  XtVaSetValues (vars->baseWidget(),
		 XmNwidth, 850,
		 XmNheight, 450,
		 XmNtopPosition, 20,
		 XmNleftAttachment, XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,
		 XmNtopAttachment, XmATTACH_POSITION,
		 XmNbottomPosition, 93,
		 XmNbottomAttachment, XmATTACH_POSITION,
		 XmNfractionBase, 100,
		 NULL);
//   XtVaSetValues (vars->baseWidget(),
// 		 XmNleftAttachment, XmATTACH_FORM,
// 		 XmNrightAttachment, XmATTACH_FORM,
// 		 XmNtopPosition, 52,
// 		 XmNtopAttachment, XmATTACH_POSITION,
// 		 XmNbottomAttachment, XmATTACH_FORM,
// 		 NULL);
//  vars->varsmanaged = 0;

  esys = new editsysControl(main_form, &toplevel, &text_modeltype, &mfsdialog, &datfsdialog, "esys", "irrelevant", "sysfiles/o2funcs.cc", "sysfiles/temp/params.desc", &paramschanged, &app);
  XtVaSetValues (esys->baseWidget(),
		 XmNwidth, 850,
		 XmNheight, 450,
		 XmNtopPosition, 20,
		 XmNleftAttachment, XmATTACH_FORM,
		 XmNrightAttachment, XmATTACH_FORM,
		 XmNtopAttachment, XmATTACH_POSITION,
		 XmNbottomPosition, 93,
		 XmNbottomAttachment, XmATTACH_POSITION,
		 XmNfractionBase, 100,
		 NULL);

  pv.p = params;
  pv.v = vars;
  pv.e = esys;
  pv.main = &form;


  ///////////////////////////////////////
  //                                   //
  //  The second row of buttons, etc.  // (needs to be there before first row)
  //                                   //
  ///////////////////////////////////////


  rc2 = XtVaCreateManagedWidget 
    ("rc2",
     xmRowColumnWidgetClass, main_form,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 1,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 18,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNorientation,  XmHORIZONTAL,
     //     XmNspacing, 25,
     //     XmNadjustLast, True,
     NULL);
  //
  //
  //
  // ordering the areas


  frame_selmodel = XtVaCreateManagedWidget 
    ("frame_selmodel",
     xmFrameWidgetClass, rc2,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);

  frame_makerun = XtVaCreateManagedWidget 
    ("frame_makerun",
     xmFrameWidgetClass, rc2,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);

  frame_inputfile = XtVaCreateManagedWidget 
    ("frame_inputfile",
     xmFrameWidgetClass, rc2,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);

  frame_params = XtVaCreateManagedWidget 
    ("frame_params",
     xmFrameWidgetClass, rc2,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);

  //
  //
  //
  rc1 = XtVaCreateManagedWidget 
    ("rc1",
     xmRowColumnWidgetClass, form,
     XmNorientation, XmHORIZONTAL,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 50,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopAttachment, XmATTACH_FORM,
     XmNbottomPosition, 25,
     XmNbottomAttachment, XmATTACH_POSITION,
     //     XmNspacing, 10,
     XmNadjustLast, True,
     NULL);

  frame_outputfile = XtVaCreateManagedWidget 
    ("frame_outputfile",
     xmFrameWidgetClass, rc1,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);

  frame_plot = XtVaCreateManagedWidget 
    ("frame_plot",
     xmFrameWidgetClass, rc1,
     XmNshadowType,  XmSHADOW_ETCHED_IN,
     NULL);


  //
  //
  //
  //
  //

  XtAddCallback (frame_selmodel, XmNhelpCallback, genhelpCallback, frame_selmodel);

  rc3 = XtVaCreateManagedWidget 
    ("rc3",
     xmRowColumnWidgetClass, frame_selmodel,
     XmNorientation,  XmVERTICAL,
     NULL);

  rc31 = XtVaCreateManagedWidget 
    ("rc3",
     xmRowColumnWidgetClass, rc3,
     XmNorientation,  XmHORIZONTAL,
     NULL);


  label_input = XtVaCreateManagedWidget
    ("label_input",
     xmLabelWidgetClass, rc31,
     XmNlabelString, xmstr_input,
     NULL);

  button_selectmodel = new selectmodelControl(rc31, &toplevel, &text_comout, &text_modeltype, &text_inputfile, &plot_text, &text_pfilename, &(esys->text_module), &(esys->text_datfile), "button_selectmodel", "select", "userfiles/model_types.dat", &label_info, &autoreg_tog, &params, &vars);
  button_selectmodel->manage();


  text_modeltype = XtVaCreateManagedWidget
    ("text_modeltype",
     xmTextWidgetClass, rc3,
     XmNcolumns, 15,
     XmNeditable, False,
     NULL);




  XtAddCallback (frame_outputfile, XmNhelpCallback, genhelpCallback, frame_outputfile);


  rc7 = XtVaCreateManagedWidget 
    ("rc7",
     xmRowColumnWidgetClass, frame_outputfile,
     XmNorientation,  XmVERTICAL,
     NULL);

  rc71 = XtVaCreateManagedWidget 
    ("rc71",
     xmRowColumnWidgetClass, rc7,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  rc72 = XtVaCreateManagedWidget 
    ("rc72",
     xmRowColumnWidgetClass, rc7,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  label_outputfile = XtVaCreateManagedWidget
    ("label_outputfile",
     xmLabelWidgetClass, rc71,
     XmNlabelString, xmstr_outputfile,
     NULL);

 




  XtAddCallback (frame_inputfile, XmNhelpCallback, genhelpCallback, frame_inputfile);

  rc6 = XtVaCreateManagedWidget 
    ("rc6",
     xmRowColumnWidgetClass, frame_inputfile,
     XmNorientation,  XmVERTICAL,
     NULL);


  rc61 = XtVaCreateManagedWidget 
    ("rc61",
     xmRowColumnWidgetClass, rc6,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  label_inputfile = XtVaCreateManagedWidget
    ("label_inputfile",
     xmLabelWidgetClass, rc61,
     XmNlabelString, xmstr_inputfile,
     NULL);

  rc62 = XtVaCreateManagedWidget 
    ("rc62",
     xmRowColumnWidgetClass, rc6,
     XmNorientation,  XmHORIZONTAL,
     NULL);



  text_inputfile = XtVaCreateManagedWidget
    ("text_inputfile",
     xmTextWidgetClass, rc62,
     XmNeditable, False,
     XmNcolumns, 30,
     NULL);




  fsdialog = XmCreateFileSelectionDialog(rc61, "filesb", NULL, 0);
  //  XtSetSensitive (XmFileSelectionBoxGetChild (fsdialog, XmDIALOG_HELP_BUTTON), False);
  filesb_titlestring = XmStringCreateLocalized("Select the input file");
  XtVaSetValues(fsdialog, XmNdialogTitle, filesb_titlestring, NULL);
  XmStringFree(filesb_titlestring);
  XtAddCallback (fsdialog, XmNokCallback, echo_file, (XtPointer) text_inputfile);
  XtAddCallback (fsdialog, XmNhelpCallback, FileSBhelp, (XtPointer) text_inputfile);
  XtAddCallback (fsdialog, XmNcancelCallback, CloseFileSB, (XtPointer) fsdialog);
  //  XtManageChild(fsdialog);

  // the module file select-file dialog

  mfsdialog = XmCreateFileSelectionDialog(form, "filesb", NULL, 0);
  //  XtSetSensitive (XmFileSelectionBoxGetChild (mfsdialog, XmDIALOG_HELP_BUTTON), False);
  filesb_titlestring = XmStringCreateLocalized("Select the module file");
  XtVaSetValues(mfsdialog, XmNdialogTitle, filesb_titlestring, NULL);
  XmStringFree(filesb_titlestring);
  XtAddCallback (mfsdialog, XmNokCallback, echo_mfile, (XtPointer) (esys->text_module));
  XtAddCallback (mfsdialog, XmNhelpCallback, FileSBhelp2, (XtPointer) (esys->text_module));
  XtAddCallback (mfsdialog, XmNcancelCallback, CloseFileSB, (XtPointer) mfsdialog);

  // the model descriptor file select-file dialog

  datfsdialog = XmCreateFileSelectionDialog(form, "filesb", NULL, 0);
  //  XtSetSensitive (XmFileSelectionBoxGetChild (datfsdialog, XmDIALOG_HELP_BUTTON), False);
  filesb_titlestring = XmStringCreateLocalized("Select the model descriptor file");
  XtVaSetValues(datfsdialog, XmNdialogTitle, filesb_titlestring, NULL);
  XmStringFree(filesb_titlestring);
  XtAddCallback (datfsdialog, XmNokCallback, echo_datfile, (XtPointer) (esys->text_datfile));
  XtAddCallback (datfsdialog, XmNhelpCallback, FileSBhelp3, (XtPointer) (esys->text_datfile));
  XtAddCallback (datfsdialog, XmNcancelCallback, CloseFileSB, (XtPointer) datfsdialog);





//   button_selectfile = 
//     XmVaCreateSimplePulldownMenu(rc2, "file_menu", 0, file_cb,
// 				 XmVaPUSHBUTTON, xmstr_selectfile, 'S', NULL, NULL,
// 				 NULL);



  button_selectfile = new selectfileControl(rc61, &text_inputfile, &fsdialog, "button_selectfile", "choose", &label_info, &autoreg_tog);
  button_selectfile->manage();


  button_editfile = new editfileControl(rc61, &text_inputfile, "button_editfile", "edit", &label_info, &autoreg_tog);
  button_editfile->manage();

  button_cpinputfile = new cpinputfileControl(rc61, &text_inputfile, "button_cpinputfile", "copy", &label_info);
  button_cpinputfile->manage();

  button_editfilesimp = new editfilesimpControl(rc71, &text_outputfile, "button_editfilesimp", "view", &label_info, &app);
  button_editfilesimp->manage();

  button_reducefile = new reducefileControl(rc71, &text_outputfile, "button_reducefile", "reduce", &label_info, &app);
  button_reducefile->manage();


  text_outputfile = XtVaCreateManagedWidget
    ("text_outputfile",
     xmTextWidgetClass, rc72,
     NULL);



  rc9 = XtVaCreateManagedWidget 
    ("rc9",
     xmRowColumnWidgetClass, frame_params,
     XmNorientation,  XmVERTICAL,
     NULL);

  rc91 = XtVaCreateManagedWidget 
    ("rc91",
     xmRowColumnWidgetClass, rc9,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  rc92 = XtVaCreateManagedWidget 
    ("rc92",
     xmRowColumnWidgetClass, rc9,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  label_pfilename = XtVaCreateManagedWidget
    ("label_pfilename",
     xmLabelWidgetClass, rc91,
     XmNlabelString, xmstr_fname,
     NULL);

  text_pfilename = XtVaCreateManagedWidget
    ("text_pfilename",
     xmTextWidgetClass, rc92,
     XmNeditable, False,
     XmNcolumns, 30,
     NULL);
     // 


  pfsdialog = XmCreateFileSelectionDialog(rc91, "filesb", NULL, 0);
  //  XtSetSensitive (XmFileSelectionBoxGetChild (pfsdialog, XmDIALOG_HELP_BUTTON), False);
  filesb_titlestring = XmStringCreateLocalized("Select the parameter file");
  XtVaSetValues(pfsdialog, XmNdialogTitle, filesb_titlestring, NULL);
  XmStringFree(filesb_titlestring);
  XtAddCallback (pfsdialog, XmNokCallback, echo_pfile, (XtPointer) text_pfilename);
  XtAddCallback (pfsdialog, XmNhelpCallback, FileSBhelp1, (XtPointer) text_pfilename);
  XtAddCallback (pfsdialog, XmNcancelCallback, CloseFileSB, (XtPointer) pfsdialog);

  button_selectpfile = new selectpfileControl(rc91, &text_pfilename, &pfsdialog, "button_selectpfile", "choose", &label_info, &autoreg_tog);
  button_selectpfile->manage();

  XtAddCallback (frame_params, XmNhelpCallback, genhelpCallback, frame_params);
  XtAddCallback (text_pfilename, XmNhelpCallback, genhelpCallback, text_pfilename);

  button_viewpfile = new viewpfileControl(rc91, &text_pfilename, "button_viewpfile", "edit", &label_info);
  button_viewpfile->manage();

  button_cpparamfile = new cpparamfileControl(rc91, &text_pfilename, "button_cpparamfile", "copy", &label_info);
  button_cpparamfile->manage();

  ////////////////////////////////////
  //                                //
  //  The top row of buttons, etc.  //
  //                                //
  ////////////////////////////////////





  frame_message = XtVaCreateManagedWidget 
    ("frame_message",
     xmFrameWidgetClass, form,
     XmNleftPosition, 50,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopAttachment, XmATTACH_FORM,
     XmNbottomPosition, 25,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XtAddCallback (frame_message, XmNhelpCallback, genhelpCallback,frame_message);

  label_info = new messagelabel(frame_message, "label_info", "(messages)");
//   XtVaSetValues (label_info->baseWidget(),
// 		 XmNwidth, 400,
// 		 NULL);


//    label_info1 = XtVaCreateManagedWidget 
//      ("label_info1", xmLabelWidgetClass, form,
//       XmNleftAttachment, XmATTACH_FORM,
//       XmNrightPosition, 20,
//       XmNrightAttachment, XmATTACH_POSITION,
//       XmNtopPosition, 10,
//       XmNtopAttachment, XmATTACH_POSITION,
//       XmNbottomPosition, 18,
//       XmNbottomAttachment, XmATTACH_POSITION,
//       XmNlabelString, xmstr_info,
//       NULL);



  // XDrawPoint(labeldisplay, Drawable dr, GC gc, int x, int y)


  // editfile needs to know the status of plottog



  XtAddCallback (frame_plot, XmNhelpCallback, genhelpCallback,frame_plot);

  rc8 = XtVaCreateManagedWidget 
    ("rc8",
     xmRowColumnWidgetClass, frame_plot,
     XmNorientation,  XmVERTICAL,
     NULL);

  rc81 = XtVaCreateManagedWidget 
    ("rc81",
     xmRowColumnWidgetClass, rc8,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  rc82 = XtVaCreateManagedWidget 
    ("rc82",
     xmRowColumnWidgetClass, rc8,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  label_vartoplot = XtVaCreateManagedWidget
    ("label_vartoplot",
     xmLabelWidgetClass, rc81,
     XmNlabelString, xmstr_vartoplot,
     NULL);

  plot_text = XtVaCreateManagedWidget
    ("plot_text",
     xmTextWidgetClass, rc82,
     XmNcolumns, 25,
     NULL);

  XtAddCallback (plot_text, XmNhelpCallback, genhelpCallback, plot_text);



  button_selectvar = new selectoutvarControl(rc81, &toplevel, &text_outputfile, &text_comout, &plot_text, "button_selectvar", "select", "src/lib/P_makeoutputinfo", &label_info, &autoreg_tog);
  button_selectvar->manage();

  button_plot = new plotControl(rc81, &toplevel, &text_comout, &text_outputfile, &text_pfilename, "button_plot", "gnuplot", &label_info, &plot_text);

  button_editheadfile = new editheadfileControl(rc81, &plot_text, "button_editheadfile", "header", &label_info);
  button_editheadfile->manage();


  XtAddCallback (frame_makerun, XmNhelpCallback, genhelpCallback,frame_makerun);

  rc4 = XtVaCreateManagedWidget 
    ("rc4",
     xmRowColumnWidgetClass, frame_makerun,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  rc41 = XtVaCreateManagedWidget 
    ("rc41",
     xmRowColumnWidgetClass, rc4,
     XmNorientation,  XmVERTICAL,
     NULL);

  rc42 = XtVaCreateManagedWidget 
    ("rc42",
     xmRowColumnWidgetClass, rc4,
     XmNorientation,  XmVERTICAL,
     NULL);


  autoreg_tog = new plotToggle(rc41, &text_modeltype, &text_inputfile, &text_outputfile, "autoreg_tog", "autoreg.", &label_info, &smooth_tog);

  //  XtAddCallback (autoreg_tog->baseWidget(), XmNhelpCallback, genhelpCallback, autoreg_tog->baseWidget());

  smooth_tog = new smoothToggle(rc41, "smooth_tog", "smooth", &label_info);
  contplot_tog = new contplotToggle(rc42, "contplot_tog", "contplot", &label_info);

  rc421 = XtVaCreateManagedWidget 
    ("rc421",
     xmRowColumnWidgetClass, rc42,
     XmNorientation,  XmHORIZONTAL,
     NULL);

  button_make = new makeControl(rc421, &toplevel, "button_make", "make", &label_info, autoreg_tog);

  button_makerun = new makerunControl(rc421, &toplevel, &text_comout, &text_modeltype, &text_inputfile, &text_outputfile, &text_pfilename, "button_makerun", "run", &label_info, &autoreg_tog, smooth_tog, &contplot_tog, &plot_text, &app, &firstuse);



  //display the buttons

  label_info->manage();
  button_make->manage();
  //  button_run->manage(); 
  button_makerun->manage();
  //  plot_text->manage();
  autoreg_tog->manage();
  smooth_tog->manage();
  button_plot->manage();

  //
  // Get options to initialise the interface. Fail silently
  //

  getoption("userfiles/gui_options", "DATAFILE", DATAFILE, 100);
  getoption("userfiles/gui_options", "DEF_MODEL", DEF_MODEL, 100);

  tmp = getmoddef("userfiles/model_defaults", DEF_MODEL, "input");
  strncpy(DEF_INPUT_FILE, tmp, 99);
  free(tmp);
  tmp = getmoddef("userfiles/model_defaults", DEF_MODEL, "var");
  strncpy(DEF_PLOT_VAR, tmp, 99);
  free(tmp);
  tmp = getmoddef("userfiles/model_defaults", DEF_MODEL, "pvals");
  strncpy(DEF_PARAM_FILE, tmp, 99);
  free(tmp);


  if(getoption("userfiles/gui_options", "PARAM_CHANGES_FILE", PARAM_CHANGES_FILE, 100)!=0){
    strcpy(PARAM_CHANGES_FILE, "userfiles/__paramchanges.log"); // safe
    fprintf(stderr, "Using \"userfiles/__paramchanges.log\", as the parameter change tracking file.\n");
  }

  // Set text fields

  XmTextSetString(text_modeltype, DEF_MODEL); // default
  XmTextSetString(text_inputfile, DEF_INPUT_FILE); // default
  XmTextSetCursorPosition (text_inputfile, strlen (DEF_INPUT_FILE));
  XmTextSetString(text_outputfile, DATAFILE); // default
  XmTextSetString(text_pfilename, DEF_PARAM_FILE); // default
  XmTextSetCursorPosition (text_pfilename, strlen (DEF_PARAM_FILE));
  XmTextSetString(plot_text, DEF_PLOT_VAR); // default




//    separator1 = XtVaCreateManagedWidget 
//      ("separator1",
//       xmSeparatorWidgetClass, form,
//       XmNleftAttachment, XmATTACH_FORM,
//       XmNrightAttachment, XmATTACH_FORM,
//       XmNtopWidget, params->baseWidget(),
//       XmNtopAttachment, XmATTACH_WIDGET,
//       XmNbottomAttachment, XmATTACH_NONE,
//       NULL);

//    rc3 = XtVaCreateManagedWidget 
//      ("rc3",
//       xmRowColumnWidgetClass, form,
//       XmNorientation, XmHORIZONTAL,
//       XmNleftAttachment, XmATTACH_FORM,
//       XmNrightAttachment, XmATTACH_FORM,
//       XmNtopWidget, separator1,
//       XmNtopAttachment, XmATTACH_WIDGET,
//       XmNbottomAttachment, XmATTACH_NONE,
//       NULL);

//    separator2 = XtVaCreateManagedWidget 
//      ("separator2",
//       xmSeparatorWidgetClass, form,
//       XmNleftAttachment, XmATTACH_FORM,
//       XmNrightAttachment, XmATTACH_FORM,
//       XmNtopWidget, rc3,
//       XmNtopAttachment, XmATTACH_WIDGET,
//       XmNbottomAttachment, XmATTACH_NONE,
//       NULL);

  //  drawing1 = XtVaCreateManagedWidget 
  //  ("drawing1",
   //    xmDrawingAreaWidgetClass, form,
//       XmNleftAttachment, XmATTACH_FORM,
//       XmNrightAttachment, XmATTACH_FORM,
//       XmNtopWidget, separator2,
//       XmNtopAttachment, XmATTACH_WIDGET,
//       XmNbottomAttachment, XmATTACH_FORM,
//       NULL);



  //

//    drawingdisplay = XtDisplay(drawing1);
//    screen_ptr = XtScreen(drawing1);

//    gcv.foreground = BlackPixelOfScreen(screen_ptr);
//    gc = XCreateGC(drawingdisplay,
//  		 RootWindowOfScreen(screen_ptr), GCForeground, &gcv);
//    XtVaSetValues(drawing1, XmNuserData, gc, NULL);

//    XtAddCallback(drawing1, XmNexposeCallback, draw_cbk, NULL);


  //create the buttons





//    label_vars = XtVaCreateManagedWidget 
//      ("label_vars", xmLabelWidgetClass, rc3,
//       XmNlabelString, xmstr6,
//       NULL);

//    text_varname = XtVaCreateManagedWidget 
//      ("text_varname", xmTextWidgetClass, rc3,
//       XmNlabelString, xmstr_name,
//       NULL);

//    text_varval = XtVaCreateManagedWidget 
//      ("text_varval", xmTextWidgetClass, rc3,
//       XmNlabelString, xmstr_val,
//       NULL);

  // Free the compound strings when they no longer needed


  XmStringFree(xmstr);
  XmStringFree(xmstr1);
  XmStringFree(xmstr2);
  XmStringFree(xmstr3);
  XmStringFree(xmstr4);
  XmStringFree(xmstr5);
  XmStringFree(xmstr6);
  XmStringFree(xmstr_name);
  XmStringFree(xmstr_val);
  XmStringFree(xmstr_nofunc);
  XmStringFree(xmstr_paramtog);
  XmStringFree (xmstr_input);
  XmStringFree (xmstr_fname);
  XmStringFree (xmstr_inputfile);
  XmStringFree (xmstr_outputfile);
  XmStringFree (xmstr_vartoplot);


  //register the function

  XtAddCallback (button_quit, XmNactivateCallback, quitCallback, NULL);
  XtAddCallback (button_quit, XmNhelpCallback, genhelpCallback, button_quit);
  XtAddCallback (button_paramtog, XmNactivateCallback, paramtogCallback, (XtPointer) &pv);  
  XtAddCallback (button_paramtog, XmNhelpCallback, genhelpCallback, button_paramtog);
  

  //  XmMainWindowSetAreas (main_w, menubar, NULL, NULL, NULL, XtParent (main_form));
  // Realise all widgets and enter the main event loop

  fd = fopen(PARAM_CHANGES_FILE, "a");
  if(fd==NULL)
    fprintf(stderr, "File \"%s\" could not be opened.\n", PARAM_CHANGES_FILE);
  else{
    tstmp=time(NULL);
    fprintf(fd, "\n\n*****************\n\nBEGINSESSION: %s\n", ctime(&tstmp));
    fclose(fd);
  }



  XtRealizeWidget(toplevel);
  XtAppMainLoop(app);



  return 0;

}

void draw_cbk(Widget w, XtPointer data,
	      XtPointer cbk)
{
  int i;
  Window win; 
  GC gc;
  win = XtWindow(w);
  XPoint xp[20]; 

  for(i=0;i<20;i++){
    xp[i].x = i;
    xp[i].y = i;
  }

  XtVaGetValues(w, XmNuserData, &gc, NULL);
  XDrawPoint(drawingdisplay, win, gc, 50, 50);
  XDrawRectangle(drawingdisplay, win, gc, 10, 10, 100, 50);
  XDrawPoints(drawingdisplay, win, gc, xp, 20, CoordModeOrigin);  
}

void appmenu_cb(Widget widget, XtPointer client_data, XtPointer call_data)
{
  long item_no = (long) client_data; // for x64 compatibility
  if (item_no == 0)
    quitCallback(widget, client_data, call_data);
}

void viewmenu_cb(Widget widget, XtPointer client_data, XtPointer call_data)
{
  paramvar *obj;
  paramControl *obj1;
  varControl *obj2;
  editsysControl *obj3;
  Widget *main;
  //  obj = (paramvar *)clientdata1;
  obj=&pv;
  obj1 = (paramControl *)(obj->p);
  obj2 = (varControl *)(obj->v);
  obj3 = (editsysControl *)(obj->e);
  main = (Widget *)(obj->main);
  long item_no = (long) client_data; // for x64 compatibility

  if (item_no == 0){
    obj3->unmanage();
    obj2->unmanage();
    obj1->unmanage();
    XtManageChild(*main);
    viewstate=0;
  }
  else if (item_no == 1){
    XtUnmanageChild(*main);
    obj2->unmanage();
    obj3->unmanage();
    obj1->manage();
    viewstate=1;
  }
  else if (item_no == 2){
    obj1->unmanage();
    XtUnmanageChild(*main);
    obj3->unmanage();
    obj2->manage();
    viewstate=2;
  }
  else if (item_no == 3){
    obj1->unmanage();
    XtUnmanageChild(*main);
    obj2->unmanage();
    obj3->manage();
    viewstate=3;
  }
}

void paramw_cb(Widget, XtPointer clientdata1, XtPointer)
{
  paramvar *obj;
  paramControl *obj1;
  varControl *obj2;
  Widget *main;
  //  obj = (paramvar *)clientdata1;
  obj=&pv;
  obj1 = (paramControl *)(obj->p);
  obj2 = (varControl *)(obj->v);
  main = (Widget *)(obj->main);
  if (viewstate == 0){
    XtUnmanageChild(*main);
    obj2->unmanage();
    obj1->manage();
//     obj1->paramsmanaged = 1;
//     obj2->varsmanaged = 0;
    viewstate=1;
  }
  else if (viewstate == 1){
    obj1->unmanage();
    XtUnmanageChild(*main);
    obj2->manage();
//     obj1->paramsmanaged = 2;
//     obj2->varsmanaged = 1;
    viewstate=2;
  }
  else{
    obj2->unmanage();
    obj1->unmanage();
    XtManageChild(*main);
    viewstate=0;
//     obj2->varsmanaged = 0;
//     obj1->paramsmanaged = 0;
  }
}

void help_menu_cb(Widget widget, XtPointer client_data, XtPointer call_data)
{
// had to change *newcbs to newcbs - the original in Heller and Ferguson gave me segfaults - perhaps a cpp issue?

  long item_no = (long) client_data; // for x64 compatibility
  Widget Helpdialog;
  char vardesc[3000];
  char title[100];
  int l;

  if (item_no == 0){
  // what is help being requested for?
    l=getdesc("helpfiles/GUI_WID_HELP", "model_about", vardesc, 3000);
    strcpy(title, "About the BRAINCIRC model"); // safe
    Helpdialog = PostHelpDialog(XtParent(XtParent(XtParent(widget))), title, vardesc);
  }
  else if (item_no == 1){
    l=getdesc("helpfiles/GUI_WID_HELP", "interface_about", vardesc, 3000);
    strcpy(title, "About this user interface"); // safe
    Helpdialog = PostHelpDialog(XtParent(XtParent(XtParent(widget))), title, vardesc);
  }
  else if (item_no == 2){
    l=getdesc("helpfiles/GUI_WID_HELP", "getting_started", vardesc, 3000);
    strcpy(title, "Getting started"); // safe
    Helpdialog = PostHelpDialog(XtParent(XtParent(XtParent(widget))), title, vardesc);
  }
  else if (item_no == 3){
    query_for_help(widget, client_data, call_data);
  }
  else if (item_no == 4){
    l=getdesc("helpfiles/GUI_WID_HELP", "model_management", vardesc, 3000);
    strcpy(title, "Model management"); // safe
    Helpdialog = PostHelpDialog(XtParent(XtParent(XtParent(widget))), title, vardesc);
  }
  else if (item_no == 5){
    l=getdesc("helpfiles/GUI_WID_HELP", "known_issues", vardesc, 3000);
    strcpy(title, "Known issues"); // safe
    Helpdialog = PostHelpDialog(XtParent(XtParent(XtParent(widget))), title, vardesc);
  }

}

void query_for_help (Widget widget, XtPointer client_data, XtPointer call_data)
{
  Cursor cursor;
  Display *display;
  Widget help_widget;
  XmAnyCallbackStruct *cbs, newcbs; 
  XEvent event;
  cbs = (XmAnyCallbackStruct *) call_data;
  display = XtDisplay (toplevel);
  cursor = XCreateFontCursor (display, XC_hand2);

  help_widget = XmTrackingEvent (toplevel, cursor, True, &event);
  while (help_widget != NULL) {
    if (XtHasCallbacks (help_widget, XmNhelpCallback) == XtCallbackHasSome){
      newcbs.reason = XmCR_HELP;
      newcbs.event = &event;
      XtCallCallbacks (help_widget, XmNhelpCallback, (XtPointer) (&newcbs));
      help_widget = NULL;
    }
    else
      help_widget = XtParent (help_widget);
  }
  XFreeCursor (display, cursor);
}


void quitCallback (Widget parent, XtPointer client_data, XtPointer call_data)
{
  int l;
  FILE *fd;
  char PARAM_CHANGES_FILE[100];
  Widget Errdialog;

  if(getoption("userfiles/gui_options", "PARAM_CHANGES_FILE", PARAM_CHANGES_FILE, 100)!=0){
    strcpy(PARAM_CHANGES_FILE, "userfiles/__paramchanges.log"); // safe
    fprintf(stderr, "Using \"userfiles/__paramchanges.log\", as the parameter change tracking file.\n");
    Errdialog=PostEDialog(XtParent(parent), "ERROR with getting an option: see terminal for details");
  }

  fd = fopen(PARAM_CHANGES_FILE, "a");
  if(fd==NULL)
    fprintf(stderr, "File \"%s\" could not be opened", PARAM_CHANGES_FILE);
  fprintf(fd, "\nENDSESSION\n\n");
  fclose(fd);

  if(paramschanged !=0){
    if(AskUser(XtParent(parent), "Various parameter values were changed. Do you want to undo all changes this session?") == 1){

      l=undoparamsession(PARAM_CHANGES_FILE);
      if(l!=0){ // failed
	fprintf(stderr, "Some changes failed. Make sure you undo these changes by hand.\n");
      }
      else{
	fprintf(stderr, "All parameter changes during the session have been successfully undone.\n");
      }
    }
    else{
      fprintf(stderr, "Parameter changes kept. You can undo parameter changes at a\nlater date by referring to the file %s\n", PARAM_CHANGES_FILE);
    }
  }

  exit (0);
}

int AskUser(Widget parent, char *question)
{
  static Widget dialog;
  XmString text, yes, no, titlestring;
  static int answer;

  answer = 0;

  if (!dialog) {
    dialog = XmCreateQuestionDialog(parent, "dialog", NULL, 0);
    yes = XmStringCreateLocalized("Yes");
    no = XmStringCreateLocalized("No");
    titlestring = XmStringCreateLocalized("WARNING");

    XtVaSetValues(dialog,
		  XmNdialogStyle,        XmDIALOG_APPLICATION_MODAL,
		  XmNokLabelString,      yes,
		  XmNcancelLabelString,  no,
		  XmNdialogTitle,     titlestring,
		  NULL);

    //    XtSetSensitive(
    //		   XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON), False);
    XtAddCallback(dialog, XmNokCallback, response, &answer);
    XtAddCallback(dialog, XmNcancelCallback, response, &answer);
    XtAddCallback(dialog, XmNhelpCallback, response, &answer);
    XmStringFree (yes);
    XmStringFree (no);
    XmStringFree (titlestring);
  }
  text = XmStringCreateLocalized(question);
  XtVaSetValues(dialog,
		XmNmessageString,      text,
		NULL);
  XmStringFree(text);
  XtManageChild(dialog);
  XtPopup(XtParent(dialog), XtGrabNone);

/* while the user hasn't provided an answer, simulate XtMainLoop.
* The answer changes as soon as the user selects one of the
* buttons and the callback routine changes its value.  Don't
* break loop until XtPending() also returns False to assure
* widget destruction.
*/
  while (answer == 0 || XtAppPending(app)) // app is a global variable
    XtAppProcessEvent(app, XtIMAll);

  XtPopdown (XtParent (dialog));
  return answer;
}

/* response() --The user made some sort of response to the
* question posed in AskUser().  Set the answer (client_data)
* accordingly and destroy the dialog.
*/
void response(Widget widget, XtPointer client_data, XtPointer call_data)
{
  int *answer = (int *) client_data;
  XmAnyCallbackStruct *cbs = (XmAnyCallbackStruct *) call_data;
  Widget Errdialog, Helpdialog;
  char systemcom[1000];
  char PARAM_CHANGES_FILE[100];

  if(getoption("userfiles/gui_options", "PARAM_CHANGES_FILE", PARAM_CHANGES_FILE, 100)!=0){
    strcpy(PARAM_CHANGES_FILE, "userfiles/__paramchanges.log"); // safe
    fprintf(stderr, "Using \"userfiles/__paramchanges.log\", as the parameter change tracking file.\n");
    Errdialog=PostEDialog(XtParent(widget), "ERROR with getting an option: see terminal for details");
  }


  switch (cbs->reason) {
  case XmCR_HELP:
    snprintf(systemcom, 1000, "Some parameter value files have been changed. You can either\npress \"Yes\" to keep the new values, or you can revert to the\nold values. All parameter changes are tracked in the file\n\"%s\" in case you ever want to undo manually any\nchanges you made via the interface. If you undo changes,\nthen these are also deleted from \"%s\"", PARAM_CHANGES_FILE, PARAM_CHANGES_FILE);
      Helpdialog = PostHelpDialog(widget, "Help on parameter saving", systemcom);
    break;
  case XmCR_OK:
    *answer = YES;
    break;
  case XmCR_CANCEL:
    *answer = NO;
    break;
  default:
    *answer = NO;
    return;
  }
}

void paramtogCallback(Widget, XtPointer clientdata1, XtPointer)
{
  paramvar *obj;
  paramControl *obj1;
  varControl *obj2;
  editsysControl *obj3;
  Widget *main;
  obj=&pv;
  obj1 = (paramControl *)(obj->p);
  obj2 = (varControl *)(obj->v);
  obj3 = (editsysControl *)(obj->e);
  main = (Widget *)(obj->main);
  if (viewstate == 0){
    XtUnmanageChild(*main);
    obj2->unmanage();
    obj3->unmanage();
    obj1->manage();
    viewstate=1;
  }
  else if (viewstate == 1){
    obj1->unmanage();
    XtUnmanageChild(*main);
    obj3->unmanage();
    obj2->manage();
    viewstate=2;
  }
  else if (viewstate == 2){
    obj1->unmanage();
    XtUnmanageChild(*main);
    obj2->unmanage();
    obj3->manage();
    viewstate=3;
  }
  else{
    obj3->unmanage();
    obj2->unmanage();
    obj1->unmanage();
    XtManageChild(*main);
    viewstate=0;
  }
}

void exec_cmd (Widget cmd_widget, XtPointer client_data, XtPointer call_data)
{
  char *cmd, buf[BUFSIZ];
  XmTextPosition pos;
  FILE *pp;
  Widget text_w = (Widget) client_data;
  XmCommandCallbackStruct *cbs = (XmCommandCallbackStruct *) call_data;
  XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &cmd);

  if(!cmd || !*cmd){
    if(cmd)
      XtFree (cmd);
    return;
  }

  if (!(pp = popen(cmd, "r")))
    perror (cmd);
  XtFree(cmd);

  if (!pp)
    return;

  for (pos=XmTextGetLastPosition(text_w);fgets(buf, sizeof buf, pp); pos += strlen (buf))
    XmTextReplace (text_w, pos, pos, buf);

  pclose (pp);
}

void echo_file(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char *filename;
  XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call_data;
  Widget *tempw = (Widget *) client_data;
  Widget errdialog;
  char WORKDIR[100];

  if(getoption("userfiles/gui_options", "WORKDIR", WORKDIR, 99)!=0)
    strcpy(WORKDIR, "."); // safe

  strcat(WORKDIR, "/"); // safe

  if(!XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &filename))
    return; // must have been an internal error

  if(!*filename || isonlyspace(filename)){ // nothing typed
    fprintf(stderr, "ERROR: No file selected...\n");
    errdialog = PostEDialog(XtParent(widget), "No file selected.");
    XtFree(filename);
    return;
  }

  if(startswith(filename, WORKDIR)){
    XmTextSetString(*tempw, filename + strlen(WORKDIR));
    XmTextSetCursorPosition (*tempw, strlen (filename)+ strlen(WORKDIR));
  }
  else{
    XmTextSetString(*tempw, filename);
    XmTextSetCursorPosition (*tempw, strlen (filename));
  }

  XtFree(filename);
  XtUnmanageChild (fsdialog);

}

void echo_pfile(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char *filename;
  XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call_data;
  Widget *tempw = (Widget *) client_data;
  char WORKDIR[100];
  char *tmp;
  FILE *fd;
  char systemcom[200];
  Widget errdialog;

  if(getoption("userfiles/gui_options", "WORKDIR", WORKDIR, 99)!=0)
    strcpy(WORKDIR, "."); // safe
  strcat(WORKDIR, "/"); // safe

  if(!XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &filename))
    return; // must have been an internal error

  if(!*filename || isonlyspace(filename)){ // nothing typed
    fprintf(stderr, "ERROR: No file selected...\n");
    errdialog = PostEDialog(XtParent(widget), "No file selected.");
    XtFree(filename);
    return;
  }

  if(strstr(filename, WORKDIR))
    XmTextSetString(*tempw, filename + strlen(WORKDIR));
  else
    XmTextSetString(*tempw, filename);

  XmTextSetCursorPosition (*tempw, strlen (filename));

  // update sysfiles/sysstate/which_param_file

  fd = fopen("sysfiles/sysstate/which_param_file", "w");
  if(!fd){
    snprintf(systemcom, 200, "File \"sysfiles/sysstate/which_param_file\" can't be opened.");
    errdialog = PostEDialog(XtParent(widget), systemcom);
    XtFree(filename);
    return;
  }
  tmp=XmTextGetString(*tempw);
  fprintf(fd, "%s", tmp);
  free(tmp);
  fclose(fd);

  XtFree(filename);
  XtUnmanageChild (pfsdialog);
}


void echo_mfile(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char *filename;
  XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call_data;
  Widget *tempw = (Widget *) client_data;
  char WORKDIR[100];
  Widget errdialog;
  

  if(getoption("userfiles/gui_options", "WORKDIR", WORKDIR, 99)!=0)
    strcpy(WORKDIR, "."); // safe
  strcat(WORKDIR, "/"); // safe

  if(!XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &filename))
    return; // must have been an internal error

  if(!*filename || isonlyspace(filename)){ // nothing typed
    fprintf(stderr, "ERROR: No file selected...\n");
    errdialog = PostEDialog(XtParent(widget), "No file selected.");
    XtFree(filename);
    return;
  }

  if(strstr(filename, WORKDIR))
    XmTextSetString(*tempw, filename + strlen(WORKDIR));
  else
    XmTextSetString(*tempw, filename);

  XmTextSetCursorPosition (*tempw, strlen (filename));

  XtFree(filename);
  XtUnmanageChild (mfsdialog);

}



void echo_datfile(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char *filename;
  XmFileSelectionBoxCallbackStruct *cbs = (XmFileSelectionBoxCallbackStruct *) call_data;
  Widget *tempw = (Widget *) client_data;
  char WORKDIR[100];
  FILE *fd;
  char systemcom[200];
  char *tmp;
  Widget errdialog;

  if(getoption("userfiles/gui_options", "WORKDIR", WORKDIR, 99)!=0)
    strcpy(WORKDIR, "."); // safe
  strcat(WORKDIR, "/"); // safe

  if(!XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &filename))
    return; // must have been an internal error

  if(!*filename || isonlyspace(filename)){ // nothing typed
    snprintf(systemcom, 200, "ERROR: No file selected...\n");
    errdialog = PostEDialog(XtParent(widget), systemcom);
    XtFree(filename);
    return;
  }

  if(strstr(filename, WORKDIR))
    XmTextSetString(*tempw, filename + strlen(WORKDIR));
  else
    XmTextSetString(*tempw, filename);

  XmTextSetCursorPosition (*tempw, strlen (filename));

  // update which_desc_file
  fd = fopen("sysfiles/sysstate/which_desc_file", "w");
  if(!fd){
    snprintf(systemcom, 200, "File \"sysfiles/sysstate/which_desc_file\" can't be opened.");
    errdialog = PostEDialog(XtParent(widget), systemcom);
    XtFree(filename);
    return;
  }
  tmp=XmTextGetString(*tempw);
  fprintf(fd, "%s", tmp);
  free(tmp);
  fclose(fd);

  XtFree(filename);
  XtUnmanageChild (datfsdialog);

}

static void CloseFileSB(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget shell = (Widget) client_data;
  XtUnmanageChild(shell);
}


static void FileSBhelp(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget dialog;
  dialog = PostHelpDialog(widget, "Help", "Select the file that contains the input data.\nInput files essentially contain a list of\nparameter values with various options. You can view\nor edit an input file by choosing it, and then\nclicking on the edit button.");
  return;
}

static void FileSBhelp1(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget dialog;
  dialog = PostHelpDialog(widget, "Help", "Select the file that contains the desired\nparameter data. You can view or edit a\nparameter file by choosing it and then\nclicking on the \"view\" button.");
  return;
}

static void FileSBhelp2(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget dialog;
  dialog = PostHelpDialog(widget, "Help", "Select the module file you want to look at, scan or edit.");
  return;
}

static void FileSBhelp3(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget dialog;
  dialog = PostHelpDialog(widget, "Help", "Select the model descriptor file. By changing this\nyou effectively change the model: Simultaions will\nbe run using whatever descriptor file is chosen.");
  return;
}

void FullSysHelp(Widget widget, XtPointer client_data, XtPointer call_data)
{
  Widget confirmdialog;
  XmString str, cancel, titlestring;
  Arg args[5];
  int n=0;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "help_button_activate", vardesc, 1000);

  // uncomment if you want the "i" button

//   Pixel fg, bg;
//   Dimension ht, st;
//   Pixmap Helppix;

//   XtVaGetValues(widget,
// 		XmNforeground, &fg,
// 		XmNbackground, &bg,
// 		NULL);

//   Helppix = XmGetPixmapByDepth(XtScreen (widget), "xm_information", fg, bg, DefaultDepthOfScreen (XtScreen (widget)));

  titlestring = XmStringCreateLocalized("Help");
  cancel = XmStringCreateLocalized ("Done");
  XtSetArg (args[n], XmNautoUnmanage, False); n++;
  confirmdialog = XmCreateQuestionDialog (XtParent(widget), "confirm", args, n);
//   str = XmStringCreateLocalized(
// "You can access context-sensitive help by pushing the\nbutton with the \"i\" symbol below. After this you\nwill get help on the next object you click on.\n\nClick on the \"Done\" button when you have finished.");

  str = XmStringCreateLtoR(vardesc, "MY_TAG");

  XtVaSetValues (confirmdialog,
		 //		 XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL, 
		 XmNmessageString, str,
		 XmNcancelLabelString, cancel,
		 XmNdialogTitle,     titlestring,
		 NULL);

  // uncomment if you want the "i" button

//   okbutton = XmMessageBoxGetChild (confirmdialog, XmDIALOG_OK_BUTTON);

//   XtVaGetValues(okbutton,
// 		XmNhighlightThickness, &ht,
// 		XmNshadowThickness, &st,
// 		NULL);


//   XtVaSetValues (okbutton,
// 		 XmNmarginWidth, 20,
// 		 XmNmarginHeight, 2,
// 		 XmNlabelType, XmPIXMAP,
// 		 XmNlabelPixmap, Helppix,
// 		 NULL);


  XmStringFree(str);
  XmStringFree(cancel);
  XmStringFree(titlestring);

  XtUnmanageChild(XmMessageBoxGetChild (confirmdialog, XmDIALOG_HELP_BUTTON));

  // comment out if you want the "i" button

  XtUnmanageChild(XmMessageBoxGetChild (confirmdialog, XmDIALOG_OK_BUTTON));

  // uncomment if you want the "i" button

  //  XtAddCallback(confirmdialog, XmNokCallback, query_for_help, NULL);
  XtAddCallback(confirmdialog, XmNcancelCallback, DestWidget, NULL);

  XtManageChild (confirmdialog);

  XtPopup (XtParent (confirmdialog), XtGrabNone);

  return;
}


void genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data){
  Widget Helpdialog;
  char vardesc[3000];
  char title[100];
  int l;

  Widget *tempw = (Widget *) client_data;

  if (!XtName(*tempw)){
    fprintf(stderr, "no widget name\n");
    return;
  }

  // what is help being requested for?
  if(strcmp(XtName(*tempw), "frame_selmodel") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "select_model_area", vardesc, 3000);
    strcpy(title, "Help on selecting a model"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_inputfile") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "input_file_area", vardesc, 3000);
    strcpy(title, "Help on input files"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_outputfile") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "output_file_area", vardesc, 3000);
    strcpy(title, "Help on output files"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_plot") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "plotting_area", vardesc, 3000);
    strcpy(title, "Help on plotting"); // safe
  }
  else if(strcmp(XtName(*tempw), "plot_text") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "plotvar_text", vardesc, 3000);
    strcpy(title, "Help on plotting"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_makerun") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "makerun_area", vardesc, 3000);
    strcpy(title, "Help on running simulations"); // safe
  }
  else if(strcmp(XtName(*tempw), "autoreg_tog") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "autoreg_togglebutton", vardesc, 3000);
    strcpy(title, "Help on static vs dynamic simulations"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_message") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "messages_label", vardesc, 3000);
    strcpy(title, "Messages"); // safe
  }
  else if(strcmp(XtName(*tempw), "command_w") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "command_area", vardesc, 3000);
    strcpy(title, "Help on command area"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_comout") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "output_area", vardesc, 3000);
    strcpy(title, "Help on the output area"); // safe
  }
  else if(strcmp(XtName(*tempw), "Helpbutton") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "Helpbutton", vardesc, 3000);
    strcpy(title, "Help on getting help"); // safe
  }
  else if(strcmp(XtName(*tempw), "ibutton") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "ibutton", vardesc, 3000);
    strcpy(title, "Context sensitive help"); // safe
  }
  else if(strcmp(XtName(*tempw), "button_paramtog") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "togglebutton", vardesc, 3000);
    strcpy(title, "Help on different interfaces"); // safe
  }
  else if(strcmp(XtName(*tempw), "button_quit") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "quitbutton", vardesc, 3000);
    strcpy(title, "Help on exiting the application"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_pfilename") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_pfile", vardesc, 3000);
    strcpy(title, "The input parameter file"); // safe
  }
  else if(strcmp(XtName(*tempw), "frame_params") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_file_area", vardesc, 3000);
    strcpy(title, "The parameter file area"); // safe
  }


  if(l<0){
    fprintf(stderr, "No help could be found for this area.\n");
    return;
  }

  Helpdialog = PostHelpDialog(widget, title, vardesc);

}


