/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "BasicComponent.h"
#include <Xm/Label.h>
#include "messagelabel.h"

int messagelabel::setmessage(char *message){
  XmString xmstr;
  xmstr = XmStringCreateSimple(message);
  XtVaSetValues (_w, XmNlabelString, xmstr, NULL);
  XmUpdateDisplay(_w); 
  XmStringFree(xmstr);
  return 0;
}

messagelabel::messagelabel(Widget parent, char *name, char display[]): BasicComponent (name){
  XmString xmstr;
  xmstr = XmStringCreateSimple(display);
  _w = XtVaCreateWidget
    (_name,
     xmLabelWidgetClass, parent,
     XmNlabelString, xmstr,
     NULL);
  XmStringFree (xmstr);
}
