/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//#include <sys/types.h>
//#include <unistd.h>
//#include <time.h> // for sleep
#include <stdio.h> // for printf
#include <stdlib.h> // for system
#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/Frame.h>
#include <Xm/Separator.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "BasicComponent.h"
#include "messagelabel.h"

#include "../common/stringmanip.h"
#include "../common/nrsimp.h"

#include "paramcontrol.h"

void telluser(messagelabel **label, char mess[]); // defined in control.cc - just needs to be declared
Widget PostErrorDialog(Widget parent, messagelabel **label, char *msg); // in controls.cc
Widget PostLongDialog(Widget parent, char *title, char *msg);
Widget PostDialog(Widget parent, int dialog_type, char *msg); // in controls.cc
Widget PostHelpDialog(Widget parent, char *title, char *msg); // in controls.cc
void DestWidget(Widget widget, XtPointer client_data, XtPointer call_data); // in controls.cc
void TOC(Boolean on, Widget *wid); // in controls.cc


//
//
// constructor
//
//

paramControl::paramControl(Widget parent, Widget *toplevel1, Widget *text_pfilename, char *name, char display[], char *funcfile, char *descfile, int *paramschanged, XtAppContext *app): BasicComponent (name){
  XmString xmstr, xmstr_add, xmstr_del;
  XmString xmstr_name, xmstr_type, xmstr_value, xmstr_desc, xmstr_func;
  XmString xmstr_fname, xmstr_fname1;
  xmstr = XmStringCreateSimple("PARAMETERS");
  xmstr_add = XmStringCreateSimple("add");
  xmstr_del = XmStringCreateSimple("remove");

  xmstr_name = XmStringCreateSimple("name");
  xmstr_type = XmStringCreateSimple("set/o2");
  xmstr_value = XmStringCreateSimple("value");
  xmstr_desc = XmStringCreateSimple("description");
  xmstr_func = XmStringCreateSimple("function");
  xmstr_fname = XmStringCreateSimple("parameter file:");
  xmstr_fname1 = XmStringCreateSimple("infile:");

  toplevel=toplevel1;
  app1 = app;
  text_pfile = text_pfilename;
  // load the parameters

  _w = XtVaCreateWidget (_name,
				xmFormWidgetClass, parent,
				NULL);

//   XtVaSetValues (_w,
// 		 XmNfractionBase, 100,
// 		 NULL);

   separator1 = XtVaCreateManagedWidget 
     ("separator1",
      xmSeparatorWidgetClass, _w,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_FORM,
      XmNtopPosition, 0,
      XmNtopAttachment, XmATTACH_POSITION,
      XmNbottomAttachment, XmATTACH_NONE,
      NULL);

  frame_main = XtVaCreateManagedWidget
    ("frame_main",
     xmFrameWidgetClass, _w,
     XmNleftPosition, 2,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 14,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  label_main = XtVaCreateManagedWidget
    ("label_main",
     xmLabelWidgetClass, frame_main,
     XmNlabelString, xmstr,
     NULL);


  rc1 = XtVaCreateManagedWidget 
    ("rc1",
     xmRowColumnWidgetClass, _w,
     XmNorientation, XmVERTICAL,
     XmNleftPosition, 82,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 80,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  label_name = XtVaCreateManagedWidget
    ("label_name",
     xmLabelWidgetClass, _w,
     XmNleftPosition, 16,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 24,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_name,
     NULL);


  text_name = XtVaCreateManagedWidget
    ("text_name",
     xmTextWidgetClass, _w,
     XmNleftPosition, 24,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 43,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);


  //  XmTextSetString(text_name, "Vol_BrW"); // default

  XtAddCallback (label_name, XmNhelpCallback, genhelpCallback, text_name);
  XtAddCallback (text_name, XmNhelpCallback, genhelpCallback, text_name);

  label_type = XtVaCreateManagedWidget
    ("label_type",
     xmLabelWidgetClass, _w,
     XmNleftPosition, 43,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 51,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_type,
     NULL);

  text_type = XtVaCreateManagedWidget
    ("text_type",
     xmTextWidgetClass, _w,
     XmNeditable, False,
     XmNleftPosition, 51,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 58,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XtAddCallback (label_type, XmNhelpCallback, genhelpCallback, text_type);
  XtAddCallback (text_type, XmNhelpCallback, genhelpCallback, text_type);


  label_value = XtVaCreateManagedWidget
    ("label_value",
     xmLabelWidgetClass, _w,
     XmNleftPosition, 59,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 65,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_value,
     NULL);

  text_value = XtVaCreateManagedWidget
    ("text_value",
     xmTextWidgetClass, _w,
     XmNeditable, False,
     XmNleftPosition, 65,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 80,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XtAddCallback (label_value, XmNhelpCallback, genhelpCallback, text_value);
  XtAddCallback (text_value, XmNhelpCallback, genhelpCallback, text_value);


  label_desc = XtVaCreateManagedWidget
    ("label_desc",
     xmLabelWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 15,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 17,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 40,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_desc,
     NULL);

  text_desc = XtVaCreateManagedWidget
    ("text_desc",
     xmTextWidgetClass, _w,
     XmNeditable, False,
     XmNwordWrap, True,
     XmNleftPosition, 15,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 80,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 17,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 40,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNeditMode, XmMULTI_LINE_EDIT,
     NULL);

  XtAddCallback (label_desc, XmNhelpCallback, genhelpCallback, text_desc);
  XtAddCallback (text_desc, XmNhelpCallback, genhelpCallback, text_desc);

  label_func = XtVaCreateManagedWidget
    ("label_func",
     xmLabelWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 15,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 42,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 75,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_func,
     NULL);

  text_func = XtVaCreateManagedWidget
    ("text_func",
     xmTextWidgetClass, _w,
     XmNeditable, False,
     XmNwordWrap, True,
     XmNleftPosition, 15,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 80,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 42,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 75,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNeditMode, XmMULTI_LINE_EDIT,
     NULL);

  XtAddCallback (label_func, XmNhelpCallback, genhelpCallback, text_func);
  XtAddCallback (text_func, XmNhelpCallback, genhelpCallback, text_func);

  message_frame = XtVaCreateManagedWidget
    ("message_frame",
     xmFrameWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 80,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 95,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XtAddCallback (message_frame, XmNhelpCallback, genhelpCallback, message_frame);

  messages = new messagelabel(message_frame, "messages", "(messages)");
  messages->manage();

  button_check = new checkControl(rc1, toplevel, text_pfile, &text_name, &text_type, &text_value, &text_desc, &text_func, &label_desc, &label_func, "button_check", "check", &messages, funcfile, descfile, app1);
  button_check->manage();

  button_deps = new depsControl(rc1, &text_name, &text_desc, &text_func, &label_desc, &label_func, "button_deps", "dependencies", &button_check, &messages);
  button_deps->manage();

  button_editpfile = new editpfileControl(rc1, text_pfile, &text_name, &text_type, "button_editpfile", "change", &messages, &button_check, paramschanged);
  button_editpfile->manage();


  XmStringFree (xmstr);
  XmStringFree (xmstr_add);
  XmStringFree (xmstr_del);
  XmStringFree (xmstr_name);
  XmStringFree (xmstr_type);
  XmStringFree (xmstr_value);
  XmStringFree (xmstr_desc);
  XmStringFree (xmstr_func);
  XmStringFree (xmstr_fname);
  XmStringFree (xmstr_fname1);

  XtAddCallback(_w, XmNhelpCallback,
		&paramControl::helpCallback,
		(XtPointer) this);

}

void paramControl::clearall(char *defvar){
  XmTextSetString(text_name, defvar);
  XmTextSetString(text_type, "");
  XmTextSetString(text_value, "");
  XmTextSetString(text_desc, "");
  XmTextSetString(text_func, "");
  messages->setmessage("");
}

void paramControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  paramControl *obj = (paramControl *) client_data;
  obj->help();
};

void paramControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "param_area", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), &messages, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on the parameter interface", vardesc);

}


void paramControl::genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data){
  paramControl *obj = (paramControl *) client_data;
  obj->genhelp(widget, client_data, call_data);
};


void paramControl::genhelp(Widget widget, XtPointer client_data, XtPointer call_data){
  Widget Helpdialog;
  char vardesc[3000];
  char title[100];
  int l;

  Widget *tempw = (Widget *) client_data;

  if (!XtName(*tempw)){
    fprintf(stderr, "no widget name\n");
    return;
  }

  // what is help being requested for?
  if(strcmp(XtName(*tempw), "text_name") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_name", vardesc, 3000);
    strcpy(title, "Parameter name"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_type") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_set", vardesc, 3000);
    strcpy(title, "Settable or non-settable parameter"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_value") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_value", vardesc, 3000);
    strcpy(title, "The parameter value"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_desc") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_description", vardesc, 3000);
    strcpy(title, "Information on the parameter"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_func") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "param_text_function", vardesc, 3000);
    strcpy(title, "Information on the parameter"); // safe
  }
  else if(strcmp(XtName(*tempw), "message_frame") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "paramvar_label_area", vardesc, 3000);
    strcpy(title, "Basic output"); // safe
  }


  if(l<0){
    fprintf(stderr, "No help could be found for this area.\n");
    return;
  }

  Helpdialog = PostHelpDialog(widget, title, vardesc);

}





//
//
// checkControl
//
//


void checkControl::select(char inputstr[])
{
  Widget dialog;
  XmString t, *str;
  int i=0, l;
  int totlines=0;
  char **lines;
  char systemcom[200];
  char othertype[100];

  Widget errdialog;
  Arg args[5];
  int n=0;
  XmString titlestring;

  answer = 0;
  char makecom[50];

  if(getoption("userfiles/gen_options", "MAKE", makecom, 50)!=0){
    errdialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return;
  }

  TOC(True, toplevel);

  snprintf(systemcom, 200, "%s sysfiles/alldescs.dat", makecom);
  l=system(systemcom);
  if(l!=0){
    errdialog = PostErrorDialog(_w, label, "description file could not be made - see terminal for details...");
    TOC(False, toplevel);
    return;
  }

  totlines = orderlines(inputstr, "PARAM", "sysfiles/alldescs.dat", &lines, othertype, 100);

  if(totlines==0){
    if(isonlyspace(othertype))
      errdialog = PostErrorDialog(_w, label, "Parameter not found. No possibilities found. Do a\ncomplete search using the search button (bottom left).");
    else{
      if (strstr(othertype, "TEMP"))
	errdialog = PostErrorDialog(_w, label, "Parameter not found. There is a temporary variable by this name");
      else if(strstr(othertype, "VARIABLE"))
	errdialog = PostErrorDialog(_w, label, "Parameter not found. There is a variable by this name");
      else if(strstr(othertype, "PROCESS"))
	errdialog = PostErrorDialog(_w, label, "Parameter not found. There is a process by this name");
      else if(strstr(othertype, "REACTION"))
	errdialog = PostErrorDialog(_w, label, "Parameter not found. There is a reaction rate by this name");
      else
	errdialog = PostErrorDialog(_w, label, "Parameter not found. No possibilities found");
    }
    TOC(False, toplevel);
    return;
  }

  str = (XmString *) XtMalloc (totlines*sizeof (XmString));
  t = XmStringCreateLocalized ("Parameter not found. Possibilities listed:");
  for (i=0; i < totlines; i++)
    str[i] = XmStringCreateLocalized (lines[i]);

  XtSetArg(args[n], XmNautoUnmanage, False); n++;
  titlestring = XmStringCreateLocalized("Select a parameter");
  dialog = XmCreateSelectionDialog (_w, "selection", args, n);

  telluser(label, "Select a parameter");

  XtVaSetValues (dialog,
  		 XmNlistLabelString, t,
		 XmNlistItems,       str,
		 XmNlistItemCount,   totlines,
		 XmNdialogTitle,     titlestring,
		 XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL, 
		 XmNmustMatch,       True,
		 NULL);
  XmStringFree(titlestring);

  XtSetSensitive (XmSelectionBoxGetChild (dialog, XmDIALOG_APPLY_BUTTON), False);
  XtAddCallback(dialog, XmNokCallback, dialog_callback, XtPointer (this));
  XtAddCallback(dialog, XmNnoMatchCallback, dialog_callback, XtPointer (this));
  XtAddCallback(dialog, XmNhelpCallback, dialog_callback, XtPointer (this));
  XtAddCallback(dialog, XmNcancelCallback, DestWidget, XtPointer (this));

  // memory freeing

  XmStringFree (t);
  while (--i >= 0)
    XmStringFree (str[i]); /* free elements of array */
  freearraydat(lines, totlines);

  XtManageChild (dialog);
  TOC(False, toplevel);
  XtPopup (XtParent (dialog), XtGrabNone);

  // don't return control until we have an answer. 

  while (answer == 0)
    XtAppProcessEvent (*app1, XtIMAll);

}


void checkControl::dlg(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char varname[100];
  char varname1[100];
  char vardesc[1000];
  int i, l;
  char msg[256], prompt[100], *value;
  int dialog_type;
  Widget Helpdialog;
  XmSelectionBoxCallbackStruct *cbs = 
    (XmSelectionBoxCallbackStruct *) call_data;

  switch (cbs->reason) {
  case XmCR_HELP:
    l=getdesc("helpfiles/GUI_WID_HELP", "paramcheck_dialog_helpbutton", vardesc, 1000);
    if(l<0){
      Helpdialog = PostErrorDialog(widget, label, "ERROR in getting help: see terminal for details");
      return;
    }
    Helpdialog = PostHelpDialog(widget, "Help on finding a parameter", vardesc);
    return;
  case XmCR_OK:
    strcpy(prompt,"Selection: "); // safe
      dialog_type = XmDIALOG_MESSAGE;
      break;
  case XmCR_NO_MATCH:
      strcpy(prompt, "Not a valid selection: "); // safe
      dialog_type = XmDIALOG_ERROR;
      break;
  default:
      strcpy(prompt, "Unknown selection: "); // safe
      dialog_type = XmDIALOG_ERROR;
      break;
  }

  XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);
  snprintf (msg, 256, "%s%s", prompt, value);

  if(dialog_type != XmDIALOG_MESSAGE)
    (void) PostDialog (XtParent(XtParent (widget)), dialog_type, msg);

  if (cbs->reason != XmCR_NO_MATCH) {
    XtPopdown (XtParent (widget));
    XtDestroyWidget (widget); 
    getnthword(value, varname1, 100, 1);

    if(isonlyspace(varname1))
      telluser(label, "Nothing selected. Try again");
    else{
      i=0;while(value[i] && value[i] != ':'){i++;}// get past the type 
      getnthword(value + i, varname, 100, 1);
      XmTextSetString(*vartext, varname);
      answer=1;
//       if(check()!=0){
// 	XtFree(value);
// 	return;
//       }
    }
  }

  XtFree (value);

}


void checkControl::dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data){
  checkControl *obj = (checkControl *) client_data;
  obj->dlg(widget, client_data, call_data);
};

void checkControl::checkCallback(Widget, XtPointer client_data, XtPointer){
  checkControl *obj = (checkControl *) client_data;
  obj->check();
};

int checkControl::check()
{
  int l;
  char varname[30];
  char *pval;
  char *paramfile;
  char paramvalfile[100];
  char vardesc[1000];
  char buf[1000];
  XmString xmstr;
  Widget dialog;
  FILE *fd;
  char makecom[50];

  if(getoption("userfiles/gen_options", "MAKE", makecom, 50)!=0){
    dialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return -1;
  }

  fd = fopen("sysfiles/sysstate/which_param_file", "r");
  if(fd == NULL){
    dialog = PostErrorDialog(_w, label, "ERROR: file \"sysfiles/sysstate/which_param_file\" could not be opened.\n");
    return -1;
  }

  paramfile = XmTextGetString(*pfile);
  getline(fd, buf, 1000);
  getnthblock(buf, paramvalfile, 100, 1);
  fclose(fd);

  if(strcmp(paramfile, paramvalfile)!=0){
    snprintf(vardesc, 1000, "echo %s > sysfiles/sysstate/which_param_file", paramfile);
    system(vardesc);
    telluser(label, "Parameter file reset");
  }
  XtFree(paramfile);

  strncpy(varname, XmTextGetString(*vartext), 29);

  xmstr = XmStringCreateSimple("description");
  XtVaSetValues (*descl, XmNlabelString, xmstr, NULL);
  XmUpdateDisplay(_w);
  XmStringFree(xmstr);

  xmstr = XmStringCreateSimple("function");
  XtVaSetValues (*funcl, XmNlabelString, xmstr, NULL);
  XmUpdateDisplay(_w);
  XmStringFree(xmstr);


  // this is the potentially long part...

  TOC(True, toplevel);

  snprintf(vardesc, 1000, "%s sysfiles/params.dat", makecom);
  l=system(vardesc);
  if(l!=0){
    dialog = PostLongDialog(_w, "ERROR", "File sysfiles/params.dat could not be made.\nCheck that the model matches the parameter\nvalue file.");
    telluser(label, "ERROR: Parameter value file does not seem to match the model.");
    TOC(False, toplevel);
    return -1;
  }

  snprintf(vardesc, 1000, "%s sysfiles/o2funcs.cc", makecom);
  l=system(vardesc);
  if(l!=0){
    dialog = PostLongDialog(_w, "ERROR", "File sysfiles/o2funcs.cc could not be made.\nCheck that the model matches the parameter\nvalue file.");
    TOC(False, toplevel);
    return -1;
  }

  snprintf(vardesc, 1000, "%s sysfiles/allcurrent_pvals.dat", makecom);
  l=system(vardesc);
  if(l!=0){
    dialog = PostLongDialog(_w, "ERROR", "File sysfiles/allcurrent_pvals.dat could not be made.\nCheck that the model matches the parameter\nvalue file.");
    telluser(label, "ERROR: Parameter value file does not seem to match the model.");
    TOC(False, toplevel);
    return -1;
  }

  TOC(False, toplevel);


  if(!isonlyspace(varname))
    pval=getcvalfromfile("sysfiles/params.dat", varname);
  else
    pval=strdup("");
  if(isonlyspace(varname) || isonlyspace(pval)){ // value not found: run the selection process
    free(pval);
    XmTextSetString(*typetext, "");
    XmTextSetString(*valuetext, "");
    XmTextSetString(*desctext, "");
    XmTextSetString(*functext, "");

    select(varname);
    if(strcmp(varname, XmTextGetString(*vartext))==0) // nothing changed
      return -1;
    // try again
    strncpy(varname, XmTextGetString(*vartext), 29);
    pval=getcvalfromfile("sysfiles/params.dat", varname);
    //    return 1;
  }

  if(strstr(pval, "fcn") || !isnumber(pval)){ // o2 parameter found
    XmTextSetString(*typetext, "o2");
    findfunc1(funcfile, varname, buf, 1000, 1);
    XmTextSetString(*functext, buf);
  }
  else{ // set parameter found
    XmTextSetString(*typetext, "set");
    XmTextSetString(*functext, "No function: this is a settable parameter");
  }
  free(pval);
  // set the value
  pval=getcvalfromfile("sysfiles/allcurrent_pvals.dat", varname);
  if(isonlyspace(pval)){ 
// value not found: this should only happen if there is a mismatch between the model and the parameter value file (e.g. an out of date parameter value file).
    dialog = PostLongDialog(_w, "ERROR", "The value of the parameter could not be found.\nThe model does not seem to match the parameter\nvalue file.");
    telluser(label, "ERROR: Parameter value file does not seem to match the model.");
    free(pval);
    return -1;
  }
  XmTextSetString(*valuetext, pval);
  // set the description
  getdesc(descfile, varname, vardesc, 1000);
  XmTextSetString(*desctext, vardesc);
  telluser(label, "values displayed");
  free(pval);
  return 0;
}

void checkControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  checkControl *obj = (checkControl *) client_data;
  obj->help();
};

void checkControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "param_check_button", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), label, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on checking a parameter", vardesc);

}

checkControl::checkControl(Widget parent, Widget *toplevel1, Widget *text_pfilename, Widget *vart, Widget *typet, Widget *valuet, Widget *desct, Widget *funct, Widget *desclabel, Widget *funclabel, char *name, char *display, messagelabel **label1, char *funcfilename, char *descfilename, XtAppContext *app): BasicComponent (name){
  vartext = vart;
  typetext = typet;
  valuetext = valuet;
  desctext = desct;
  functext = funct;
  descl = desclabel;
  funcl = funclabel;
  label = label1; // set pointer to the correct label
  toplevel=toplevel1;
  app1 = app;
  pfile = text_pfilename;

  funcfile = funcfilename;
  descfile = descfilename;


  // Set what to display on the button

  XmString xmstr;
  xmstr = XmStringCreateSimple(display);

  // Create the button

  _w = XtVaCreateWidget
    (_name, 
     xmPushButtonWidgetClass, parent,
     XmNlabelString, xmstr,
     XmNmarginWidth, 10,
     XmNmarginHeight, 8,
     NULL);

  XmStringFree (xmstr); 

  XtAddCallback(_w, XmNactivateCallback,
		&checkControl::checkCallback,
		(XtPointer) this);

  XtAddCallback(_w, XmNhelpCallback,
		&checkControl::helpCallback,
		(XtPointer) this);
}; // end of constructor




//
//
// depsControl
//
//


void depsControl::depsCallback(Widget widget, XtPointer client_data, XtPointer call_data){
  depsControl *obj = (depsControl *) client_data;
  obj->deps();
};

void depsControl::deps()
{
  int i, l;
  char varname[100];
  char buf[2000];
  int bufs=2000;
  int ind=-1;
  XmString xmstr;
  Widget dialog;
  char makecom[50];
  char *pdeplist[1000];
  char **paramarray;
  int numparams = 0;
  int numdeps;


  if(getoption("userfiles/gen_options", "MAKE", makecom, 50)!=0){
    dialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return;
  }



  if((l=(*CC1)->check())!=0)
    return;

  strncpy(varname, XmTextGetString(*vartext), 49);


  if(strcmp(varname, "") == 0){
    dialog = PostErrorDialog(_w, label, "enter the name of a parameter...");
    return;
  }

  snprintf(buf, 2000, "%s sysfiles/params.dat", makecom);
  l=system(buf);
  if(l!=0){
    dialog = PostErrorDialog(_w, label, "file sysfiles/params.dat could not be made (see terminal for details)");
    return;
  }

  snprintf(buf, 2000, "%s sysfiles/alldeps.dat", makecom);
  l=system(buf);
  if(l!=0){
    dialog = PostErrorDialog(_w, label, "file sysfiles/alldeps.dat could not be made (see terminal for details)");
    return;
  }

  paramarray = genarraydat("sysfiles/params.dat", &numparams);

  telluser(label, "getting dependent variables...");
  if((ind = isinarray(paramarray, numparams, varname)) >= 0){
    // set the first label
    xmstr = XmStringCreateSimple("dependent");
    XtVaSetValues (*depsl, XmNlabelString, xmstr, NULL);
    XmUpdateDisplay(_w);
    XmStringFree(xmstr);
    // set the second label
    xmstr = XmStringCreateSimple("depends on");
    XtVaSetValues (*funcl, XmNlabelString, xmstr, NULL);
    XmUpdateDisplay(_w);
    XmStringFree(xmstr);
    strcpy(buf, ""); // safe
    bufs-=2;
    numdeps = getalldepson(varname, paramarray, numparams, "sysfiles/alldeps.dat", pdeplist, 1000);
    for(i=1;i<numdeps;i++){ // i=0 is the parameter itself
      if(bufs > (int)(strlen(pdeplist[i]))+2){
        strncat(buf, pdeplist[i], 1999-strlen(buf));
        if(((i+2) % 5) == 0)  strncat(buf, "\n", 1999-strlen(buf));
        else strncat(buf, "  ", 1999-strlen(buf));
        bufs-=strlen(pdeplist[i])+2;
      }
      else
	fprintf(stderr, "Ran out of space to print quantities dependent on this parameter...\n");
    }

    XmTextSetString(*desctext, buf);
    free_datarray(pdeplist, numdeps);
    bufs=1998;
    strcpy(buf, ""); //safe
    numdeps = getalldeps(varname, paramarray, numparams, "sysfiles/alldeps.dat", pdeplist, 1000);
    for(i=1;i<numdeps;i++){ // i=0 is the parameter itself
      if(bufs > (int)(strlen(pdeplist[i]))+2){
	strncat(buf, pdeplist[i], 1999-strlen(buf));
	if(((i+2) % 5) == 0)  strncat(buf, "\n", 1999-strlen(buf));
	else strncat(buf, "  ", 1999-strlen(buf));
	bufs-=strlen(pdeplist[i])+2;
      }
      else
	fprintf(stderr, "Ran out of space to print dependencies.\n");
    }
    XmTextSetString(*functext, buf);
    free_datarray(pdeplist, numdeps);
    telluser(label, "dependencies displayed...");
  }
  else{
    dialog = PostErrorDialog(_w, label, "parameter can't be found...");
    freearraydat(paramarray, numparams);
    return;
  }

  freearraydat(paramarray, numparams);
  return;

}

void depsControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  depsControl *obj = (depsControl *) client_data;
  obj->help();
};

void depsControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "param_depend_button", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), label, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on getting a parameter's dependencies", vardesc);

}


depsControl::depsControl(Widget parent, Widget *vart, Widget *desct, Widget *funct, Widget *depslabel, Widget *funclabel, char *name, char *display, checkControl **CC, messagelabel **label1): BasicComponent (name){
  vartext = vart;
  desctext = desct;
  functext = funct;
  label = label1; // set pointer to the correct label
  depsl = depslabel;
  funcl = funclabel;
  CC1 = CC;

  // Set what to display on the button

  XmString xmstr;
  xmstr = XmStringCreateSimple(display);

  // Create the button

  _w = XtVaCreateWidget
    (_name, 
     xmPushButtonWidgetClass, parent,
     XmNlabelString, xmstr,
     XmNmarginWidth, 10,
     XmNmarginHeight, 8,
     NULL);

  XmStringFree(xmstr); 

  XtAddCallback(_w, XmNactivateCallback,
		&depsControl::depsCallback,
		(XtPointer) this);
  XtAddCallback(_w, XmNhelpCallback,
		&depsControl::helpCallback,
		(XtPointer) this);
}; // end of constructor


//
//
// editpfileControl
//
//



void editpfileControl::newval()
{
  Widget dialog;
  XmString t, t1;
  Arg args[5];
  int n=0;
  char instr[100];
  FILE *fd;
  char *varname;
  char *paramfile;
  char *type;
  int flag, len;
  int lim=200;
  char oneline[200];
  char varn[100];
  Widget errdialog;
  char comnd[200];
  int l;

  // perform a check (first thing to do, before reading the parameter name)

  if((l=(*CC1)->check())!=0)
    return;

  paramfile = XmTextGetString(*pfile);
  type = XmTextGetString(*typetext);
  varname = XmTextGetString(*varwidget);

  if(strcmp(type, "o2")==0){
    snprintf(comnd, 200, "%s is not a settable parameter.", varname);
    errdialog = PostErrorDialog(_w, label, comnd);
    XtFree(varname);XtFree(paramfile);XtFree(type);
    return;
  }
  fd = fopen(paramfile, "r");
  if(fd == NULL){
    snprintf(comnd, 200, "file \"%s\" can't be opened.", paramfile);
    errdialog = PostErrorDialog(_w, label, comnd);
    XtFree(varname); XtFree(paramfile); XtFree(type);
    return;
  }

  flag=0;
  while((len = getline(fd, oneline, lim)) > 0){
    if(!iscom(oneline)){
      getnthword(oneline, varn, 100, 1);
      if(strcmp(varname, varn)==0){
	flag=1;
	break;
      }
    }

  }
  fclose(fd);
  if(flag==0){
    snprintf(comnd, 200, "The parameter %s could not be found \nin the file \"%s\".\nIt is probably not a settable parameter", varname, paramfile);
    errdialog = PostLongDialog(_w, "ERROR", comnd);
    snprintf(comnd, 200, "Parameter %s not found - probably not a settable parameter", varname);
    telluser(label, comnd);
    XtFree(varname); XtFree(paramfile); XtFree(type);
    return;
  }

  snprintf(instr, 100, "Change value of %s to:", varname);
  t = XmStringCreateLocalized (instr);
  XtSetArg (args[n], XmNselectionLabelString, t); n++;
  t1 = XmStringCreateLocalized ("Change");
  XtSetArg (args[n], XmNdialogTitle, t1); n++;
  XtSetArg(args[n], XmNautoUnmanage, False);n++;

  dialog = XmCreatePromptDialog (_w, "prompt", args, n);
  XmStringFree (t); XmStringFree (t1);
  XtFree(varname); XtFree(paramfile); XtFree(type);

  XtAddCallback(dialog, XmNokCallback, dialog_callback, (XtPointer) this);
  XtAddCallback(dialog, XmNhelpCallback, dialog_callback, (XtPointer) this);
  XtAddCallback(dialog, XmNcancelCallback, DestWidget, (XtPointer) this);


  XtManageChild (dialog);
  XtPopup (XtParent (dialog), XtGrabNone);
}

void editpfileControl::dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data){
  editpfileControl *obj = (editpfileControl *) client_data;
  obj->changeval(widget, client_data, call_data);
};


void editpfileControl::changeval(Widget widget, XtPointer client_data, XtPointer call_data){
  FILE *fd, *fd1, *fd2;
  int len, flag, l=1;
  Widget errdialog;
  char varn[100];
  char valn[100];
  char oneline[200];
  int lim=200;
  char comnd[200];
  char *value;
  Widget Helpdialog;
  char vardesc[1000];
  char *varname;
  char *paramfile;
  char pchangefile[100];
  char paramfilebak[100];
  XmSelectionBoxCallbackStruct *cbs = 
    (XmSelectionBoxCallbackStruct *) call_data;
  

  switch (cbs->reason) {
  case XmCR_HELP:
    l=getdesc("helpfiles/GUI_WID_HELP", "paramchange_dialog_helpbutton", vardesc, 1000);
    if(l<0){
      Helpdialog = PostErrorDialog(widget, label, "ERROR in getting help: see terminal for details");
      return;
    }
    Helpdialog = PostHelpDialog(widget, "Help on changing a parameter value", vardesc);
    return;
  default:
    break;
  }

  if(getoption("userfiles/gui_options", "PARAM_CHANGES_FILE", pchangefile, 100)!=0){
    errdialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return;
  }


  XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);

  if(isonlyspace(value)){
    errdialog = PostLongDialog(_w, "Problem with value", "You must enter something. Try again.\n");
    XtFree(value);
    return;
  }

  if(!isnumber(value)){
    errdialog = PostErrorDialog(_w, label, "You must enter a number. Try again.\n");
    XtFree(value);
    return;
  }

  paramfile = XmTextGetString(*pfile);
  varname = XmTextGetString(*varwidget);

  if(strlen(paramfile) < 95){
    strcpy(paramfilebak, paramfile); // safe
    strcat(paramfilebak, ".bak"); // safe
  }
  else{
    errdialog = PostErrorDialog(_w, label, "Parameter file name too long. Exiting.");
    XtFree(paramfile);XtFree(varname);
    XtDestroyWidget(widget);
    return;
  }

  snprintf(vardesc, 1000, "cp %s %s", paramfile, paramfilebak);
  l=system(vardesc);

  if(l!=0){
    errdialog = PostErrorDialog(_w, label, "Parameter value file could not be backed up - exiting...");
    XtFree(paramfile);XtFree(varname);
    XtDestroyWidget(widget);
    return;
  }

  fd = fopen(paramfilebak, "r");
  if(fd == NULL){
    snprintf(comnd, 200, "File \"%s\" can't be opened.", paramfilebak);
    errdialog = PostErrorDialog(_w, label, comnd);
    XtFree(paramfile);XtFree(varname);
    XtDestroyWidget(widget);
    return;
  }

  fd1 = fopen(paramfile, "w");
  if(fd1 == NULL){
    snprintf(comnd, 200, "File \"%s\" can't be opened for writing.", paramfile);
    errdialog = PostErrorDialog(_w, label, comnd);
    fclose(fd); XtFree(paramfile); XtFree(varname);
    XtDestroyWidget(widget);
    return;
  }

  flag=0;
  while((len = getline(fd, oneline, lim)) > 0){
    if(iscom(oneline))
      fprintf(fd1, "%s", oneline);
    else {
      getnthword(oneline, varn, 100, 1);
      getnthtoken(oneline, valn, 100, 2);
      if(strcmp(varname, varn)==0){
	fprintf(fd1, "%s\t%s\n", varname, value);
	flag=1;
        // keep a record of the parameter changes
	fd2 = fopen(pchangefile, "a");
	if(fd2==NULL)
	  fprintf(stderr, "File \"%s\" could not be opened", pchangefile);
	fprintf(fd2, "\tFile: %s\n", paramfile);
	fprintf(fd2, "\t%s %s to %s\n", varn, valn, value);
	fclose(fd2);
      }
      else
	fprintf(fd1, "%s", oneline);
    }
  }
  fclose(fd);
  fclose(fd1);

  (*pch)=1;

  // perform the check again
  if((*CC1)->check()!=0){
    XtFree (value); XtFree(varname); XtFree(paramfile);
    XtDestroyWidget(widget);
    return;
  }


  //
  // this should never execute. Ever. It is just a safety measure in case
  // the user edits the parameter value file directly
  //

  if(flag==0){
    snprintf(comnd, 200, "The parameter %s could not be found. Undoing all changes.", varname);
    errdialog = PostErrorDialog(_w, label, comnd);
    snprintf(comnd, 200, "cp %s %s", paramfilebak, paramfile);
    l=system(comnd);
  }

  XtFree (value); XtFree(varname); XtFree(paramfile);

}

void editpfileControl::editpfileCallback(Widget, XtPointer client_data, XtPointer){
  editpfileControl *obj = (editpfileControl *) client_data;
  obj->newval(); 
};

void editpfileControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  editpfileControl *obj = (editpfileControl *) client_data;
  obj->help();
};

void editpfileControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "param_change_button", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), label, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on changing a parameter value", vardesc);

}

//constructor

editpfileControl::editpfileControl(Widget parent, Widget *text_pfilename, Widget *varw, Widget *typew, char *name, char display[], messagelabel **label1, checkControl **CC, int *paramschanged): BasicComponent (name){
  label = label1; // set pointer to the correct label
  XmString xmstr;
  xmstr = XmStringCreateSimple(display);
  pfile = text_pfilename;
  varwidget = varw;
  pch = paramschanged;
  typetext = typew;

  CC1 = CC;

  // Create the widget

  _w = XtVaCreateWidget
    (_name, 
     xmPushButtonWidgetClass, parent,
     XmNlabelString, xmstr,
     XmNmarginWidth, 10,
     XmNmarginHeight, 8,
     NULL);

  XmStringFree (xmstr); 

  XtAddCallback(_w, XmNactivateCallback,
		&editpfileControl::editpfileCallback,
		(XtPointer) this);

  XtAddCallback(_w, XmNhelpCallback,
		&editpfileControl::helpCallback,
		(XtPointer) this);
}; // end of constructor


