/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//
//
// checkControl
//
//

class checkControl: public BasicComponent{

  XtAppContext *app1;
  int answer;

 protected:

  messagelabel **label; // a pointer to the label to be set
  Widget *vartext; //pointer to the text field holding the variable
  Widget *typetext;
  Widget *valuetext;
  Widget *desctext;
  Widget *functext;
  Widget *descl, *funcl; 
  Widget *toplevel;
  Widget *pfile;

  char *funcfile;
  char *descfile;

 public:

  checkControl(Widget parent, Widget *toplevel1, Widget *text_pfilename, Widget *vart, Widget *typet, Widget *valuet, Widget *desct, Widget *funct, Widget *desclabel, Widget *funclabel, char *name, char *display, messagelabel **label1, char *funcfilename, char *descfilename, XtAppContext *app);

  void select(char inputstr[]);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  static void checkCallback(Widget, XtPointer client_data, XtPointer);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);

  int check();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

};

//
//
// depsControl
//
//

class depsControl: public BasicComponent{

  checkControl **CC1;

 protected:

  messagelabel **label; // a pointer to the label to be set
  Widget *vartext; //pointer to the text field holding the variable
  Widget *desctext;
  Widget *functext;
  Widget *depsl; // The label which normally says "description" gets changed to "dependent";
  Widget *funcl; // The label which normally says "function" gets changed to "depends on";

 public:

  depsControl(Widget parent, Widget *vart, Widget *desct, Widget *funct, Widget *depslabel, Widget *funclabel, char *name, char *display, checkControl **CC, messagelabel **label1);

  static void depsCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void deps();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

};

//
//
// editpfileControl
//
//

class editpfileControl: public BasicComponent{

 public:

  messagelabel **label; // a pointer to the label to be set
  Widget *varwidget;
  Widget *typetext;
  Widget *pfile;
  char *inputfstr;
  char *varstr;
  char systemcom[100];
  checkControl **CC1;
  int *pch;

  void editpfile();
  void changeval(Widget widget, XtPointer client_data, XtPointer call_data);
  void newval();

  static void editpfileCallback(Widget widget, XtPointer client_data, XtPointer call_data);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  //constructor

  editpfileControl(Widget parent, Widget *text_pfilename, Widget *varw, Widget *typew, char *name, char display[], messagelabel **label1, checkControl **CC, int *paramschanged);

};




//
//
// The main one: paramControl (must be the last one)
//
//




class paramControl: public BasicComponent{

  XtAppContext *app1;
  Widget *text_pfile;

 public:

  Widget rc1,
    label_main, 
    label_name, label_type, label_value,
    label_desc, label_func,
    frame_main, 
    text_name, text_type, text_value, text_desc, text_func,
    message_frame;
  Widget separator1;

  int paramsmanaged;
  messagelabel *messages;
  checkControl *button_check;
  depsControl *button_deps;
  editpfileControl *button_editpfile;
  Widget *toplevel;

  static void genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void genhelp(Widget widget, XtPointer client_data, XtPointer call_data);

  static void helpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void help();
  void clearall(char *defvar);
  // constructor

  paramControl(Widget parent, Widget *toplevel1, Widget *text_pfilename, char *name, char display[], char *funcfile, char *descfile, int *paramschanged, XtAppContext *app);

};

