/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

//#include <sys/types.h>
//#include <unistd.h>
//#include <time.h> // for sleep
#include <stdio.h> // for printf
#include <stdlib.h> // for system
#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/Frame.h>
#include <Xm/Separator.h>
#include "BasicComponent.h"
#include "messagelabel.h"

#include "../common/stringmanip.h"

#include "varcontrol.h"

void telluser(messagelabel **label, char mess[]); // defined in control.cc - just needs to be declared

Widget PostErrorDialog(Widget parent, messagelabel **label, char *msg); // in controls.cc
Widget PostDialog(Widget parent, int dialog_type, char *msg); // in controls.cc
Widget PostHelpDialog(Widget parent, char *title, char *msg); // in controls.cc
void DestWidget(Widget widget, XtPointer client_data, XtPointer call_data); // in controls.cc
void TOC(Boolean on, Widget *wid); // in controls.cc

//
//
// var control
//
//

varControl::varControl(Widget parent, Widget *toplevel1, Widget *text_modname, char *name, char display[], char *descfile, char *evolfile, XtAppContext *app): BasicComponent (name){
  char title[] = "VARIABLES";
  XmString xmstr, xmstr_name, xmstr_desc, xmstr_evol, xmstr_type;
  xmstr = XmStringCreateSimple(title);
  xmstr_name = XmStringCreateSimple("name");
  xmstr_desc = XmStringCreateSimple("description");
  xmstr_evol = XmStringCreateSimple("evolution");
  xmstr_type = XmStringCreateSimple("type");

  toplevel=toplevel1;
  text_mod = text_modname;
  app1 = app;

  _w = XtVaCreateWidget (_name,
			 xmFormWidgetClass, parent,
			 NULL);

  XtVaSetValues (_w,
		 XmNfractionBase, 100,
		 NULL);

   separator1 = XtVaCreateManagedWidget 
     ("separator1",
      xmSeparatorWidgetClass, _w,
      XmNleftAttachment, XmATTACH_FORM,
      XmNrightAttachment, XmATTACH_FORM,
      XmNtopPosition, 0,
      XmNtopAttachment, XmATTACH_POSITION,
      //      XmNtopWidget, _w,
      //      XmNtopAttachment, XmATTACH_WIDGET,
      XmNbottomAttachment, XmATTACH_NONE,
      NULL);

  frame_main = XtVaCreateManagedWidget
    ("frame_main",
     xmFrameWidgetClass, _w,
     XmNleftPosition, 2,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 14,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  label_main = XtVaCreateManagedWidget
    ("label_main",
     xmLabelWidgetClass, frame_main,
     XmNlabelString, xmstr,
     NULL);

  rc1 = XtVaCreateManagedWidget 
    ("rc1",
     xmRowColumnWidgetClass, _w,
     XmNorientation, XmVERTICAL,
     XmNleftPosition, 82,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 80,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  label_name = XtVaCreateManagedWidget
    ("label_name",
     xmLabelWidgetClass, _w,
     XmNleftPosition, 16,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 24,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_name,
     NULL);


  text_name = XtVaCreateManagedWidget
    ("text_name",
     xmTextWidgetClass, _w,
     XmNleftPosition, 24,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 43,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XmTextSetString(text_name, "q"); // default

  XtAddCallback (label_name, XmNhelpCallback, genhelpCallback, text_name);
  XtAddCallback (text_name, XmNhelpCallback, genhelpCallback, text_name);

  label_type = XtVaCreateManagedWidget
    ("label_type",
     xmLabelWidgetClass, _w,
     XmNleftPosition, 43,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 51,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_type,
     NULL);

  text_type = XtVaCreateManagedWidget
    ("text_type",
     xmTextWidgetClass, _w,
     XmNleftPosition, 51,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 65,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 4,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 15,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);


  XtAddCallback (label_type, XmNhelpCallback, genhelpCallback, text_type);
  XtAddCallback (text_type, XmNhelpCallback, genhelpCallback, text_type);

  label_desc = XtVaCreateManagedWidget
    ("label_desc",
     xmLabelWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 15,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 17,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 40,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_desc,
     NULL);

  text_desc = XtVaCreateManagedWidget
    ("text_desc",
     xmTextWidgetClass, _w,
     XmNwordWrap, True,
     XmNleftPosition, 15,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 80,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 17,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 40,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNeditMode, XmMULTI_LINE_EDIT,
     NULL);

  XtAddCallback (label_desc, XmNhelpCallback, genhelpCallback, text_desc);
  XtAddCallback (text_desc, XmNhelpCallback, genhelpCallback, text_desc);

  label_evol = XtVaCreateManagedWidget
    ("label_evol",
     xmLabelWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightPosition, 15,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 42,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 75,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNlabelString, xmstr_evol,
     NULL);

  text_evol = XtVaCreateManagedWidget
    ("text_evol",
     xmTextWidgetClass, _w,
     XmNwordWrap, True,
     XmNleftPosition, 15,
     XmNleftAttachment, XmATTACH_POSITION,
     XmNrightPosition, 80,
     XmNrightAttachment, XmATTACH_POSITION,
     XmNtopPosition, 42,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 75,
     XmNbottomAttachment, XmATTACH_POSITION,
     XmNeditMode, XmMULTI_LINE_EDIT,
     NULL);

  XtAddCallback (label_evol, XmNhelpCallback, genhelpCallback, text_evol);
  XtAddCallback (text_evol, XmNhelpCallback, genhelpCallback, text_evol);


  message_frame = XtVaCreateManagedWidget
    ("message_frame",
     xmFrameWidgetClass, _w,
     XmNleftAttachment, XmATTACH_FORM,
     XmNrightAttachment, XmATTACH_FORM,
     XmNtopPosition, 80,
     XmNtopAttachment, XmATTACH_POSITION,
     XmNbottomPosition, 95,
     XmNbottomAttachment, XmATTACH_POSITION,
     NULL);

  XtAddCallback (message_frame, XmNhelpCallback, genhelpCallback, message_frame);

  messages = new messagelabel(message_frame, "messages", "(messages)");
  messages->manage();

  button_varcheck = new varcheckControl(rc1, toplevel, &text_name, &text_type, &text_desc, &text_evol, &label_desc, &label_evol, "button_varcheck", "check", &messages, evolfile, descfile);
  button_varcheck->manage();


  XmStringFree(xmstr);
  XmStringFree(xmstr_name);
  XmStringFree(xmstr_desc);
  XmStringFree(xmstr_evol);

  XtAddCallback(_w, XmNhelpCallback,
		&varControl::helpCallback,
		(XtPointer) this);

}

void varControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  varControl *obj = (varControl *) client_data;
  obj->help();
};

void varControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "var_area", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), &messages, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on the variable interface", vardesc);

}


void varControl::genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data){
  varControl *obj = (varControl *) client_data;
  obj->genhelp(widget, client_data, call_data);
};

void varControl::clearall(char *defvar){
  XmTextSetString(text_name, defvar);
  XmTextSetString(text_type, "");
  XmTextSetString(text_desc, "");
  XmTextSetString(text_evol, "");
  messages->setmessage("");
}


void varControl::genhelp(Widget widget, XtPointer client_data, XtPointer call_data){
  Widget Helpdialog;
  char vardesc[3000];
  char title[100];
  int l;

  Widget *tempw = (Widget *) client_data;

  if (!XtName(*tempw)){
    fprintf(stderr, "no widget name\n");
    return;
  }

  // what is help being requested for?
  if(strcmp(XtName(*tempw), "text_name") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "var_text_name", vardesc, 3000);
    strcpy(title, "Variable name"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_type") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "var_text_type", vardesc, 3000);
    strcpy(title, "Static or dynamic evolution"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_desc") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "var_text_description", vardesc, 3000);
    strcpy(title, "Information on the variable"); // safe
  }
  else if(strcmp(XtName(*tempw), "text_evol") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "var_text_evolution", vardesc, 3000);
    strcpy(title, "Evolution of the variable"); // safe
  }
  else if(strcmp(XtName(*tempw), "message_frame") == 0){
    l=getdesc("helpfiles/GUI_WID_HELP", "paramvar_label_area", vardesc, 3000);
    strcpy(title, "Basic output"); // safe
  }


  if(l<0){
    fprintf(stderr, "No help could be found for this area.\n");
    return;
  }

  Helpdialog = PostHelpDialog(widget, title, vardesc);

}



//
//
// varcheckControl
//
//


void varcheckControl::varcheckCallback(Widget, XtPointer clientdata, XtPointer){
  varcheckControl *obj = (varcheckControl *) clientdata;
  obj->varcheck();
};


void varcheckControl::select(char inputstr[])
{
  Widget dialog;
  XmString t, *str;
  int i=0, l;
  int totlines=0;
  char **lines;
  char systemcom[200];
  char othertype[100];

  Widget errdialog;
  Arg args[5];
  int n=0;
  XmString titlestring;

  char makecom[50];

  if(getoption("userfiles/gen_options", "MAKE", makecom, 50)!=0){
    errdialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return;
  }

  TOC(True, toplevel);

  snprintf(systemcom, 200, "%s sysfiles/alldescs.dat", makecom);
  l=system(systemcom);
  if(l!=0){
    errdialog = PostErrorDialog(_w, label, "description file could not be made - see terminal for details...");
    TOC(False, toplevel);
    return;
  }

  totlines = orderlines(inputstr, "VARIABLE TEMP REACTION", "sysfiles/alldescs.dat", &lines, othertype, 100);

  if(totlines==0){
    if(isonlyspace(othertype))
      errdialog = PostErrorDialog(_w, label, "Variable not found. No possibilities found");
    else{
      if(strstr(othertype, "PARAM") !=NULL)
	errdialog = PostErrorDialog(_w, label, "Variable not found. There is a parameter by this name");
      else if(strstr(othertype, "PROCESS") !=NULL)
	errdialog = PostErrorDialog(_w, label, "Variable not found. There is a process by this name");
      else
	errdialog = PostErrorDialog(_w, label, "Variable not found. No possibilities found");
    }
    TOC(False, toplevel);
    return;
  }


  str = (XmString *) XtMalloc (totlines*sizeof (XmString));
  t = XmStringCreateLocalized ("Variable not found. Possibilities listed:");
  for (i=0; i < totlines; i++)
    str[i] = XmStringCreateLocalized (lines[i]);

  XtSetArg(args[n], XmNautoUnmanage, False); n++;
  dialog = XmCreateSelectionDialog (_w, "selection", args, n);

  telluser(label, "Select a variable");
  titlestring = XmStringCreateLocalized("Search");
  XtVaSetValues (dialog,
		 XmNlistLabelString, t,
		 XmNlistItems,       str,
		 XmNlistItemCount,   totlines,
		 XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL,
		 XmNdialogTitle,     titlestring,
		 XmNmustMatch,       True,
		 NULL);

  XmStringFree(titlestring);

  //  XtSetSensitive (XmSelectionBoxGetChild (dialog, XmDIALOG_HELP_BUTTON), False);
  XtSetSensitive (XmSelectionBoxGetChild (dialog, XmDIALOG_APPLY_BUTTON), False);
  XtAddCallback(dialog, XmNokCallback, dialog_callback, (XtPointer) this);
  XtAddCallback(dialog, XmNnoMatchCallback, dialog_callback, (XtPointer) this);
  XtAddCallback(dialog, XmNhelpCallback, dialog_callback, XtPointer (this));
  XtAddCallback(dialog, XmNcancelCallback, DestWidget, XtPointer (this));

  XmStringFree (t);
  while (--i >= 0)
    XmStringFree (str[i]);
  freearraydat(lines, totlines);

  XtManageChild (dialog);
  TOC(False, toplevel);
  XtPopup (XtParent (dialog), XtGrabNone);
}

void varcheckControl::dlg(Widget widget, XtPointer client_data, XtPointer call_data)
{
  char varname[100];
  char varname1[100];
  char msg[256], prompt[100], *value;
  int dialog_type;
  Widget Helpdialog;
  char vardesc[1000];
  int i, l;
  XmSelectionBoxCallbackStruct *cbs = 
    (XmSelectionBoxCallbackStruct *) call_data;

  switch (cbs->reason) {
  case XmCR_HELP:
    l=getdesc("helpfiles/GUI_WID_HELP", "varcheck_dialog_helpbutton", vardesc, 1000);
    if(l<0){
      Helpdialog = PostErrorDialog(widget, label, "ERROR in getting help: see terminal for details");
      return;
    }
    Helpdialog = PostHelpDialog(widget, "Help on finding a variable", vardesc);
    return;
  case XmCR_OK:
      strcpy(prompt, "Selection: "); // safe
      dialog_type = XmDIALOG_MESSAGE;
      break;
    case XmCR_NO_MATCH:
      strcpy(prompt, "Not a valid selection: "); // safe
      dialog_type = XmDIALOG_ERROR;
      break;
    default:
      strcpy(prompt, "Unknown selection: "); // safe
      dialog_type = XmDIALOG_ERROR;
      break;
  }

  XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);
  snprintf (msg, 256, "%s%s", prompt, value);

  if(dialog_type != XmDIALOG_MESSAGE)
    (void) PostDialog (XtParent(XtParent (widget)), dialog_type, msg);

  if (cbs->reason != XmCR_NO_MATCH) {
    XtPopdown (XtParent (widget));
    XtDestroyWidget (widget); 
    getnthword(value, varname1, 100, 1);
    if(isonlyspace(varname1)){
      telluser(label, "Nothing selected. Try again");
    }
    else {
      i=0;while(value[i] && value[i] != ':'){i++;}// get past the type 
      getnthword(value + i, varname, 100, 1);
      XmTextSetString(*vartext, varname);
      XtFree(value);
      varcheck();
      return;
    }
  }

  XtFree (value);
}


void varcheckControl::dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data){
  varcheckControl *obj = (varcheckControl *) client_data;
  obj->dlg(widget, client_data, call_data);
};


void varcheckControl::varcheck()
{
  char varname[100];
  char vardesc[2000];
  char buf[2000];
  int l, len, flag;
  char oneline[2000];
  int lim=2000;
  char varname1[100];
  XmString xmstr;
  FILE *fd;
  Widget dialog;
  char systemcom[100];
  char makecom[50];

  if(getoption("userfiles/gen_options", "MAKE", makecom, 50)!=0){
    dialog = PostErrorDialog(_w, label, "ERROR with getting an option: see terminal for details");
    return;
  }

  strncpy(varname, XmTextGetString(*vartext), 49);

  xmstr = XmStringCreateSimple("description");
  XtVaSetValues (*descl, XmNlabelString, xmstr, NULL);
  XmUpdateDisplay(_w);
  XmStringFree(xmstr);

  xmstr = XmStringCreateSimple("evolution");
  XtVaSetValues (*evoll, XmNlabelString, xmstr, NULL);
  XmUpdateDisplay(_w);
  XmStringFree(xmstr);


  TOC(True, toplevel);

  snprintf(systemcom, 100, "%s sysfiles/varbles.dat", makecom);
  l=system(systemcom);
  if(l!=0){
    dialog = PostErrorDialog(_w, label, "file sysfiles/varbles.dat could not be made (see terminal for details)");
    TOC(False, toplevel);
    return;
  }

  snprintf(systemcom, 100, "%s sysfiles/tempvars.dat", makecom);
  l=system(systemcom);
  if(l!=0){
    dialog = PostErrorDialog(_w, label, "file sysfiles/tempvars.dat could not be made (see terminal for details)");
    TOC(False, toplevel);
    return;
  }

  snprintf(systemcom, 100, "%s %s", makecom, descfile);
  l=system(systemcom);
  if(l!=0){
    snprintf(systemcom, 100, "File %s could not be made (see terminal for details)", descfile); 
    dialog = PostErrorDialog(_w, label, systemcom);
    TOC(False, toplevel);
    return;
  }

  snprintf(systemcom, 100, "%s %s", makecom, evolfile);
  l=system(systemcom);
  if(l!=0){
    snprintf(systemcom, 100, "File %s could not be made (see terminal for details)", evolfile); 
    dialog = PostErrorDialog(_w, label, systemcom);
    TOC(False, toplevel);
    return;
  }

  snprintf(systemcom, 100, "%s sysfiles/alltempstrs.dat", makecom);
  l=system(systemcom);
  if(l!=0){
    snprintf(systemcom, 100, "File sysfiles/alltempstrs.dat could not be made (see terminal for details)"); 
    dialog = PostErrorDialog(_w, label, systemcom);
    TOC(False, toplevel);
    return;
  }


  TOC(False, toplevel);

  fd=fopen("sysfiles/varbles.dat", "r");
  if(fd==NULL){
    snprintf(systemcom, 100, "File \"sysfiles/varbles.dat\" could not be opened");
    dialog = PostErrorDialog(_w, label, systemcom);
    return;
  }


  if(strcmp(varname, "") != 0){
    while((len = getline(fd, oneline, lim)) > 0){
      flag=0;
      if(!iscom(oneline)){
	getnthword(oneline, varname1, 100, 1);
	if(strcmp(varname, varname1)==0){
	  flag=1;
	  break;
	}  
      }
    }

    fclose(fd);

    if(flag==0){ // not found in sysfiles/varbles.dat - check if a temporary variable
      fd=fopen("sysfiles/alltempstrs.dat", "r");
      if(fd==NULL){
	snprintf(systemcom, 100, "File \"sysfiles/alltempstrs.dat\" could not be opened");
	dialog = PostErrorDialog(_w, label, systemcom);
	return;
      }

      while((len = getline(fd, oneline, lim)) > 0){
	if(!iscom(oneline)){
	  getnthword(oneline, varname1, 100, 1);
	  if(strcmp(varname, varname1)==0){
	    flag=2;
	    break;
	  }   
	}
      }

      fclose(fd);
    }

  }

  if(strcmp(varname, "") == 0 || flag==0){
    xmstr = XmStringCreateSimple("possibilities");
    XtVaSetValues (*descl, XmNlabelString, xmstr, NULL);
    XmUpdateDisplay(_w);
    XmStringFree(xmstr);
    XmTextSetString(*typetext, "");
    XmTextSetString(*evoltext, "");
    XmTextSetString(*desctext, "");
    select(varname);
    return;
  }


  getdesc(descfile, varname, vardesc, 2000);
  if((strcmp(vardesc, "") == 0) && (strstr(varname, "T_") != NULL)){
    snprintf(vardesc, 2000, "rate term for the reaction \"%s\"", varname+2);
  }
  XmTextSetString(*desctext, vardesc);
  getdesc(evolfile, varname, buf, 2000);
  if(buf[0]==0){
    getrestfromfile("sysfiles/alltempstrs.dat", varname, buf, 2000);
  }
  XmTextSetString(*evoltext, buf);
  getnthword(buf, oneline, lim, 1);
  snprintf(systemcom, 100, "D%s", varname);
  if(strcmp(oneline, systemcom) == 0)
    XmTextSetString(*typetext, "dynamic");
  else if (flag==1)
    XmTextSetString(*typetext, "static");
  else if (flag==2)
    XmTextSetString(*typetext, "static (temp)");
  else
    XmTextSetString(*typetext, "");

  telluser(label, "Description and evolution displayed...");

}


void varcheckControl::helpCallback(Widget, XtPointer client_data, XtPointer){
  varcheckControl *obj = (varcheckControl *) client_data;
  obj->help();
};

void varcheckControl::help(){
  Widget Helpdialog;
  char vardesc[1000];
  int l;

  l=getdesc("helpfiles/GUI_WID_HELP", "var_check_button", vardesc, 1000);
  if(l<0){
    Helpdialog = PostErrorDialog(XtParent(_w), label, "ERROR in getting help: see terminal for details");
    return;
  }
  Helpdialog = PostHelpDialog(_w, "Help on checking a variable", vardesc);

}



varcheckControl::varcheckControl(Widget parent, Widget *toplevel1, Widget *vart, Widget *typet, Widget *desct, Widget *evolt, Widget *desclabel, Widget *evollabel, char *name, char *display, messagelabel **label1, char *evolfilename, char *descfilename): BasicComponent (name){
  vartext = vart;
  typetext = typet;
  desctext = desct;
  evoltext = evolt;
  descl = desclabel;
  evoll = evollabel;
  label = label1; // set pointer to the correct label
  toplevel = toplevel1;

  evolfile = evolfilename;
  descfile = descfilename;


  // Set what to display on the button

  XmString xmstr;
  xmstr = XmStringCreateSimple(display);

  // Create the button

  _w = XtVaCreateWidget
    (_name, 
     xmPushButtonWidgetClass, parent,
     XmNlabelString, xmstr,
     XmNmarginWidth, 10,
     XmNmarginHeight, 8,
     NULL);

  XmStringFree (xmstr); 

  XtAddCallback(_w, XmNactivateCallback,
		&varcheckControl::varcheckCallback,
		(XtPointer) this);

  XtAddCallback(_w, XmNhelpCallback,
		&varcheckControl::helpCallback,
		(XtPointer) this);
}; // end of constructor



