/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */


//
//
// varcheckControl
//
//

class varcheckControl: public BasicComponent{

 protected:

  messagelabel **label; // a pointer to the label to be set
  Widget *vartext; //pointer to the text field holding the variable
  Widget *typetext;
  Widget *desctext;
  Widget *evoltext;
  Widget *descl, *evoll;
  Widget *toplevel;

  char *evolfile;
  char *descfile;


 public:
  varcheckControl(Widget parent, Widget *toplevel1, Widget *vart, Widget *typet, Widget *desct, Widget *evolt, Widget *desclabel, Widget *evollabel, char *name, char *display, messagelabel **label1, char *evolfilename, char *descfilename);

  void select(char inputstr[]);
  void dlg(Widget widget, XtPointer client_data, XtPointer call_data);

  static void varcheckCallback(Widget, XtPointer clientdata, XtPointer);
  static void dialog_callback(Widget widget, XtPointer client_data, XtPointer call_data);

  void varcheck();

  static void helpCallback(Widget widget, XtPointer clientdata, XtPointer call_data);

  void help();


};


//
//
// The main one: varControl
//
//




class varControl: public BasicComponent{

  XtAppContext *app1;
  Widget *toplevel;

 public:

  Widget rc1, 
    frame_main,
    label_main, message_frame,
    label_name, text_name,
    label_desc, text_desc,
    label_evol, text_evol,
    label_type, text_type;
  Widget separator1;
  Widget *text_mod;

  varcheckControl *button_varcheck;

  int varsmanaged;
  messagelabel *messages;

  // constructor

  static void genhelpCallback(Widget widget, XtPointer client_data, XtPointer call_data);

  void genhelp(Widget widget, XtPointer client_data, XtPointer call_data);

  static void helpCallback(Widget widget, XtPointer clientdata, XtPointer call_data);

  void help();

  void clearall(char *defvar);

  varControl(Widget parent, Widget *toplevel1, Widget *text_modname, char *name, char display[], char *descfile, char *evolfile, XtAppContext *app);



};

