/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "common/stringmanip.h"

int main()
{
  FILE *fd, *fd1, *fd2, *fd3, *fd4, *fd5;
  char line[5000];
  char oneline[5000];
  char twoline[5000];
  char oneword[100];
  int found, len, fnd1;
  char *loc;
  char *ltxname=NULL;
  char *vn;

  // The file to output

  fd4 = fopen("sysfiles/alldescs.dat", "w");
  if(fd4 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/alldescs.dat\" could not be opened for writing.\n");
    return -1;
  }

  fd5 = fopen("sysfiles/ltxnames.dat", "w");
  if(fd5 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/ltxnames.dat\" could not be opened for writing.\n");
    return -1;
  }


  //
  // The variables
  //

  fd1 = fopen("sysfiles/varbles.dat", "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/varbles.dat\" could not be opened for reading.\n");
    fclose(fd4);
    return -1;
  }


  while((len = getline(fd1, line, 5000)) > 0){
    if(!(iscomsep(line))){
      getnthword(line, oneword, 100, 1);
      fd3 = fopen("sysfiles/temp/vars.desc", "r");
      if(fd3 == NULL){
	fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/temp/vars.desc\" could not be opened for reading.\n");
	return -1;
      }

      found=0;
      while((len = getline(fd3, oneline, 5000)) > 0){
	vn=lrtrim(oneline);
	if(!(iscomsep(oneline)) && (strcmp(oneword, vn) == 0)){
	  found=1;fnd1=0;
	  getline(fd3, oneline, 5000);
	  while((len = getline(fd3, twoline, 5000)) > 0 && !strstr(twoline, "****")){
	    if(strstr(twoline, "latex:")){
	      ltxname = getrst("latex:", twoline);
	      if(!isonlyspace(ltxname)){
		fprintf(fd5, "%s\t%s\n", oneword, ltxname);
		fnd1=1;
	      }
	      free(ltxname);
	      break;
	    }
	  }
	  if(fnd1==0){
	    ltxname = ltx(oneword);
	    fprintf(fd5, "%s\t%s\n", oneword, ltxname);
	    free(ltxname);
	  }
	  break;
        }
	free(vn);
      }
      loc = getvalfromfile("sysfiles/varloc.dat", oneword);
      if(found == 0)
        fprintf(fd4, "VARIABLE: %s: [in %s] \n", oneword, loc);
      else
        fprintf(fd4, "VARIABLE: %s: [in %s] %s", oneword, loc, oneline);
      free(loc);
      fclose(fd3);
    }

  }
  fclose(fd1);

  // The temporary variables and parameters

  fd1 = fopen("sysfiles/tempvars.dat", "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/tempvars.dat\" could not be opened for reading.\n");
    return -1;
  }


  while((len = getline(fd1, line, 5000)) > 0){
    if(!(iscomsep(line))){
      getnthword(line, oneword, 100, 1);

      fd3 = fopen("sysfiles/temp/vars.desc", "r");
      if(fd3 == NULL){
	fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/temp/vars.desc\" could not be opened for reading.\n");
	return -1;
      }

      found=0;
      while((len = getline(fd3, oneline, 5000)) > 0){
	vn=lrtrim(oneline);
	if(!(iscomsep(oneline)) && (strcmp(oneword, vn) == 0)){
	  found=1;fnd1=0;
	  getline(fd3, oneline, 5000);
	  while((len = getline(fd3, twoline, 5000)) > 0 && !strstr(twoline, "****")){
	    if(strstr(twoline, "latex:")){
	      ltxname = getrst("latex:", twoline);
	      if(!isonlyspace(ltxname)){
		fprintf(fd5, "%s\t%s\n", oneword, ltxname);
		fnd1=1;
	      }
	      free(ltxname);
	      break;
	    }
	  }
	  if(fnd1==0){
	    ltxname = transltx(oneword);
	    fprintf(fd5, "%s\t%s\n", oneword, ltxname);
	    free(ltxname);
	  }
	  break;
        }
	free(vn);
      }
      fclose(fd3);
      if(found == 0){
        fd3 = fopen("sysfiles/temp/params.desc", "r");
        if(fd3 == NULL){
	  fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/temp/params.desc\" could not be opened for reading.\n");
	  return -1;
        }
        while((len = getline(fd3, oneline, 5000)) > 0){
	  vn=lrtrim(oneline);
	  if(!(iscomsep(oneline)) && (strcmp(oneword, vn) == 0)){
	    found=1;fnd1=0;
	    getline(fd3, oneline, 5000);
	    while((len = getline(fd3, twoline, 5000)) > 0 && !strstr(twoline, "****")){
	      if(strstr(twoline, "latex:")){
		ltxname = getrst("latex:", twoline);
		if(!isonlyspace(ltxname)){
		  fprintf(fd5, "%s\t%s\n", oneword, ltxname);
		  fnd1=1;
		}
		free(ltxname);
		break;
	      }
	    }
	    if(fnd1==0){
	      ltxname = ltx(oneword);
	      fprintf(fd5, "%s\t%s\n", oneword, ltxname);
	      free(ltxname);
	    }
	    break;
          }
	  free(vn);
        }
        fclose(fd3);

      }

      loc = getvalfromfile("sysfiles/varloc.dat", oneword);
      if(found == 0)
        fprintf(fd4, "TEMP VARIABLE: %s: [in %s] \n", oneword, loc);
      else
        fprintf(fd4, "TEMP VARIABLE: %s: [in %s] %s", oneword, loc, oneline);
      free(loc);
    }

  }
  fclose(fd1);



  // The parameters

  fd = fopen("sysfiles/params.dat", "r");
  if(fd == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/params.dat\" could not be opened for reading.\n");
    return -1;
  }


  while((len = getline(fd, line, 5000)) > 0){
    if(!(iscomsep(line))){
      getnthword(line, oneword, 100, 1);

      fd2 = fopen("sysfiles/temp/params.desc", "r");
      if(fd2 == NULL){
        fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/temp/params.desc\" could not be opened for reading.\n");
        return -1;
      }

      found=0;
      while((len = getline(fd2, oneline, 5000)) > 0){
	vn=lrtrim(oneline);
	if(!(iscomsep(oneline)) && (strcmp(oneword, vn) == 0)){
	  found=1;fnd1=0;
	  getline(fd2, oneline, 5000);
	  while((len = getline(fd2, twoline, 5000)) > 0 && !strstr(twoline, "****")){
	    if(strstr(twoline, "latex:")){
	      ltxname = getrst("latex:", twoline);
	      if(!isonlyspace(ltxname)){
		fprintf(fd5, "%s\t%s\n", oneword, ltxname);
		fnd1=1;
	      }
	      free(ltxname);
	      break;
	    }
	  }
	  if(fnd1==0){
	    ltxname = ltx(oneword);
	    fprintf(fd5, "%s\t%s\n", oneword, ltxname);
	    free(ltxname);
	  }
	  break;
        }
	free(vn);
      }

      loc = getvalfromfile("sysfiles/varloc.dat", oneword);
      if(found == 0)
        fprintf(fd4, "PARAM: %s: [in %s] \n", oneword, loc);
      else
        fprintf(fd4, "PARAM: %s: [in %s] %s", oneword, loc, oneline);
      free(loc);

      fclose(fd2);
    }
  }
  fclose(fd);
  fclose(fd5);


  //
  // The processes
  //

  fd1 = fopen("sysfiles/allprocs.dat", "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/allprocs.dat\" could not be opened for reading.\n");
    fclose(fd4);
    return -1;
  }


  while((len = getline(fd1, line, 5000)) > 0){
    if(!(iscomsep(line))){
      getnthword(line, oneword, 100, 1);

      fd3 = fopen("sysfiles/temp/allprocs.desc", "r");
      if(fd3 == NULL){
	fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/temp/allprocs.desc\" could not be opened for reading.\n");
	return -1;
      }

      found=0;
      while((len = getline(fd3, oneline, 5000)) > 0){
	vn=lrtrim(oneline);
	if(!(iscomsep(oneline)) && (strcmp(oneword, vn) == 0)){
	  found=1;
	  getline(fd3, oneline, 5000);
	  break;
        }
	free(vn);
      }

      loc = getvalfromfile("sysfiles/procloc.dat", oneword);
      if(found == 0)
        fprintf(fd4, "PROCESS: %s: [in %s] \n", oneword, loc);
      else
        fprintf(fd4, "PROCESS: %s: [in %s] %s", oneword, loc, oneline);
      free(loc);

      fclose(fd3);
    }

  }
  fclose(fd1);

  //
  // The reaction rates
  //

  fd1 = fopen("sysfiles/reacrates.dat", "r");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in \"makealldescs.c\": File \"sysfiles/reacrates.dat\" could not be opened for reading.\n");
    fclose(fd4);
    return -1;
  }


  while((len = getline(fd1, line, 5000)) > 0){
    if(!(iscomsep(line))){
      getnthword(line, oneword, 100, 1);
      if(strlen(oneword)>2){
        loc = getvalfromfile("sysfiles/procloc.dat", oneword+2);
        if(oneword[0] == 'T' && oneword[1] == '_'){
          fprintf(fd4, "REACTION RATE: %s: [in %s] Rate of the reaction \"%s\"\n", oneword, loc, oneword+2);
        }
	free(loc);
      }

    }

  }
  fclose(fd1);


  fclose(fd4);
  return 0;

}
