/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// temp1.cc
#include <unistd.h> // for getcwd
#include "common/stringmanip.h"

int main(int argc, char **argv)
{
  char dirname[50];
  char *filename = "userfiles/gui_options";
  FILE *fd;
  char **varn=NULL;
  char **varval=NULL;
  int numopts=0;
  int i;
  fd = fopen(filename, "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in \"gui/makeglobalvars.cc\": file %s could not be opened for writing.\n", filename);
    return -1;
  }
  numopts = genarraysdat("userfiles/gui_globalvars", &varn, &varval);
  fprintf(fd, "// global variables used throughout the project\n\n");
  for(i=0;i<numopts;i++){
    fprintf(fd, "%s\t%s\n", varn[i], varval[i]);
  }
  getcwd(dirname, 50);
  fprintf(fd, "WORKDIR\t%s\n", dirname); 
  fclose(fd);
  freearraydat(varn, numopts);
  freearraydat(varval, numopts);
  return 0;
}
