/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// This file generates the relations to be held in a C structure

#include "common/stringmanip.h"

int main()
{
  FILE *fd;
  char *modname;
  char line[1000];
  char *tmp;


  fd = fopen("sysfiles/sysstate/which_model_file", "r");
  if (fd==NULL){
    fprintf(stderr, "ERROR in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_model_file\". Exiting...\n");
    return -1;
  }
  getline(fd, line, 1000);
  modname = getnthblk(line, 1);
  fclose(fd);


  fd = fopen("sysfiles/sysstate/which_moduledir_file", "w");
  if (fd==NULL){
    fprintf(stderr, "WARNING in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_moduledir_file\"\n");
  }
  else{
    fprintf(fd, "models/modules/%s/", modname);
    fclose(fd);
  }



  tmp = getmoddef("userfiles/model_defaults", modname, "modeldesc");
  if(!isonlyspace(tmp) && strcmp(tmp, "models/modeldescs/")!=0){
    fd = fopen("sysfiles/sysstate/which_desc_file", "w");
    if (fd==NULL){
      fprintf(stderr, "WARNING in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_desc_file\"\n");
    }
    else{
      fprintf(fd, "%s", tmp);
      fclose(fd);
    }
  }
  free(tmp);

  tmp = getmoddef("userfiles/model_defaults", modname, "input");
  if(!isonlyspace(tmp) && strcmp(tmp, "models/inputs/")!=0){
    fd = fopen("sysfiles/sysstate/which_input_file", "w");
    if (fd==NULL){
      fprintf(stderr, "WARNING in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_input_file\"\n");
    }
    else{
      fprintf(fd, "%s", tmp);
      fclose(fd);
    }
  }
  free(tmp);

  tmp = getmoddef("userfiles/model_defaults", modname, "pvals");
  if(!isonlyspace(tmp) && strcmp(tmp, "models/pvals/")!=0){
    fd = fopen("sysfiles/sysstate/which_param_file", "w");
    if (fd==NULL){
      fprintf(stderr, "WARNING in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_param_file\"\n");
    }
    else{
      fprintf(fd, "%s", tmp);
      fclose(fd);
    }
  }
  free(tmp);

  tmp = getmoddef("userfiles/model_defaults", modname, "autoinput");
  if(!isonlyspace(tmp) && strcmp(tmp, "models/autoreginputs/")!=0){
    fd = fopen("sysfiles/sysstate/which_autoreginput_file", "w");
    if (fd==NULL){
      fprintf(stderr, "WARNING in makemodel.c: Couldn't open the file: \"sysfiles/sysstate/which_autoreginput_file\"\n");
    }
    else{
      fprintf(fd, "%s", tmp);
      fclose(fd);
    }
  }
  free(tmp);
  free(modname);

  return 0;
}
