
#include "../syssize.h"
#include "../common/stringmanip.h"
#include "../common/nrsimp.h"

int extractrterms(char *vars[], int numvars, struct DE DEarray[], int numDEs, struct algrel algrelarray[], int numalgrels, char *outarray[]);

int main(){
  int i, j, k, l, des, flag;
  FILE *fd, *fd1, *fd2, *fd3;
  char *vecfile = "sys/vecfcnfile.c";
  char *initsfile = "sys/initfcnfile.c";
  int lim_tempword = 500;
  char tempword[500];

  int len;
  int lim = 2000;
  char oneline[2000];

  char *temp;
  char *temp1;
  char *temp2, *temp3;
  char *aux;

  int numDEvars=0;
  char **DEvararray;
  int numaux=0;
  char **auxeqs;
  int numsolvevars=0;
  char **solvevars;
  char **outarray;

  char **vararray;
  int numvars=0;
  char **allparamarray;
  int numallparams=0;

  struct DE allDEs[MAXDE];
  int numDEs;
  struct algrel allalgrels[MAXALG];
  int numalgrels;

  int numcontrolp = 16;
  char *controlp[16] = {"P_a", "gluc_a", "K_a", "pH_a", "BiC_a", "X_a", "X_O1_a", "X_O2_a", "X_O3_a", "X_O4_a", "X_tot", "CY_a", "Y_a", "O2_a", "CO2_a", "X_H_a"};
  char paramdatafile[50];


  strcpy(paramdatafile, "solvedata.dat"); // safe

  // first parse gets numbers

  fd2 = fopen(paramdatafile, "r");
  if(fd2 == NULL){
    fprintf(stderr, "ERROR in makevecfcn.c: file %s could not be opened.\n", paramdatafile);
    return -1;
  }
  while(len = getline(fd2, oneline, lim) > 0){
    if(!iscomsep(oneline)){
      getnthword(oneline, tempword, lim_tempword, 1);
      if(strcmp(tempword, "param") == 0){
	numsolvevars++;
      }
      else if(strcmp(tempword, "DE") == 0){
	numDEvars++;
      }
      else if(strcmp(tempword, "aux") == 0){
	numaux++;
      }
    }
  }
  fclose(fd2);

/*   printf("numsolvevars = %d\n", numsolvevars); */
/*   printf("numDEvars = %d\n", numDEvars); */
/*   printf("numaux = %d\n\n", numaux); */

  DEvararray = charar(0, numDEvars);
  auxeqs = charar(0, numaux);
  solvevars = charar(0, numsolvevars);
  outarray = charar(0, numsolvevars);

  // second parse
  i=j=k=0;

  fd2 = fopen(paramdatafile, "r");
  if(fd2 == NULL){
    fprintf(stderr, "ERROR in makevecfcn.c: file %s could not be opened.\n", paramdatafile);
    return -1;
  }
  while(len = getline(fd2, oneline, lim) > 0){
    if(!iscomsep(oneline)){
      getnthword(oneline, tempword, lim_tempword, 1);
      if(strcmp(tempword, "param") == 0){
	getnthword(oneline, tempword, lim_tempword, 2);
	solvevars[i] = cvector(0, strlen(tempword));
	strcpy(solvevars[i++], tempword);
      }
      else if(strcmp(tempword, "DE") == 0){
	getnthword(oneline, tempword, lim_tempword, 2);
	DEvararray[j] = cvector(0, strlen(tempword));
	strcpy(DEvararray[j++], tempword);
      }
      else if(strcmp(tempword, "aux") == 0){
	aux = getrst("aux:", oneline);
	auxeqs[k] = cvector(0, strlen(aux));
	strcpy(auxeqs[k++], aux);
	free(aux);
      }
    }
  }
  fclose(fd2);


  fd3 = fopen("../../sysfiles/newtonparams.c", "w");
  if(fd3 == NULL){
    fprintf(stderr, "ERROR in makevecfcn.c: file ../sysfiles/newtonparams.c could not be opened.\n");
    return -1;
  }
  fprintf(fd3, "// This file is generated by the file newtonsrc/params/makevecfcn.c \n\n");
  fprintf(fd3, "int numnewtonparams = %d;\n\n", numsolvevars);
  fprintf(fd3, "char *newtonparams[%d] = {", numsolvevars);
  for(l=0;l<numsolvevars-1;l++){
    if (l%3 == 2)
      fprintf(fd3, "\"%s\",\n", solvevars[l]);
    else
      fprintf(fd3, "\"%s\", ", solvevars[l]);
  }
  if(numsolvevars > 0)
    fprintf(fd3, "\"%s\"};\n\n", solvevars[l]);
  else
    fprintf(fd3, "};\n\n");
  fclose(fd3);
/*   printf("solvevars:\n"); */
/*   for(l=0;l<numsolvevars;l++) */
/*     printf("%s\n", solvevars[l]); */
/*   printf("\n"); */
/*   printf("DEs:\n"); */
/*   for(l=0;l<numDEvars;l++) */
/*     printf("%s\t", DEvararray[l]); */
/*   printf("\n"); */
/*   printf("aux:\n"); */
/*   for(l=0;l<numaux;l++) */
/*     printf("%s\n", auxeqs[l]); */
/*   printf("\n"); */

  fd = fopen(vecfile, "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in makevecfcn.c: file %s could not be opened.\n", vecfile);
    return -1;
  }
  fd1 = fopen(initsfile, "w");
  if(fd1 == NULL){
    fprintf(stderr, "ERROR in makevecfcn.c: file %s could not be opened.\n", initsfile);
    return -1;
  }

  vararray = genarraydat("../../sysfiles/vararray.dat", &numvars);
  allparamarray = genarraydat("../../sysfiles/allparams.dat", &numallparams);

  // Read in the DEs and the algrels from the data files

  numDEs = readDEfile(allDEs, MAXDE, "../../sysfiles/allDEs1.dat", "../../sysfiles/vararray.dat", "../../sysfiles/allparams.dat", "../../userfiles/remsfile.dat");
  numalgrels = readalgfile(allalgrels, MAXALG, "../../sysfiles/allalgrels1.dat", "../../sysfiles/vararray.dat", "../../sysfiles/allparams.dat", "../../userfiles/remsfile.dat");


  //
  // First get the set of equations to be solved
  //

  // get the rhs terms from the DEs into outarray
  des = extractrterms(DEvararray, numDEvars, allDEs, numDEs, allalgrels, numalgrels, outarray);
  // get the auxilliary equations into outarray
  for (i=des;i<des + numaux;i++){ 
    outarray[i] = cvector(0, 2000);
    strcpy(outarray[i], auxeqs[i-des]);
    //printf("outarray[%d] = %s\n", i, outarray[i]);
  }

  //
  // now translate them. There is some weirdness here in the 
  // case that the array is empty. Some compilers don't like this!
  //
  
  fprintf(fd, "// This file is generated by the program\n//makevecfcn.c.\n\n");
  fprintf(fd, "int numsolvevars = %d;\n", numsolvevars);
  if (numsolvevars==0)
    fprintf(fd, "char *solvevars[1] = {"); // weirdness
  else{
    fprintf(fd, "char *solvevars[%d] = {", numsolvevars);;
  }
  if (numsolvevars==0)
    fprintf(fd, "\"\"};\n\n");
  else{
    for(i=0;i<numsolvevars-1;i++)
      fprintf(fd, "\"%s\", ", solvevars[i]);
    fprintf(fd, "\"%s\"};\n\n", solvevars[i]);
  }

  fprintf(fd, "void vecfcn(int n, double *x, double *f, double *p){\n");
  for(i=0;i<numsolvevars;i++){// ?
    fprintf(stderr, "outarray[%d] = %s\n", i, outarray[i]);
    // add "n" to the variable names
    temp = transfunc1(outarray[i], "n", vararray, numvars);
    // add "n" to the names of control parameters only if we are dealing with a DE
    if(i<des)
      temp1 = transfunc1(temp, "n", controlp, numcontrolp);
    else temp1 = strdup(temp);;
    // replace the solvevars with x values
    fprintf(stderr, "%s\n", temp1);
    temp2 = transalt1(temp1, "x", solvevars, numsolvevars);
    fprintf(stderr, "%s\n", temp2);
    //translate the rest using the paramfile
    temp3 = transalt1(temp2, "p", allparamarray, numallparams);
    fprintf(stderr, "%s\n", temp3);
    fprintf(fd, "  f[%d] = %s;\n", i, temp3);
    free(temp);free(temp1);free(temp2);free(temp3);
  }
  fprintf(fd, "}\n");

  // the initial conditions
  fprintf(fd1, "// This file is generated by the program\n//makevecfcn.c.\n\n");

  for(i=0;i<numsolvevars;i++){
    flag = isinarray(allparamarray, numallparams, solvevars[i]);
    if (flag >= 0)
      fprintf(fd1, "x[%d] = p[%d];\n", i,  flag);
    else
      fprintf(stderr, "The variable %s does not seem to exist in the datafile \"sysfiles/allparamarray.c\"\n", solvevars[i]);
  }
  fclose(fd);
  fclose(fd1);

  freearraydat(vararray, numvars);
  freearraydat(allparamarray, numallparams);
  free_algarray(allalgrels, numalgrels);
  free_DEarray(allDEs, numDEs);

  return 0;
}



