// The inputs to this function are an existing vecfcn 
// using a set of parameters and an existing set of parameters
// if newtonupdate.o is ever used then there has to be linking to the newton library for fdjac, mnewt, etc.

#include <stdio.h>
#include <math.h>
#include "../common/stringmanip.h"
#include "../common/nrsimp.h"


double heavi(double s);
#include "sys/vecfcnfile.c" // includes solvevars and the vecfcn

void fdjac(int n, double x[], double fvec[], double **df, double *otherparams, void (*vecfunc)(int, double [], double [], double []));
void usrfun(double *x, int n, double *fvec, double **fjac, double *otherparams)
{
    vecfcn(n, x, fvec, otherparams);
    fdjac(n, x, fvec, fjac, otherparams, vecfcn);
}
void mnewt(int ntrial, double x[], int n, double tolx, double tolf, double *otherparams, void (*usrfcn)(double *, int, double *, double **, double *)); // in the library


int newtonupdate(char *paramarray[], int numparams, double *rpar){
  int i;
  double *x;
  double tolx = 0.000001;
  double tolf = 0.000001;

  FILE *fd;
  char *outputfile = "sysfiles/solve_params.dat";

  double *p;

  p = dvector(0, numparams-1);
  // put the parameter values into the array p
  for(i=0;i<numparams;i++)
    p[i] = rpar[i];

  x = dvector(0, numsolvevars-1);

  // initialise x using the plist
#include "sys/initfcnfile.c"
  // solve for x
  mnewt(10, x, numsolvevars, tolx, tolf, p, usrfun);

  // print out the solved values
  fd = fopen(outputfile, "w");
  if(fd == NULL){
    fprintf(stderr, "ERROR in newtonupdate: File: %s could not be opened...\n", outputfile);
    return -1;
  }
  for(i=0;i<numsolvevars;i++)
    fprintf(fd, "%s\t%.6e\n", solvevars[i], x[i]);
  fclose(fd);

  overrideparamsfromfile(outputfile, paramarray, numparams, rpar);
  free_dvector(x, 0, numsolvevars-1);
  free_dvector(p, 0, numparams-1);
  return 0;
}


