#include "../common/stringmanip.h"
#include "../common/nrsimp.h"

int extractrterms(char *vars[], int numvars, struct DE DEarray[], int numDEs, struct algrel algrelarray[], int numalgrels, char *outarray[])
{
  int i, j, k=0, found;
  // extract the right hand sides of DEs/algrels from a set of DEs/alrels, based on the key variables. outarray has to be at least the size of numvars. memory is allocated in the routine
  for (i=0;i<numvars;i++){
    found = 0;
    for(j=0;j<numDEs;j++){
      if (strcmp(vars[i], DEarray[j].keyvar) == 0){
	found = 1;
	outarray[k] = cvector(0, strlen(DEarray[j].rterm));
	strcpy(outarray[k], DEarray[j].rterm);
	k++;
	break;
      }
    }
    if(found == 0){
      for(j=0;j<numalgrels;j++){
        if (strcmp(vars[i], algrelarray[j].keyvar) == 0){
	  found = 1;
	  outarray[k] = cvector(0, strlen(algrelarray[j].rterm));
	  strcpy(outarray[k], algrelarray[j].rterm);
	  k++;
	  break;
        }
      }
    }
    if(found == 0){
      fprintf(stderr, "ERROR in routine extractrterms: variable %s does not exist.\n", vars[i]);
      strcpy(outarray[k++], "");
    }
  }
  return k; // free position in outarray

}
