#include "../src/common/stringmanip.h"
#include "../src/common/nrsimp.h"

#define max(A, B) ((A) > (B) ? (A) : (B))
#define min(A, B) ((A) < (B) ? (A) : (B))

// there are lots of external declarations because solmat has to take the arguments specified by RADAU.

void solmat0()
{
  int i;
  extern char **matvars;
  extern int nummatvars;
  extern int *ord;
  extern int numvars;
  extern char **vararray;
  extern FILE *brf;
  extern char **qvars;
  extern int numqvars;

  printf("#time");
  for (i=0;i < nummatvars; i++){
    ord[i] = isinarray(vararray, numvars, matvars[i]);
    printf("\t %s", matvars[i]);
  }
  printf("\n");

  if(brf){
    fprintf(brf, "#time");
    for (i=0;i < numqvars; i++)
      fprintf(brf, "\t %s", qvars[i]);
    fprintf(brf, "\n");
  }
}

void solmat(int *nr,double *xold,double *x,
	    double *__y,
	    double *cont,int *lrc,
	    int *n,
	    double *rpar,int *ipar,
	    int *irtrn)
{

  int i, tmp, tmp1;
  extern int numvars;
  extern char **vararray;
  extern int numparams;
  extern char **paramarray;
  extern char **matvars;
  extern int nummatvars;
  extern int *ord;

  extern int numchangeparams;
  extern char *chosen_param[10];
  extern int fixedstep;
  extern double **Pvals;
  extern int kps;
  extern int ktot;
  extern int autoreg;
  extern FILE *brf;
  extern char **qvars;
  extern int numqvars;

  //
  // End of common values
  //

  if ((*x > 0.01) || (*x == 0.0)){
    printf("%.4e", *x);
    for (i=0;i<nummatvars;i++){
      if(ord[i] >= 0)
	printf("\t %.4e", __y[ord[i]]);
      else if(autoreg == 0 && (tmp1 = isinarray(chosen_param, numchangeparams, matvars[i])) >= 0){
	if (fixedstep==1)
	  printf("\t %.4e", Pvals[kps%ktot][tmp1]);
	else
	  printf("\t %.4e", Pvals[kps%ktot][tmp1 + 1]);
      }
      else{
	tmp=isinarray(paramarray, numparams, matvars[i]);
	if(tmp>=0)
	  printf("\t %.4e", rpar[tmp]);
	else
	  printf("\t 0.0000e+00");
      }
    }
    printf("\n");
  }

  // the brief output file

  if(brf){
    if ((*x > 0.01) || (*x == 0.0)){
      fprintf(brf, "%.4e", *x);
      for (i=0;i<numqvars;i++){
        tmp = isinarray(vararray, numvars, qvars[i]);
        if(tmp >= 0)
	  fprintf(brf, "\t %.4e", __y[tmp]);
        else if(autoreg == 0 && (tmp1 = isinarray(chosen_param, numchangeparams, qvars[i])) >= 0){
	  if (fixedstep==1)
	    fprintf(brf, "\t %.4e", Pvals[kps%ktot][tmp1]);
	  else
	    fprintf(brf, "\t %.4e", Pvals[kps%ktot][tmp1 + 1]);
        }
        else{
	  tmp=isinarray(paramarray, numparams, qvars[i]);
	  if(tmp>=0)
	    fprintf(brf, "\t %.4e", rpar[tmp]);
	  else
	    fprintf(brf, "\t 0.0000e+00");
        }
      }
      fprintf(brf, "\n");
      fflush(brf);
    }
  }

}
