/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

#include "common/stringmanip.h"

void pfunc(double *pvals, double *outvals);
void vfunc(double *rpar, double *y);

void setinits1(double *y, double *rpar){
  vfunc(rpar, y);
}

int newtonupdate(char *paramarray[], int numparams, double *rpar); // in newton/newtonupdate.cc


void setval1(char s[], double val, char *paramarray[], int numparams, double *rpar, char *paramfileout, int override, char *setarray[], int numset, double *invals)
  // paramfileout only used for output
{
  int i=0, l;
  double oldval;
  FILE *fd;
  if(!(isonlyspace(s))){ // empty string means do nothing
    if((l = isinarray(setarray, numset, s)) >= 0){ // in array 
      oldval = invals[l];
      invals[l] = val;
      if(fabs(oldval - val) > 0.00001*val) // a real change
	pfunc(invals, rpar);
    }  
  }

  pfunc(invals, rpar);

  if(override==1){
    newtonupdate(paramarray, numparams, rpar);
  }

  fd = fopen(paramfileout, "w");
  if (fd == NULL){
    fprintf(stderr, "ERROR in setval1 in \"paramsetting.cc\": file %s could not be opened.\n", paramfileout);
    return;
  }
  for(i=0;i< numparams;i++){
    fprintf(fd, "%s\t%.4e\n", paramarray[i], rpar[i]);
  }

  fclose(fd);
}


