#include "common/stringmanip.h"
#include "syssize.h"
#define min(A, B) ((A) < (B) ? (A) : (B))

int main(int argc, char *argv[]){
  double inc_size1 = 8.0; // a percentage
  double inc_size2 = 8.0; // a percentage

  FILE *fd;
  int l;
  char *fitparam1 = "r_m2";
  char *fitparam2 = "Vol_blood_frac";
  char systemcom[200];
  double TOIval;
  double TOIsupval;
  double diff1;
  double diff2;
  double diff3;
  double diff4;
  double diffmin;
  double difflast;
  int sign, signold;
  double change;
  char *vname1=NULL;
  double vinit1;
  double vval1;
  double vval1last;
  char *vname2=NULL;
  double vinit2;
  double vval2;  
  double vval2last;
  int itnum;
  char modname[100];
  char inputfile[100]; 
  char paramfile[100];
  int firstchange;
  int itbest;

  if(getoption("ilias_art", "model", modname, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"model\". Exiting.\n");
    return -1;
  }
  if(getoption("ilias_art", "input_file", inputfile, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"input_file\". Exiting.\n");
    return -1;
  }
  if(getoption("ilias_art", "param_file", paramfile, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"param_file\". Exiting.\n");
    return -1;
  }

  snprintf(systemcom, 200, "cat %s > tempfiles/tempinput.dat", inputfile);
  l=system(systemcom);
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
    return -1;
  }

  snprintf(systemcom, 200, "make %s", modname);
  l=system(systemcom);
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make full\"\n");
    return -1;
  }

  fd = fopen("sysfiles/sysstate/which_param_file", "w");
  if(fd==NULL){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"sysfiles/sysstate/which_param_file\" for writing.\n");
    return -1;
  }
  fprintf(fd, "%s", paramfile);
  fclose(fd);

  fd = fopen("sysfiles/sysstate/which_input_file", "w");
  if(fd==NULL){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"sysfiles/sysstate/which_input_file\" for writing.\n");
    return -1;
  }
  fprintf(fd, "%s", inputfile);
  fclose(fd);

  l=system("make");
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make\"\n");
    return -1;
  }

  l=system("make sysfiles/allcurrent_pvals.dat");
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make sysfiles/allcurrent_pvals.dat\"\n");
    return -1;
  }

  vname1 = getcvalfromfile("sysfiles/allcurrent_pvals.dat", fitparam1);
  vinit1 = atof(vname1);
  free(vname1);
  vval1 = vinit1;
  vval1last = vinit1;

  vname2 = getcvalfromfile("sysfiles/allcurrent_pvals.dat", fitparam2);
  vinit2 = atof(vname2);
  free(vname2);
  vval2last = vinit2;

  snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
  l=system(systemcom);

  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
    return -1;
  }

  diff = distaverage("outdat/tempout.dat", 0, 60, "TOI", "TOIsup", 0);
  //  TOIval = timeaverage("outdat/tempout.dat", 0, 60, "TOI");
  //  TOIsupval = timeaverage("outdat/tempout.dat", 0, 60, "TOIsup");
  //  diff = (TOIval-TOIsupval)/TOIsupval;
  diffmin = 2.0*diff;

  fprintf(stderr, "diff = %.4e\n", diff);

  sign = 1;


  // initial run ends...
  // while loop starts

  itnum=0;
  firstchange=0;
  while((itnum < 100) && (fabs((diff - diffmin)/diff)>0.005)){ // half a percent
    itnum++;

    fprintf(stderr, "itnum = %d\n", itnum);
    difflast = diff;
    diffmin = 2.0*diff;


    //////////////// ITERATION 1 //////////////////////

    vval1 = vval1last*(1.0 + inc_size1/100.0);

    fd = fopen(inputfile, "w");
    if(fd==NULL){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"%s\" for writing.\n", inputfile);
      return -1;
    }
    fprintf(fd, "reset: %s, %.4e, %.4e, %s, %.4e, %.4e\n", fitparam1, vinit1, vval1, fitparam2, vinit2, vval2fix);
    fclose(fd);

    fprintf(stderr, "%s = %.4e\t%s = %.4e\n", fitparam1, vval1, fitparam2, vval2fix);

    snprintf(systemcom, 200, "cat tempfiles/tempinput.dat >> %s", inputfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
      return -1;
    }

    snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", inputfile);
      return -1;
    }

    diff1 = distaverage("outdat/tempout.dat", 0, 60, "TOI", "TOIsup", 0);
    fprintf(stderr, "diff1 = %.4e\n", diff1);

    diffmin = diff1;
    itbest = 1;
    vval1tmp = vval1;

    /////////////////////////////

    //////////////// ITERATION 2 //////////////////////

    vval1 = vval1*(1.0 - inc_size1/100.0);

    fd = fopen(inputfile, "w");
    if(fd==NULL){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"%s\" for writing.\n", inputfile);
      return -1;
    }
    fprintf(fd, "reset: %s, %.4e, %.4e, %s, %.4e, %.4e\n", fitparam1, vinit1, vval1, fitparam2, vinit2, vval2fix);
    fclose(fd);

    fprintf(stderr, "%s = %.4e\t%s = %.4e\n", fitparam1, vval1, fitparam2, vval2fix);

    snprintf(systemcom, 200, "cat tempfiles/tempinput.dat >> %s", inputfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
      return -1;
    }

    snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", inputfile);
      return -1;
    }

    diff2 = distaverage("outdat/tempout.dat", 0, 60, "TOI", "TOIsup", 0);
    fprintf(stderr, "diff2 = %.4e\n", diff2);

    if(diff2 < diffmin){
      diffmin = diff2;
      itbest = 2;
      vval1tmp = vval1;
    }

    /////////////////////////////

    //////////////// ITERATION 3 //////////////////////

    vval2 = vval2*(1.0 + inc_size2/100.0);

    fd = fopen(inputfile, "w");
    if(fd==NULL){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"%s\" for writing.\n", inputfile);
      return -1;
    }
    fprintf(fd, "reset: %s, %.4e, %.4e, %s, %.4e, %.4e\n", fitparam1, vinit1, vval1fix, fitparam2, vinit2, vval2);
    fclose(fd);

    fprintf(stderr, "%s = %.4e\t%s = %.4e\n", fitparam1, vval1fix, fitparam2, vval2);

    snprintf(systemcom, 200, "cat tempfiles/tempinput.dat >> %s", inputfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
      return -1;
    }

    snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", inputfile);
      return -1;
    }

    diff3 = distaverage("outdat/tempout.dat", 0, 60, "TOI", "TOIsup", 0);
    fprintf(stderr, "diff3 = %.4e\n", diff3);

    if(diff3 < diffmin){
      diffmin = diff3;
      itbest = 3;
    }

    /////////////////////////////




    if(diffmin > difflast){
      inc_size1/=2.0;
      inc_size2/=2.0;
    }

  }

  fprintf(stderr, "Final values: %s = %.4e\t%s = %.4e\n\n", fitparam1, vval1, fitparam2, vval2);

  return 0;
}
