#include "common/stringmanip.h"
#include "syssize.h"


int main(int argc, char *argv[]){
  double inc_size = 8.0; // a percentage

  FILE *fd;
  int l;
  char *fitparam = "r_m2";
  char systemcom[200];
  double TOIval;
  double TOIsupval;
  double diff;
  int sign, signold;
  double change;
  char *vname = NULL;
  double vinit;
  double vval;
  int itnum;
  char modname[100];
  char inputfile[100]; 
  char paramfile[100];
  int firstchange;

  if(getoption("ilias_art", "model", modname, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"model\". Exiting.\n");
    return -1;
  }
  if(getoption("ilias_art", "input_file", inputfile, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"input_file\". Exiting.\n");
    return -1;
  }
  if(getoption("ilias_art", "param_file", paramfile, 100)!=0){
    fprintf(stderr, "ERROR with getting the option \"param_file\". Exiting.\n");
    return -1;
  }

  snprintf(systemcom, 200, "cat %s > tempfiles/tempinput.dat", inputfile);
  l=system(systemcom);
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
    return -1;
  }

  snprintf(systemcom, 200, "make %s", modname);
  l=system(systemcom);
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make full\"\n");
    return -1;
  }

  fd = fopen("sysfiles/sysstate/which_param_file", "w");
  if(fd==NULL){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"sysfiles/sysstate/which_param_file\" for writing.\n");
    return -1;
  }
  fprintf(fd, "%s", paramfile);
  fclose(fd);

  fd = fopen("sysfiles/sysstate/which_input_file", "w");
  if(fd==NULL){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"sysfiles/sysstate/which_input_file\" for writing.\n");
    return -1;
  }
  fprintf(fd, "%s", inputfile);
  fclose(fd);

  l=system("make");
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make\"\n");
    return -1;
  }

  l=system("make sysfiles/allcurrent_pvals.dat");
  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"make sysfiles/allcurrent_pvals.dat\"\n");
    return -1;
  }

  vname = getcvalfromfile("sysfiles/allcurrent_pvals.dat", fitparam);
  vinit = atof(vname);
  free(vname);
  vval = vinit;

  snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
  l=system(systemcom);

  if(l!=0){
    fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
    return -1;
  }

  TOIval = timeaverage("outdat/tempout.dat", 0, 60, "TOI");
  TOIsupval = timeaverage("outdat/tempout.dat", 0, 60, "TOIsup");
  diff = (TOIval-TOIsupval)/TOIsupval;

  fprintf(stderr, "diff = %.4e\n", diff);

  if (diff>0.0)
    sign = -1;
  else
    sign = 1;

  // initial run ends...
  // while loop starts

  itnum=0;
  firstchange=0;
  while((itnum < 100) && (fabs(diff)>0.005)){ // half a percent
    itnum++;

    fprintf(stderr, "itnum = %d\n", itnum);

    signold = sign;

    change = (double)sign*inc_size/100.0;
    vval = vval*(1.0 + change);

    fd = fopen(inputfile, "w");
    if(fd==NULL){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't open the file \"%s\" for writing.\n", inputfile);
      return -1;
    }
    fprintf(fd, "reset: %s, %.4e, %.4e\n", fitparam, vinit, vval);
    fclose(fd);

    fprintf(stderr, "%s = %.4e\n", fitparam, vval);

    snprintf(systemcom, 200, "cat tempfiles/tempinput.dat >> %s", inputfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", systemcom);
      return -1;
    }

    snprintf(systemcom, 200, "src/lib/P_run %s %s outdat/tempout.dat > outdat/tempout.dat", inputfile, paramfile);
    l=system(systemcom);
    if(l!=0){
      fprintf(stderr, "ERROR in setindparams.c. Couldn't run the command \"%s\"\n", inputfile);
      return -1;
    }

    TOIval = timeaverage("outdat/tempout.dat", 0, 60, "TOI");
    diff = (TOIval-TOIsupval)/TOIsupval;
    fprintf(stderr, "diff = %.4e\n", diff);

    if (diff>0.0)
      sign = -1;
    else
      sign = 1;

    if(firstchange == 1 || (sign != signold && firstchange == 0)){
      firstchange=1;
      inc_size/=2.0;
    }

  }

  fprintf(stderr, "Final values: %s = %.4e\n\n", fitparam, vval);

  return 0;
}
