/* Copyright (C) 2004-2007, Murad Banaji
 *
 * This file is part of BRAINCIRC
 *
 * BRAINCIRC is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2, 
 * or (at your option) any later version.
 *
 * BRAINCIRC is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BRAINCIRC: see the file COPYING.  If not, write to 
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA. 

 * For comments, queries, or bug-reports about BRAINCIRC, please 
 * email braincirc@medphys.ucl.ac.uk

 */

// This is the raw file, not a real C++ file. It is user modified and has comments and all. It is used to generate the computer-read file o2funcs.cc which has no comments, and also has "->getval()" attached as necessary to parameter names. The pre-processing also deals with replacing the R_ terms with the appropriate terms from the ODEs or algrels

// note that it is very important that you don't get circularity in the definition of parameters. This will be checked for during compilation by a text-reading routine, and you can get a false positive unless you:
// avoid putting comments on the same lines as code (to avoid circular dependencies).
// avoid putting printf lines on the same lines as other lines

// the routine to get the value, given a paramstr structure - for the moment we keep this just for the run paramvals

// The generic function names must **not** contain the string "fcn"



/************************** COMMON FUNCTIONS *******************/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>


double setkvals1(double K_eq, double halftime)
{
  return log(2.0)/(halftime*(1.0 + 1.0/K_eq));
}
//////////
double setkvals2(double K_eq, double halftime)
{
  return log(2.0)/(halftime*(1.0 + K_eq));
}
/////////
double setkvals1acid(double K_eq, double halftime, double normdiss)
{
  // here normdiss is the normal H+ concentration
  return log(2.0)/(halftime*(1.0 + normdiss/K_eq));
}
/////////
double setkvals2acid(double K_eq, double halftime, double normdiss)
{
  return log(2.0)/(halftime*(normdiss + K_eq));
}


/***************************** SPECIFIC FUNCTIONS *******************/

///////////

